/* **********************************************************
 *                                                          *
 *  DISSENY I IMPLEMENTACI DUNA BASE DE DADES RELACIONAL  *
 *  PER A UNA EMPRESA DE SELECCI DE PERSONAL               *
 *                                                          *
 *  UOC                                                     *
 *  PROJECTE FINAL DE CARRERA ENGINYERIA EN INFORMATICA     *
 *  ALUMNE:    RUBEN PEREZ DE LA FUENTE                     *
 *  CONSULTOR: JUAN MARTINEZ BOLAOS                        *
 *                                                          *
 ***********************************************************/

/* **********************************************************
 *                CREACI DE LES SEQUENCES
 ***********************************************************/

    /*
       Seqncies necessries per a l'obtenci de la clau primria
       de les diferents taules.
       Degut a que es fan insercions directes sobre la BD, sense
       utilitzar-les, un cop finalitzat cada grup d'insercions
       s'actualitzar la sequence corresponent per tal que no doni
       claus primries repetides i ocasioni errors d'execuci
    */
    CREATE SEQUENCE CATEGORIA_seq
        START WITH 23
        INCREMENT BY 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCACHE
        NOORDER
        NOCYCLE
    /

    CREATE SEQUENCE CONVOCATS_seq
        INCREMENT BY 1
        START WITH 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCACHE
        NOORDER
        NOCYCLE
    /

    CREATE SEQUENCE CURRICULUM_seq
        INCREMENT BY 1
        START WITH 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCACHE
        NOORDER
        NOCYCLE
    /

    CREATE SEQUENCE DEMANDAFEINA_seq
        INCREMENT BY 1
        START WITH 5
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCACHE
        NOORDER
        NOCYCLE
    /

    CREATE SEQUENCE EMPRESA_seq
        INCREMENT BY 1
        START WITH 7
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCACHE
        NOORDER
        NOCYCLE
    /

    CREATE SEQUENCE ENTREVISTA_seq
        INCREMENT BY 1
        START WITH 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE ESPLOG_seq
        INCREMENT BY 1
        START WITH 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE EXPERIENCIACV_seq
        INCREMENT BY 1
        START WITH 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE IDIOMES_seq
        INCREMENT BY 1
        START WITH 64
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE IDIOMESCV_seq
        INCREMENT BY 1
        START WITH 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE IDIOMESOT_seq
        INCREMENT BY 1
        START WITH 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE INTERESSAT_seq
        INCREMENT BY 1
        START WITH 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE NIVELL_seq
        INCREMENT BY 1
        START WITH 5
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE OFERTATREBALL_seq
        INCREMENT BY 1
        START WITH 39
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE PERFIL_seq
        INCREMENT BY 1
        START WITH 42
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE REBUTJATS_seq
        INCREMENT BY 1
        START WITH 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE SOLICITANT_seq
        INCREMENT BY 1
        START WITH 7
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE SUBCATEGORIA_seq
        INCREMENT BY 1
        START WITH 119
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE TIPUSCONTRACTE_seq
        INCREMENT BY 1
        START WITH 15
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE TIPUSJORNADA_seq
        INCREMENT BY 1
        START WITH 7
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE TITULACIO_seq
        INCREMENT BY 1
        START WITH 52
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE TITULACIOCV_seq
        INCREMENT BY 1
        START WITH 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

    CREATE SEQUENCE TITULACIOOT_seq
        INCREMENT BY 1
        START WITH 1
        MINVALUE 1
        MAXVALUE 999999999999999999999999999
        NOCYCLE
        NOORDER
        NOCACHE
    /

/* **********************************************************
 *             DESCRIPCI DEL PAQUET BASIC_PKG
 ***********************************************************/

CREATE OR REPLACE PACKAGE
BASIC_PKG is
    /* Elements generals*/

    /*
       Constants per indicar l'estat de finalitzaci de les operacions
       contra la BD
    */
    SUCCESS     constant    varchar2(20) := 'SUCCESS';
    ERROR       constant    varchar2(20) := 'ERROR';
    WARNING     constant    varchar2(20) := 'WARNING';
    -- Tipus per emmagatzemar el resultat de l'execuci dels procediments
    type xerror_typ is record (
        status      varchar2(50),
        message     varchar2(2000)
    );

    /* Interfcie PL/SQL per a la Taula CATEGORIA*/

    -- Tipus per emmagatzemar un registre de la taula
    type CATEGORIA_typ is record (
        CATCOD   CATEGORIA.CATCOD%type,
        CATDESC  CATEGORIA.CATDESC%type,
        SWBAIXA  CATEGORIA.SWBAIXA%type
    );
    -- Tipus per treballar amb cursors
    type CATEGORIA_ref is ref cursor return CATEGORIA_typ;
    -- Tipus per treballar amb taules de registres
    type CATEGORIA_tab is table of CATEGORIA_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_CATEGORIA return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_CATEGORIA (r in out CATEGORIA_ref, p_CATCOD in number default null, cons in CATEGORIA_typ);
    Procedure Consultar_CATEGORIA (t in out CATEGORIA_tab, p_CATCOD in number default null, cons in CATEGORIA_typ);
    -- Procediments per afegir un o diversos registres a la BD
    Procedure Afegir_CATEGORIA (r in out CATEGORIA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_CATEGORIA (t in out CATEGORIA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_CATEGORIA (p_CATCOD in CATEGORIA.CATCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_CATEGORIA (t in CATEGORIA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_CATEGORIA (r in out CATEGORIA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_CATEGORIA (t in out CATEGORIA_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula CONVOCATS*/

    -- Tipus per emmagatzemar un registre de la taula
    type CONVOCATS_typ is record (
        ENTCOD  CONVOCATS.ENTCOD%type,
        SOLCOD  CONVOCATS.SOLCOD%type
    );
    -- Tipus per treballar amb cursors
    type CONVOCATS_ref is ref cursor return CONVOCATS_typ;
    -- Tipus per treballar amb taules de registres
    type CONVOCATS_tab is table of CONVOCATS_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_CONVOCATS return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_CONVOCATS (r in out CONVOCATS_ref, p_ENTCOD in number default null, cons in CONVOCATS_typ );
    Procedure Consultar_CONVOCATS (t in out CONVOCATS_tab, p_ENTCOD in number default null, cons in CONVOCATS_typ );
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_CONVOCATS (r in out CONVOCATS_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_CONVOCATS (t in out CONVOCATS_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_CONVOCATS (p_ENTCOD in CONVOCATS.ENTCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_CONVOCATS (t in CONVOCATS_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_CONVOCATS (r in out CONVOCATS_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_CONVOCATS (t in out CONVOCATS_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula CURRICULUM*/

    -- Tipus per emmagatzemar un registre de la taula
    type CURRICULUM_typ is record (
        SOLCOD  CURRICULUM.SOLCOD%type
    );
    -- Tipus per treballar amb cursors
    type CURRICULUM_ref is ref cursor return CURRICULUM_typ;
    -- Tipus per treballar amb taules de registres
    type CURRICULUM_tab is table of CURRICULUM_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_CURRICULUM return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_CURRICULUM (r in out CURRICULUM_ref, p_SOLCOD in number default null);
    Procedure Consultar_CURRICULUM (t in out CURRICULUM_tab, p_SOLCOD in number default null);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_CURRICULUM (r in out CURRICULUM_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_CURRICULUM (t in out CURRICULUM_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_CURRICULUM (p_SOLCOD in CURRICULUM.SOLCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_CURRICULUM (t in CURRICULUM_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula DEMANDAFEINA*/

    -- Tipus per emmagatzemar un registre de la taula
    type DEMANDAFEINA_typ is record (
        DEFCOD   DEMANDAFEINA.DEFCOD%type,
        SOLCOD   DEMANDAFEINA.SOLCOD%type,
        PERFCOD  DEMANDAFEINA.PERFCOD%type,
        SCATCOD  DEMANDAFEINA.SCATCOD%type,
        SWBAIXA  DEMANDAFEINA.SWBAIXA%type
    );
    -- Tipus per treballar amb cursors
    type DEMANDAFEINA_ref is ref cursor return DEMANDAFEINA_typ;
    -- Tipus per treballar amb taules de registres
    type DEMANDAFEINA_tab is table of DEMANDAFEINA_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_DEMANDAFEINA return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_DEMANDAFEINA (r in out DEMANDAFEINA_ref, p_DEFCOD in number default null, cons in DEMANDAFEINA_typ);
    Procedure Consultar_DEMANDAFEINA (t in out DEMANDAFEINA_tab, p_DEFCOD in number default null, cons in DEMANDAFEINA_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_DEMANDAFEINA (r in out DEMANDAFEINA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_DEMANDAFEINA (t in out DEMANDAFEINA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_DEMANDAFEINA (p_DEFCOD in DEMANDAFEINA.DEFCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_DEMANDAFEINA (t in DEMANDAFEINA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_DEMANDAFEINA (r in out DEMANDAFEINA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_DEMANDAFEINA (t in out DEMANDAFEINA_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula EMPRESA*/

    -- Tipus per emmagatzemar un registre de la taula
    type EMPRESA_typ is record (
        EMPCOD   EMPRESA.EMPCOD%type,
        EMPNOM   EMPRESA.EMPNOM%type,
        EMPSEC   EMPRESA.EMPSEC%type,
        EMPTRE   EMPRESA.EMPTRE%type,
        EMPTEL   EMPRESA.EMPTEL%type,
        EMPCOR   EMPRESA.EMPCOR%type,
        EMPWEB   EMPRESA.EMPWEB%type,
        EMPCON   EMPRESA.EMPCON%type,
        SWBAIXA  EMPRESA.SWBAIXA%type
    );
    -- Tipus per treballar amb cursors
    type EMPRESA_ref is ref cursor return EMPRESA_typ;
    -- Tipus per treballar amb taules de registres
    type EMPRESA_tab is table of EMPRESA_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_EMPRESA return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_EMPRESA (r in out EMPRESA_ref, p_EMPCOD in number default null, cons in EMPRESA_typ);
    Procedure Consultar_EMPRESA (t in out EMPRESA_tab, p_EMPCOD in number default null, cons in EMPRESA_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_EMPRESA (r in out EMPRESA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_EMPRESA (t in out EMPRESA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_EMPRESA (p_EMPCOD in EMPRESA.EMPCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_EMPRESA (t in EMPRESA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_EMPRESA (r in out EMPRESA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_EMPRESA (t in out EMPRESA_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula ENTREVISTA*/

    -- Tipus per emmagatzemar un registre de la taula
    type ENTREVISTA_typ is record (
        ENTCOD   ENTREVISTA.ENTCOD%type,
        OFECOD   ENTREVISTA.OFECOD%type,
        ENTDATA  ENTREVISTA.ENTDATA%type
    );
    -- Tipus per treballar amb cursors
    type ENTREVISTA_ref is ref cursor return ENTREVISTA_typ;
    -- Tipus per treballar amb taules de registres
    type ENTREVISTA_tab is table of ENTREVISTA_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_ENTREVISTA return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_ENTREVISTA (r in out ENTREVISTA_ref, p_ENTCOD in number default null, cons in ENTREVISTA_typ);
    Procedure Consultar_ENTREVISTA (t in out ENTREVISTA_tab, p_ENTCOD in number default null, cons in ENTREVISTA_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_ENTREVISTA (r in out ENTREVISTA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_ENTREVISTA (t in out ENTREVISTA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_ENTREVISTA (p_ENTCOD in ENTREVISTA.ENTCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_ENTREVISTA (t in ENTREVISTA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_ENTREVISTA (r in out ENTREVISTA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_ENTREVISTA (t in out ENTREVISTA_tab, p_commit in boolean, e out xerror_typ );

    /* Interficie PL/SQL per a la Taula ESP_LOG*/

    -- Tipus per emmagatzemar un registre de la taula
    type ESPLOG_typ is record (
        LOGCOD     ESP_LOG.LOGCOD%type,
        USRCOD     ESP_LOG.USRCOD%type,
        LOGINICI   ESP_LOG.LOGINICI%type,
        LOGFINAL   ESP_LOG.LOGFINAL%type,
        LOGACCIO   ESP_LOG.LOGACCIO%type,
        LOGRESULT  ESP_LOG.LOGRESULT%type
    );
    -- Tipus per treballar amb cursors
    type ESPLOG_ref is ref cursor return ESPLOG_typ;
    -- Tipus per treballar amb taules de registres
    type ESPLOG_tab is table of ESPLOG_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_ESPLOG return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_ESPLOG ( r in out ESPLOG_ref, p_LOGCOD in number default null, cons in ESPLOG_typ );
    Procedure Consultar_ESPLOG ( t in out ESPLOG_tab, p_LOGCOD in number default null, cons in ESPLOG_typ );
    -- Procediments per afegir un registre a la BD
    Procedure Afegir_ESPLOG(l in out ESPLOG_typ, p_commit in boolean, e out xerror_typ);

    /* Interfcie PL/SQL per a la Taula EXPERIENCIACV*/

    -- Tipus per emmagatzemar un registre de la taula
    type EXPERIENCIACV_typ is record (
        SOLCOD   EXPERIENCIACV.SOLCOD%type,
        SCATCOD  EXPERIENCIACV.SCATCOD%type,
        EMPNOM   EXPERIENCIACV.EMPNOM%type,
        EMPTEL   EXPERIENCIACV.EMPTEL%type,
        DATAINI  EXPERIENCIACV.DATAINI%type,
        DATAFI   EXPERIENCIACV.DATAFI%type
    );
    -- Tipus per treballar amb cursors
    type EXPERIENCIACV_ref is ref cursor return EXPERIENCIACV_typ;
    -- Tipus per treballar amb taules de registres
    type EXPERIENCIACV_tab is table of EXPERIENCIACV_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_EXPERIENCIACV return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_EXPERIENCIACV (r in out EXPERIENCIACV_ref, p_SOLCOD in number default null, cons in EXPERIENCIACV_typ);
    Procedure Consultar_EXPERIENCIACV (t in out EXPERIENCIACV_tab, p_SOLCOD in number default null, cons in EXPERIENCIACV_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_EXPERIENCIACV (r in out EXPERIENCIACV_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_EXPERIENCIACV (t in out EXPERIENCIACV_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_EXPERIENCIACV (p_SOLCOD in EXPERIENCIACV.SOLCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_EXPERIENCIACV (t in EXPERIENCIACV_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_EXPERIENCIACV (r in out EXPERIENCIACV_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_EXPERIENCIACV (t in out EXPERIENCIACV_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula IDIOMES*/

    -- Tipus per emmagatzemar un registre de la taula
    type IDIOMES_typ is record (
        IDIOCOD  IDIOMES.IDIOCOD%type,
        IDIODESC IDIOMES.IDIODESC%type
    );
    -- Tipus per treballar amb cursors
    type IDIOMES_ref is ref cursor return IDIOMES_typ;
    -- Tipus per treballar amb taules de registres
    type IDIOMES_tab is table of IDIOMES_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_IDIOMES return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_IDIOMES (r in out IDIOMES_ref, p_IDIOCOD in number default null, cons in IDIOMES_typ);
    Procedure Consultar_IDIOMES (t in out IDIOMES_tab, p_IDIOCOD in number default null, cons in IDIOMES_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_IDIOMES (r in out IDIOMES_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_IDIOMES (t in out IDIOMES_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_IDIOMES (p_IDIOCOD in IDIOMES.IDIOCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_IDIOMES (t in IDIOMES_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_IDIOMES (r in out IDIOMES_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_IDIOMES (t in out IDIOMES_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula IDIOMESCV*/

    -- Tipus per emmagatzemar un registre de la taula
    type IDIOMESCV_typ is record (
        SOLCOD   IDIOMESCV.SOLCOD%type,
        IDIOCOD  IDIOMESCV.IDIOCOD%type,
        NIVORA   IDIOMESCV.NIVORA%type,
        NIVESC   IDIOMESCV.NIVESC%type
    );
    -- Tipus per treballar amb cursors
    type IDIOMESCV_ref is ref cursor return IDIOMESCV_typ;
    -- Tipus per treballar amb taules de registres
    type IDIOMESCV_tab is table of IDIOMESCV_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_IDIOMESCV return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_IDIOMESCV (r in out IDIOMESCV_ref, p_SOLCOD in number default null, cons in IDIOMESCV_typ);
    Procedure Consultar_IDIOMESCV (t in out IDIOMESCV_tab, p_SOLCOD in number default null, cons in IDIOMESCV_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_IDIOMESCV (r in out IDIOMESCV_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_IDIOMESCV (t in out IDIOMESCV_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_IDIOMESCV (p_SOLCOD in IDIOMESCV.SOLCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_IDIOMESCV (t in IDIOMESCV_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_IDIOMESCV (r in out IDIOMESCV_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_IDIOMESCV (t in out IDIOMESCV_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula IDIOMESOT*/

    -- Tipus per emmagatzemar un registre de la taula
    type IDIOMESOT_typ is record (
        OFECOD  IDIOMESOT.OFECOD%type,
        IDIOCOD IDIOMESOT.IDIOCOD%type
    );
    -- Tipus per treballar amb cursors
    type IDIOMESOT_ref is ref cursor return IDIOMESOT_typ;
    -- Tipus per treballar amb taules de registres
    type IDIOMESOT_tab is table of IDIOMESOT_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_IDIOMESOT return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_IDIOMESOT (r in out IDIOMESOT_ref, p_OFECOD in number default null, cons in IDIOMESOT_typ);
    Procedure Consultar_IDIOMESOT (t in out IDIOMESOT_tab, p_OFECOD in number default null, cons in IDIOMESOT_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_IDIOMESOT (r in out IDIOMESOT_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_IDIOMESOT (t in out IDIOMESOT_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_IDIOMESOT (p_OFECOD in IDIOMESOT.OFECOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_IDIOMESOT (t in IDIOMESOT_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_IDIOMESOT (r in out IDIOMESOT_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_IDIOMESOT (t in out IDIOMESOT_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula INTERESSAT*/

    -- Tipus per emmagatzemar un registre de la taula
    type INTERESSAT_typ is record (
        EMPCOD  INTERESSAT.EMPCOD%type,
        SOLCOD  INTERESSAT.SOLCOD%type
    );
    -- Tipus per treballar amb cursors
    type INTERESSAT_ref is ref cursor return INTERESSAT_typ;
    -- Tipus per treballar amb taules de registres
    type INTERESSAT_tab is table of INTERESSAT_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_INTERESSAT return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_INTERESSAT (r in out INTERESSAT_ref, p_EMPCOD in number default null, cons in INTERESSAT_typ);
    Procedure Consultar_INTERESSAT (t in out INTERESSAT_tab, p_EMPCOD in number default null, cons in INTERESSAT_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_INTERESSAT (r in out INTERESSAT_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_INTERESSAT (t in out INTERESSAT_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_INTERESSAT (p_EMPCOD in INTERESSAT.EMPCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_INTERESSAT (t in INTERESSAT_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_INTERESSAT (r in out INTERESSAT_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_INTERESSAT (t in out INTERESSAT_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula NIVELL*/

    -- Tipus per emmagatzemar un registre de la taula
    type NIVELL_typ is record (
        NIVCOD   NIVELL.NIVCOD%type,
        NIVDESC  NIVELL.NIVDESC%type
    );
    type NIVELL_ref is ref cursor return NIVELL_typ;
    -- Tipus per treballar amb taules de registres
    type NIVELL_tab is table of NIVELL_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_NIVELL return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_NIVELL (r in out NIVELL_ref, p_NIVCOD in number default null, cons in NIVELL_typ);
    Procedure Consultar_NIVELL (t in out NIVELL_tab, p_NIVCOD in number default null, cons in NIVELL_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_NIVELL (r in out NIVELL_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_NIVELL (t in out NIVELL_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_NIVELL (p_NIVCOD in NIVELL.NIVCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_NIVELL (t in NIVELL_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_NIVELL (r in out NIVELL_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_NIVELL (t in out NIVELL_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula OFERTATREBALL*/

    -- Tipus per emmagatzemar un registre de la taula
    type OFERTATREBALL_typ is record (
        OFECOD   OFERTATREBALL.OFECOD%type,
        EMPCOD   OFERTATREBALL.EMPCOD%type,
        PERFCOD  OFERTATREBALL.PERFCOD%type,
        CTECOD   OFERTATREBALL.CTECOD%type,
        TJOCOD   OFERTATREBALL.TJOCOD%type,
        SCATCOD  OFERTATREBALL.SCATCOD%type,
        OTDESC   OFERTATREBALL.OTDESC%type,
        SOUMIN   OFERTATREBALL.SOUMIN%type,
        SOUMAX   OFERTATREBALL.SOUMAX%type,
        SWBAIXA  OFERTATREBALL.SWBAIXA%type,
        OFEINI   OFERTATREBALL.OFEINI%type,
        OFEDIES  OFERTATREBALL.OFEDIES%type,
        OFEFI    OFERTATREBALL.OFEFI%type
    );
    -- Tipus per treballar amb cursors
    type OFERTATREBALL_ref is ref cursor return OFERTATREBALL_typ;
    -- Tipus per treballar amb taules de registres
    type OFERTATREBALL_tab is table of OFERTATREBALL_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_OFERTATREBALL return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_OFERTATREBALL (r in out OFERTATREBALL_ref, p_OFECOD in number default null, cons in OFERTATREBALL_typ);
    Procedure Consultar_OFERTATREBALL (t in out OFERTATREBALL_tab, p_OFECOD in number default null, cons in OFERTATREBALL_typ);
    -- Procediments per obtenir ofertes de treball no cobertes i no eliminades
    Procedure Consultar_OFERTATREBALL_Activa (t in out OFERTATREBALL_tab, p_OFECOD in number default null, cons in OFERTATREBALL_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_OFERTATREBALL (r in out OFERTATREBALL_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_OFERTATREBALL (t in out OFERTATREBALL_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_OFERTATREBALL (p_OFECOD in OFERTATREBALL.OFECOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_OFERTATREBALL (t in OFERTATREBALL_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_OFERTATREBALL (r in out OFERTATREBALL_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_OFERTATREBALL (t in out OFERTATREBALL_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula PERFIL*/

    -- Tipus per emmagatzemar un registre de la taula
    type PERFIL_typ is record (
        PERFCOD  PERFIL.PERFCOD%type,
        PERFDESC PERFIL.PERFDESC%type
    );
    -- Tipus per treballar amb cursors
    type PERFIL_ref is ref cursor return PERFIL_typ;
    -- Tipus per treballar amb taules de registres
    type PERFIL_tab is table of PERFIL_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_PERFIL return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_PERFIL (r in out PERFIL_ref, p_PERFCOD in number default null, cons in PERFIL_typ);
    Procedure Consultar_PERFIL (t in out PERFIL_tab, p_PERFCOD in number default null, cons in PERFIL_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_PERFIL (r in out PERFIL_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_PERFIL (t in out PERFIL_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_PERFIL (p_PERFCOD in PERFIL.PERFCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_PERFIL (t in PERFIL_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_PERFIL (r in out PERFIL_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_PERFIL (t in out PERFIL_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula REBUTJATS*/

    -- Tipus per emmagatzemar un registre de la taula
    type REBUTJATS_typ is record (
        EMPCOD  REBUTJATS.EMPCOD%type,
        SOLCOD  REBUTJATS.SOLCOD%type
    );
    -- Tipus per treballar amb cursors
    type REBUTJATS_ref is ref cursor return REBUTJATS_typ;
    -- Tipus per treballar amb taules de registres
    type REBUTJATS_tab is table of REBUTJATS_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_REBUTJATS return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_REBUTJATS (r in out REBUTJATS_ref, p_EMPCOD in number default null, cons in REBUTJATS_typ);
    Procedure Consultar_REBUTJATS (t in out REBUTJATS_tab, p_EMPCOD in number default null, cons in REBUTJATS_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_REBUTJATS (r in out REBUTJATS_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_REBUTJATS (t in out REBUTJATS_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_REBUTJATS (p_EMPCOD in REBUTJATS.EMPCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_REBUTJATS (t in REBUTJATS_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_REBUTJATS (r in out REBUTJATS_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_REBUTJATS (t in out REBUTJATS_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula SOLICITANT*/

    -- Tipus per emmagatzemar un registre de la taula
    type SOLICITANT_typ is record (
        SOLCOD  SOLICITANT.SOLCOD%type,
        SOLNOM  SOLICITANT.SOLNOM%type,
        SOLNIF  SOLICITANT.SOLNIF%type,
        SOLDOM  SOLICITANT.SOLDOM%type,
        SOLTEL  SOLICITANT.SOLTEL%type,
        SOLCOR  SOLICITANT.SOLCOR%type,
        SWBAIXA SOLICITANT.SWBAIXA%type
    );
    -- Tipus per treballar amb cursors
    type SOLICITANT_ref is ref cursor return SOLICITANT_typ;
    -- Tipus per treballar amb taules de registres
    type SOLICITANT_tab is table of SOLICITANT_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_SOLICITANT return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_SOLICITANT (r in out SOLICITANT_ref, p_SOLCOD in number default null, cons in SOLICITANT_typ);
    Procedure Consultar_SOLICITANT (t in out SOLICITANT_tab, p_SOLCOD in number default null, cons in SOLICITANT_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_SOLICITANT (r in out SOLICITANT_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_SOLICITANT (t in out SOLICITANT_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_SOLICITANT (p_SOLCOD in SOLICITANT.SOLCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_SOLICITANT (t in SOLICITANT_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_SOLICITANT (r in out SOLICITANT_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_SOLICITANT (t in out SOLICITANT_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula SUBCATEGORIA*/

    -- Tipus per emmagatzemar un registre de la taula
    type SUBCATEGORIA_typ is record (
        SCATCOD  SUBCATEGORIA.SCATCOD%type,
        CATCOD   SUBCATEGORIA.CATCOD%type,
        SCATDESC SUBCATEGORIA.SCATDESC%type,
        SWBAIXA  SUBCATEGORIA.SWBAIXA%type
    );
    -- Tipus per treballar amb cursors
    type SUBCATEGORIA_ref is ref cursor return SUBCATEGORIA_typ;
    -- Tipus per treballar amb taules de registres
    type SUBCATEGORIA_tab is table of SUBCATEGORIA_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_SUBCATEGORIA return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_SUBCATEGORIA (r in out SUBCATEGORIA_ref, p_SCATCOD in number default null, cons in SUBCATEGORIA_typ);
    Procedure Consultar_SUBCATEGORIA (t in out SUBCATEGORIA_tab, p_SCATCOD in number default null, cons in SUBCATEGORIA_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_SUBCATEGORIA (r in out SUBCATEGORIA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_SUBCATEGORIA (t in out SUBCATEGORIA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_SUBCATEGORIA (p_SCATCOD in SUBCATEGORIA.SCATCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_SUBCATEGORIA (t in SUBCATEGORIA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_SUBCATEGORIA (r in out SUBCATEGORIA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_SUBCATEGORIA (t in out SUBCATEGORIA_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula TIPUSCONTRACTE*/

    -- Tipus per emmagatzemar un registre de la taula
    type TIPUSCONTRACTE_typ is record (
        CTECOD  TIPUSCONTRACTE.CTECOD%type,
        CTEDESC TIPUSCONTRACTE.CTEDESC%type,
        SWBAIXA TIPUSCONTRACTE.SWBAIXA%type
    );
    -- Tipus per treballar amb cursors
    type TIPUSCONTRACTE_ref is ref cursor return TIPUSCONTRACTE_typ;
    -- Tipus per treballar amb taules de registres
    type TIPUSCONTRACTE_tab is table of TIPUSCONTRACTE_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_TIPUSCONTRACTE return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_TIPUSCONTRACTE (r in out TIPUSCONTRACTE_ref, p_CTECOD in number default null, cons in TIPUSCONTRACTE_typ);
    Procedure Consultar_TIPUSCONTRACTE (t in out TIPUSCONTRACTE_tab, p_CTECOD in number default null, cons in TIPUSCONTRACTE_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_TIPUSCONTRACTE (r in out TIPUSCONTRACTE_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_TIPUSCONTRACTE (t in out TIPUSCONTRACTE_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_TIPUSCONTRACTE (p_CTECOD in TIPUSCONTRACTE.CTECOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_TIPUSCONTRACTE (t in TIPUSCONTRACTE_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_TIPUSCONTRACTE (r in out TIPUSCONTRACTE_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_TIPUSCONTRACTE (t in out TIPUSCONTRACTE_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula TIPUSJORNADA*/

    -- Tipus per emmagatzemar un registre de la taula
    type TIPUSJORNADA_typ is record (
        TJOCOD  TIPUSJORNADA.TJOCOD%type,
        TJODESC TIPUSJORNADA.TJODESC%type
    );
    -- Tipus per treballar amb cursors
    type TIPUSJORNADA_ref is ref cursor return TIPUSJORNADA_typ;
    -- Tipus per treballar amb taules de registres
    type TIPUSJORNADA_tab is table of TIPUSJORNADA_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_TIPUSJORNADA return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_TIPUSJORNADA (r in out TIPUSJORNADA_ref, p_TJOCOD in number default null, cons in TIPUSJORNADA_typ);
    Procedure Consultar_TIPUSJORNADA (t in out TIPUSJORNADA_tab, p_TJOCOD in number default null, cons in TIPUSJORNADA_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_TIPUSJORNADA (r in out TIPUSJORNADA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_TIPUSJORNADA (t in out TIPUSJORNADA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_TIPUSJORNADA (p_TJOCOD in TIPUSJORNADA.TJOCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_TIPUSJORNADA (t in TIPUSJORNADA_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_TIPUSJORNADA (r in out TIPUSJORNADA_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_TIPUSJORNADA (t in out TIPUSJORNADA_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula TITULACIO*/

    -- Tipus per emmagatzemar un registre de la taula
    type TITULACIO_typ is record (
        TITCOD  TITULACIO.TITCOD%type,
        NIVCOD  TITULACIO.NIVCOD%type,
        TITDESC TITULACIO.TITDESC%type
    );
    -- Tipus per treballar amb cursors
    type TITULACIO_ref is ref cursor return TITULACIO_typ;
    -- Tipus per treballar amb taules de registres
    type TITULACIO_tab is table of TITULACIO_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_TITULACIO return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_TITULACIO (r in out TITULACIO_ref, p_TITCOD in number default null, cons in TITULACIO_typ);
    Procedure Consultar_TITULACIO (t in out TITULACIO_tab, p_TITCOD in number default null, cons in TITULACIO_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_TITULACIO (r in out TITULACIO_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_TITULACIO (t in out TITULACIO_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_TITULACIO (p_TITCOD in TITULACIO.TITCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_TITULACIO (t in TITULACIO_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_TITULACIO (r in out TITULACIO_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_TITULACIO (t in out TITULACIO_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula TITULACIOCV*/

    -- Tipus per emmagatzemar un registre de la taula
    type TITULACIOCV_typ is record (
        SOLCOD  TITULACIOCV.SOLCOD%type,
        TITCOD  TITULACIOCV.TITCOD%type,
        ANYTIT  TITULACIOCV.ANYTIT%type,
        ESCOLA  TITULACIOCV.ESCOLA%type
    );
    -- Tipus per treballar amb cursors
    type TITULACIOCV_ref is ref cursor return TITULACIOCV_typ;
    -- Tipus per treballar amb taules de registres
    type TITULACIOCV_tab is table of TITULACIOCV_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_TITULACIOCV return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_TITULACIOCV (r in out TITULACIOCV_ref, p_SOLCOD in number default null, cons in TITULACIOCV_typ);
    Procedure Consultar_TITULACIOCV (t in out TITULACIOCV_tab, p_SOLCOD in number default null, cons in TITULACIOCV_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_TITULACIOCV (r in out TITULACIOCV_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_TITULACIOCV (t in out TITULACIOCV_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_TITULACIOCV (p_SOLCOD in TITULACIOCV.SOLCOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_TITULACIOCV (t in TITULACIOCV_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_TITULACIOCV (r in out TITULACIOCV_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_TITULACIOCV (t in out TITULACIOCV_tab, p_commit in boolean, e out xerror_typ );

    /* Interfcie PL/SQL per a la Taula TITULACIOOT*/

    -- Tipus per emmagatzemar un registre de la taula
    type TITULACIOOT_typ is record (
        OFECOD  TITULACIOOT.OFECOD%type,
        TITCOD  TITULACIOOT.TITCOD%type
    );
    -- Tipus per treballar amb cursors
    type TITULACIOOT_ref is ref cursor return TITULACIOOT_typ;
    -- Tipus per treballar amb taules de registres
    type TITULACIOOT_tab is table of TITULACIOOT_typ index by binary_integer;

    -- Funci que retorna la clau primria d'un nou registre de la taula
    Function GetPK_TITULACIOOT return number;

    -- Procediments per obtenir registres de la BD utilitzant cursor o taula
    Procedure Consultar_TITULACIOOT (r in out TITULACIOOT_ref, p_OFECOD in number default null, cons in TITULACIOOT_typ);
    Procedure Consultar_TITULACIOOT (t in out TITULACIOOT_tab, p_OFECOD in number default null, cons in TITULACIOOT_typ);
    -- Procediments per afegir un  o diversos registres a la BD
    Procedure Afegir_TITULACIOOT (r in out TITULACIOOT_typ, p_commit in boolean, e out xerror_typ );
    Procedure Afegir_TITULACIOOT (t in out TITULACIOOT_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per eliminar un o diversos registres de la BD
    Procedure Esborrar_TITULACIOOT (p_OFECOD in TITULACIOOT.OFECOD%type, p_commit in boolean, e out xerror_typ );
    Procedure Esborrar_TITULACIOOT (t in TITULACIOOT_tab, p_commit in boolean, e out xerror_typ );
    -- Procediments per modificar un o diversos registres de la BD
    Procedure Modificar_TITULACIOOT (r in out TITULACIOOT_typ, p_commit in boolean, e out xerror_typ );
    Procedure Modificar_TITULACIOOT (t in out TITULACIOOT_tab, p_commit in boolean, e out xerror_typ );

    /* Altres procediments*/
    /* Es crea una entrevista per a una determinada oferta de treball en la data indicada i es convoca als sollicitants
       que reuneixen les condicions indicades a l'oferta */
    Procedure ConcertarEntrevista(ofe in OFERTATREBALL_typ, dat in ENTREVISTA.ENTDATA%type, p_commit in boolean, e out xerror_typ);
    -- Selecciona els candidats que compleixen les condicions indicades a l'oferta de treball corresponent
    Procedure SeleccionarCandidats(ofe in OFERTATREBALL_typ, con in out CURRICULUM_tab);
    -- Dna de baixa de la BD l'oferta de treball i el sollicitant indicats, ja que ha cobert la plaa indicada
    Procedure SeleccionarCandidat(ofe in out OFERTATREBALL_typ, p_SOLCOD in SOLICITANT.SOLCOD%type, d date, p_commit in boolean, e out xerror_typ);
    -- Omple el DW amb totes les dades incloses a la BD operacional
    Procedure ExtraccioDades(p_commit in boolean, e out xerror_typ);
    -- Omple el DW amb les dades corresponents al perode indicat
    Procedure ExtraccioDades(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type, p_commit in boolean, e out xerror_typ);
    -- Selecciona els perfils que no estan encara al DW i modifica la descripci dels existents
    Procedure FusionaPerfil(p_commit in boolean, e out xerror_typ);
    -- Selecciona les subcategories que no estan encara al DW i modifica la descripci de les existents
    Procedure FusionaSubcategoria(p_commit in boolean, e out xerror_typ);
    -- Selecciona els perodes que no estan encara al DW
    Procedure FusionaTemps(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type, p_commit in boolean, e out xerror_typ);
    -- Selecciona els tipus de contracte que no estan encara al DW i modifica la descripci dels existents
    Procedure FusionaTipusContracte(p_commit in boolean, e out xerror_typ);
    -- Selecciona els tipus de jornada que no estan encara al DW i modifica la descripci dels existents
    Procedure FusionaTipusJornada(p_commit in boolean, e out xerror_typ);

end BASIC_PKG;
/
