/* **********************************************************
 *                                                          *
 *  DISSENY I IMPLEMENTACI DUNA BASE DE DADES RELACIONAL  *
 *  PER A UNA EMPRESA DE SELECCI DE PERSONAL               *
 *                                                          *
 *  UOC                                                     *
 *  PROJECTE FINAL DE CARRERA ENGINYERIA EN INFORMATICA     *
 *  ALUMNE:    RUBEN PEREZ DE LA FUENTE                     *
 *  CONSULTOR: JUAN MARTINEZ BOLAOS                        *
 *                                                          *
 ***********************************************************/

/* **********************************************************
 *                                                          *
 *                                                          *
 *                BASE DE DADES OPERACIONAL                 *
 *                                                          *
 *                                                          *
 ***********************************************************/

/* **********************************************************
 *                  CREACI DE LES TAULES
 ***********************************************************/

CREATE TABLE Categoria
    (
     CATCOD NUMBER         NOT NULL ,
     CATDESC VARCHAR2 (50) NOT NULL,
     SWBAIXA CHAR(1) DEFAULT '0'
    )
/

CREATE TABLE Convocats
    (
     ENTCOD NUMBER  NOT NULL ,
     SOLCOD NUMBER  NOT NULL
    )
/

CREATE TABLE Curriculum
    (
     SOLCOD NUMBER  NOT NULL
    )
/

CREATE TABLE DemandaFeina
    (
     DEFCOD  NUMBER NOT NULL ,
     SOLCOD  NUMBER NOT NULL,
     PERFCOD NUMBER NOT NULL,
     SCATCOD NUMBER NOT NULL,
     SWBAIXA CHAR (1) DEFAULT '0'
    )
/
CREATE TABLE Empresa
    (
     EMPCOD  NUMBER         NOT NULL ,
     EMPNOM  VARCHAR2 (100) NOT NULL,
     EMPSEC  VARCHAR2 (50) ,
     EMPTRE  VARCHAR2 (10) ,
     EMPTEL  VARCHAR2 (9) ,
     EMPCOR  VARCHAR2 (30) ,
     EMPWEB  VARCHAR2 (30) ,
     EMPCON  VARCHAR2 (75) ,
     SWBAIXA CHAR (1) DEFAULT '0'
    )
/

CREATE TABLE Entrevista
    (
     ENTCOD  NUMBER NOT NULL ,
     OFECOD  NUMBER NOT NULL ,
     ENTDATA DATE   NOT NULL
    )
/

CREATE TABLE ESP_LOG
    (
     LOGCOD    NUMBER         NOT NULL,
     USRCOD    VARCHAR2 (20)  NOT NULL,
     LOGINICI  TIMESTAMP      NOT NULL,
     LOGFINAL  TIMESTAMP      NOT NULL,
     LOGACCIO  VARCHAR2 (255) NOT NULL,
     LOGRESULT VARCHAR2 (255) NOT NULL
    )
/

CREATE TABLE ExperienciaCV
    (
     SOLCOD  NUMBER         NOT NULL ,
     SCATCOD NUMBER         NOT NULL ,
     EMPNOM  VARCHAR2 (100) NOT NULL,
     EMPTEL  VARCHAR2 (9) ,
     DATAINI DATE           NOT NULL,
     DATAFI  DATE
    )
/

CREATE TABLE Idiomes
    (
     IDIOCOD  NUMBER        NOT NULL ,
     IDIODESC VARCHAR2 (20) NOT NULL
    )
/

CREATE TABLE IdiomesCV
    (
     SOLCOD  NUMBER       NOT NULL ,
     IDIOCOD NUMBER       NOT NULL ,
     NIVORA  VARCHAR2 (4) NOT NULL CHECK (NIVORA IN ('ALT', 'BAIX', 'MIG')) ,
     NIVESC  VARCHAR2 (4) NOT NULL CHECK (NIVESC IN ('ALT', 'BAIX', 'MIG'))
    )
/

CREATE TABLE IdiomesOT
    (
     OFECOD  NUMBER  NOT NULL ,
     IDIOCOD NUMBER  NOT NULL
    )
/

CREATE TABLE Interessat
    (
     EMPCOD NUMBER  NOT NULL ,
     SOLCOD NUMBER  NOT NULL
    )
/

CREATE TABLE Nivell
    (
     NIVCOD  NUMBER        NOT NULL ,
     NIVDESC VARCHAR2 (50) NOT NULL
    )
/

CREATE TABLE OfertaTreball
    (
     OFECOD  NUMBER         NOT NULL ,
     EMPCOD  NUMBER         NOT NULL ,
     PERFCOD NUMBER         NOT NULL ,
     CTECOD  NUMBER         NOT NULL ,
     TJOCOD  NUMBER         NOT NULL ,
     SCATCOD NUMBER         NOT NULL ,
     OTDESC  VARCHAR2 (250) NOT NULL ,
     SOUMIN  NUMBER (9,2)   NOT NULL ,
     SOUMAX  NUMBER (9,2)   NOT NULL ,
     SWBAIXA CHAR (1) DEFAULT '0' ,
     OFEINI  DATE           NOT NULL ,
     OFEDIES NUMBER (3)     NOT NULL ,
     OFEFI   DATE
    )
/

CREATE TABLE Perfil
    (
     PERFCOD  NUMBER        NOT NULL ,
     PERFDESC VARCHAR2 (50) NOT NULL
    )
/

CREATE TABLE Rebutjats
    (
     EMPCOD NUMBER  NOT NULL ,
     SOLCOD NUMBER  NOT NULL
    )
/

CREATE TABLE Solicitant
    (
     SOLCOD  NUMBER         NOT NULL ,
     SOLNOM  VARCHAR2 (75)  NOT NULL,
     SOLNIF  VARCHAR2 (9)   NOT NULL,
     SOLDOM  VARCHAR2 (100) NOT NULL,
     SOLTEL  VARCHAR2 (9) ,
     SOLCOR  VARCHAR2 (30) ,
     SWBAIXA CHAR (1) DEFAULT '0'
    )
/

CREATE TABLE Subcategoria
    (
     SCATCOD  NUMBER        NOT NULL ,
     CATCOD   NUMBER        NOT NULL ,
     SCATDESC VARCHAR2 (50) NOT NULL,
     SWBAIXA  CHAR(1) DEFAULT '0'
    )
/

CREATE TABLE TipusContracte
    (
     CTECOD  NUMBER        NOT NULL ,
     CTEDESC VARCHAR2 (50) NOT NULL ,
     SWBAIXA CHAR(1) DEFAULT '0'
    )
/

CREATE TABLE TipusJornada
    (
     TJOCOD  NUMBER        NOT NULL ,
     TJODESC VARCHAR2 (50) NOT NULL
    )
/

CREATE TABLE Titulacio
    (
     TITCOD  NUMBER         NOT NULL ,
     NIVCOD  NUMBER         NOT NULL ,
     TITDESC VARCHAR2 (100) NOT NULL
    )
/

CREATE TABLE TitulacioCV
    (
     SOLCOD NUMBER  NOT NULL ,
     TITCOD NUMBER  NOT NULL ,
     ANYTIT NUMBER (4) ,
     ESCOLA VARCHAR2 (100)
    )
/

CREATE TABLE TitulacioOT
    (
     OFECOD NUMBER  NOT NULL ,
     TITCOD NUMBER  NOT NULL
    )
/

/* **********************************************************
 *                       CLAUS PRIMRIES
 ***********************************************************/

ALTER TABLE Categoria
    ADD PRIMARY KEY ( CATCOD ) 
/

ALTER TABLE Convocats
    ADD PRIMARY KEY ( ENTCOD, SOLCOD ) 
/

ALTER TABLE Curriculum
    ADD PRIMARY KEY ( SOLCOD ) 
/

ALTER TABLE DemandaFeina
    ADD PRIMARY KEY ( DEFCOD ) 
/

ALTER TABLE ESP_LOG
    ADD PRIMARY KEY ( LOGCOD ) 
/

ALTER TABLE Empresa
    ADD PRIMARY KEY ( EMPCOD ) 
/

ALTER TABLE Entrevista
    ADD PRIMARY KEY ( ENTCOD ) 
/

ALTER TABLE ExperienciaCV
    ADD PRIMARY KEY ( SCATCOD, SOLCOD ) 
/

ALTER TABLE Idiomes
    ADD PRIMARY KEY ( IDIOCOD ) 
/

ALTER TABLE IdiomesCV
    ADD PRIMARY KEY ( SOLCOD, IDIOCOD ) 
/

ALTER TABLE IdiomesOT
    ADD PRIMARY KEY ( OFECOD, IDIOCOD ) 
/

ALTER TABLE Interessat
    ADD PRIMARY KEY ( EMPCOD, SOLCOD ) 
/

ALTER TABLE Nivell
    ADD PRIMARY KEY ( NIVCOD )
/

ALTER TABLE OfertaTreball
    ADD PRIMARY KEY ( OFECOD ) 
/

ALTER TABLE Perfil
    ADD PRIMARY KEY ( PERFCOD ) 
/

ALTER TABLE Rebutjats
    ADD PRIMARY KEY ( EMPCOD, SOLCOD ) 
/

ALTER TABLE Solicitant
    ADD PRIMARY KEY ( SOLCOD ) 
/

ALTER TABLE Subcategoria
    ADD PRIMARY KEY ( SCATCOD ) 
/

ALTER TABLE TipusContracte
    ADD PRIMARY KEY ( CTECOD )
/

ALTER TABLE TipusJornada
    ADD PRIMARY KEY ( TJOCOD ) 
/

ALTER TABLE Titulacio
    ADD PRIMARY KEY ( TITCOD ) 
/

ALTER TABLE TitulacioCV
    ADD PRIMARY KEY ( SOLCOD, TITCOD ) 
/

ALTER TABLE TitulacioOT
    ADD PRIMARY KEY ( OFECOD, TITCOD ) 
/

/* **********************************************************
 *                      CLAUS FORANES
 ***********************************************************/

ALTER TABLE OfertaTreball
    ADD CONSTRAINT FK_ContracteOT FOREIGN KEY
    (
     CTECOD
    )
    REFERENCES TipusContracte
    (
     CTECOD
    )
    ON DELETE CASCADE
/

ALTER TABLE ExperienciaCV
    ADD CONSTRAINT FK_Curriculum FOREIGN KEY
    (
     SOLCOD
    )
    REFERENCES Curriculum
    (
     SOLCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE IdiomesCV
    ADD CONSTRAINT FK_CurriculumIdioma FOREIGN KEY
    (
     SOLCOD
    )
    REFERENCES Curriculum
    (
     SOLCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE TitulacioCV
    ADD CONSTRAINT FK_CurriculumTit FOREIGN KEY
    (
     SOLCOD
    )
    REFERENCES Curriculum
    (
     SOLCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE DemandaFeina
    ADD CONSTRAINT FK_DemandaOcupacio FOREIGN KEY
    (
     SOLCOD
    )
    REFERENCES Curriculum
    (
     SOLCOD
    )
/

ALTER TABLE Convocats
    ADD CONSTRAINT FK_Entrevista FOREIGN KEY
    (
     ENTCOD
    )
    REFERENCES Entrevista
    (
     ENTCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE Convocats
    ADD CONSTRAINT FK_Entrevistat FOREIGN KEY
    (
     SOLCOD
    )
    REFERENCES Solicitant
    (
     SOLCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE IdiomesOT
    ADD CONSTRAINT FK_Idioma FOREIGN KEY
    (
     IDIOCOD
    )
    REFERENCES Idiomes
    (
     IDIOCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE IdiomesCV
    ADD CONSTRAINT FK_IdiomesCV FOREIGN KEY
    (
     IDIOCOD
    )
    REFERENCES Idiomes
    (
     IDIOCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE OfertaTreball
    ADD CONSTRAINT FK_JornadaOT FOREIGN KEY
    (
     TJOCOD
    )
    REFERENCES TipusJornada
    (
     TJOCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE IdiomesOT
    ADD CONSTRAINT FK_OfertaTreball FOREIGN KEY
    (
     OFECOD
    )
    REFERENCES OfertaTreball
    (
     OFECOD
    )
    ON DELETE CASCADE
/

ALTER TABLE Entrevista
    ADD CONSTRAINT FK_Organitza FOREIGN KEY
    (
     OFECOD
    )
    REFERENCES OfertaTreball
    (
     OFECOD
    )
    ON DELETE CASCADE
/

ALTER TABLE DemandaFeina
    ADD CONSTRAINT FK_PerfilDemanda FOREIGN KEY
    (
     PERFCOD
    )
    REFERENCES Perfil
    (
     PERFCOD
    )
/

ALTER TABLE OfertaTreball
    ADD CONSTRAINT FK_PerfilOT FOREIGN KEY
    (
     PERFCOD
    )
    REFERENCES Perfil
    (
     PERFCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE Subcategoria
    ADD CONSTRAINT FK_Pertany FOREIGN KEY
    (
     CATCOD
    )
    REFERENCES Categoria
    (
     CATCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE OfertaTreball
    ADD CONSTRAINT FK_PresentaOT FOREIGN KEY
    (
     EMPCOD
    )
    REFERENCES Empresa
    (
     EMPCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE ExperienciaCV
    ADD CONSTRAINT FK_SubcategoriaCV FOREIGN KEY
    (
     SCATCOD
    )
    REFERENCES Subcategoria
    (
     SCATCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE OfertaTreball
    ADD CONSTRAINT FK_SubcategoriesOT FOREIGN KEY
    (
     SCATCOD
    )
    REFERENCES Subcategoria
    (
     SCATCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE Interessat
    ADD CONSTRAINT FKCVInteressants FOREIGN KEY
    (
     EMPCOD
    )
    REFERENCES Empresa
    (
     EMPCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE Rebutjats
    ADD CONSTRAINT FKCVRebutjats FOREIGN KEY
    (
     EMPCOD
    )
    REFERENCES Empresa
    (
     EMPCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE Interessat
    ADD CONSTRAINT FKEmpInteressades FOREIGN KEY
    (
     SOLCOD
    )
    REFERENCES Solicitant
    (
     SOLCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE Rebutjats
    ADD CONSTRAINT FKEmpRebutjat FOREIGN KEY
    (
     SOLCOD
    )
    REFERENCES Solicitant
    (
     SOLCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE TitulacioCV
    ADD CONSTRAINT FK_TitolsCV FOREIGN KEY
    (
     TITCOD
    )
    REFERENCES Titulacio
    (
     TITCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE Titulacio
    ADD CONSTRAINT NivellTitol FOREIGN KEY
    (
     NIVCOD
    )
    REFERENCES Nivell
    (
     NIVCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE DemandaFeina
    ADD CONSTRAINT SubcategoriaDF FOREIGN KEY
    (
     SCATCOD
    )
    REFERENCES Subcategoria
    (
     SCATCOD
    )
/

ALTER TABLE Curriculum
    ADD CONSTRAINT Te FOREIGN KEY
    (
     SOLCOD
    )
    REFERENCES Solicitant
    (
     SOLCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE TitulacioOT
    ADD CONSTRAINT TitulacioOT_OfertaTreball_FK FOREIGN KEY
    (
     OFECOD
    )
    REFERENCES OfertaTreball
    (
     OFECOD
    )
    ON DELETE CASCADE
/

ALTER TABLE TitulacioOT
    ADD CONSTRAINT TitulacioOT_Titulacio_FK FOREIGN KEY
    (
     TITCOD
    )
    REFERENCES Titulacio
    (
     TITCOD
    )
    ON DELETE CASCADE
/

/* **********************************************************
 *                       DISPARADORS
 ***********************************************************/

-- Disparador per controlar que la data de l'entrevista no sigui
-- anteior a avui
CREATE OR REPLACE
TRIGGER trg_entdata
    BEFORE INSERT OR UPDATE
    ON Entrevista
        FOR EACH ROW
            WHEN (NEW.ENTDATA < SYSDATE) 
            BEGIN
                RAISE_APPLICATION_ERROR (
                    -20001, 
                    'La data de l''entrevista s anteior a avui.'
                );
END trg_entdata;
/

-- Disparador per controlar que les dates de l'experincia sn
-- coherents
CREATE OR REPLACE
TRIGGER trg_expdates
    BEFORE INSERT OR UPDATE
    ON ExperienciaCV
        FOR EACH ROW
            WHEN (NEW.DATAINI > NEW.DATAFI) 
            BEGIN
                RAISE_APPLICATION_ERROR (
                    -20002, 
                    'La data de rescisi de contracte s anterior a la de la signatura.'
                );
END trg_expdates;
/

-- Disparador per controlar que l'oferta de treball no es tanca abans
-- de la data d'entrada
CREATE OR REPLACE
TRIGGER trg_ofedates
    BEFORE INSERT OR UPDATE
    ON OfertaTreball
        FOR EACH ROW
            WHEN (NEW.OFEINI > NEW.OFEFI) 
            BEGIN
                RAISE_APPLICATION_ERROR (
                    -20003, 
                    'La data de cobertura de la plaa(' || TO_CHAR(:NEW.OFEFI,'DD/MM/YYYY') || 
                    ') s anterior a la de presentaci de l''oferta (' || TO_CHAR(:NEW.OFEINI,'DD/MM/YYYY') || ').'
                );
END trg_ofedates;
/

-- Disparador per controlar que el sou mnim no s superior al mxim
CREATE OR REPLACE
TRIGGER trg_ofesouminmax
    BEFORE INSERT OR UPDATE
    ON OfertaTreball
        FOR EACH ROW
            WHEN (NEW.SOUMIN > NEW.SOUMAX) 
            BEGIN
                RAISE_APPLICATION_ERROR (
                    -20004, 
                    'El sou mnim de l''oferta s superior al sou mxim.'
                );
END trg_ofesouminmax;
/

-- Disparador per controlar que els sous no sn negatius
CREATE OR REPLACE
TRIGGER trg_ofesouspos
    BEFORE INSERT OR UPDATE
    ON OfertaTreball
        FOR EACH ROW
        BEGIN
            IF :NEW.SOUMIN < 0 AND :NEW.SOUMAX < 0 THEN
                RAISE_APPLICATION_ERROR (
                    -20005, 
                    'Els sous han de ser 0 o positius.'
                );
            END IF;
            IF :NEW.SOUMIN < 0 THEN
                RAISE_APPLICATION_ERROR (
                    -20006, 
                    'El sou mnim ha de ser 0 o positiu.'
                );
            END IF;
            IF :NEW.SOUMAX < 0 THEN 
                RAISE_APPLICATION_ERROR (
                    -20007, 
                    'El sou mxim ha de ser 0 o positiu.'
                );
            END IF;
END trg_ofesouspos;
/
