/* **********************************************************
 *                                                          *
 *  DISSENY I IMPLEMENTACI DUNA BASE DE DADES RELACIONAL  *
 *  PER A UNA EMPRESA DE SELECCI DE PERSONAL               *
 *                                                          *
 *  UOC                                                     *
 *  PROJECTE FINAL DE CARRERA ENGINYERIA EN INFORMATICA     *
 *  ALUMNE:    RUBEN PEREZ DE LA FUENTE                     *
 *  CONSULTOR: JUAN MARTINEZ BOLAOS                        *
 *                                                          *
 ***********************************************************/

/* **********************************************************
 *                                                          *
 *                                                          *
 *                    MAGATZEM DE DADES                     *
 *                                                          *
 *                                                          *
 ***********************************************************/

/* **********************************************************
 *                  CREACI DE LES TAULES
 ***********************************************************/

CREATE TABLE DWOfertesTreball
    (
     IDTEMPS         NUMBER  NOT NULL ,
     PERFCOD         NUMBER  NOT NULL ,
     SCATCOD         NUMBER  NOT NULL ,
     CTECOD          NUMBER  NOT NULL ,
     TJOCOD          NUMBER  NOT NULL ,
     DIESCOBERTURA   NUMBER ,
     OFERTESENTEMPS  NUMBER ,
     OFERTESCOBERTES NUMBER ,
     SALARI          NUMBER
    )
/

CREATE TABLE DWPerfil
    (
     PERFCOD  NUMBER  NOT NULL ,
     PERFDESC VARCHAR2 (50)
    )
/

CREATE TABLE DWSubcategoria
    (
     SCATCOD  NUMBER  NOT NULL ,
     CATDESC  VARCHAR2 (50) ,
     SCATDESC VARCHAR2 (50)
    )
/

CREATE TABLE DWTemps
    (
     IDTEMPS NUMBER  NOT NULL ,
     NANY    NUMBER (4) ,
     MES     NUMBER (2)
    )
/

CREATE TABLE DWTipusContracte
    (
     CTECOD  NUMBER  NOT NULL ,
     CTEDESC VARCHAR2 (50)
    )
/

CREATE TABLE DWTipusJornada
    (
     TJOCOD  NUMBER  NOT NULL ,
     TJODESC VARCHAR2 (50)
    )
/

/* **********************************************************
 *                     CLAUS PRIMRIES
 ***********************************************************/

ALTER TABLE DWOfertesTreball
    ADD PRIMARY KEY ( PERFCOD, SCATCOD, CTECOD, TJOCOD, IDTEMPS ) 
/

ALTER TABLE DWPerfil
    ADD PRIMARY KEY ( PERFCOD ) 
/

ALTER TABLE DWSubcategoria
    ADD PRIMARY KEY ( SCATCOD ) 
/

ALTER TABLE DWTemps
    ADD PRIMARY KEY ( IDTEMPS ) 
/

ALTER TABLE DWTipusContracte
    ADD PRIMARY KEY ( CTECOD ) 
/

ALTER TABLE DWTipusJornada
    ADD PRIMARY KEY ( TJOCOD ) 
/

/* **********************************************************
 *                      CLAUS FORANES
 ***********************************************************/

ALTER TABLE DWOfertesTreball
    ADD CONSTRAINT CategoriaOferta FOREIGN KEY
    (
     SCATCOD
    )
    REFERENCES DWSubcategoria
    (
     SCATCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE DWOfertesTreball
    ADD CONSTRAINT ContracteOferta FOREIGN KEY
    (
     CTECOD
    )
    REFERENCES DWTipusContracte
    (
     CTECOD
    )
    ON DELETE CASCADE
/

ALTER TABLE DWOfertesTreball
    ADD CONSTRAINT JornadaOferta FOREIGN KEY
    (
     TJOCOD
    )
    REFERENCES DWTipusJornada
    (
     TJOCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE DWOfertesTreball
    ADD CONSTRAINT PerfilOferta FOREIGN KEY
    (
     PERFCOD
    )
    REFERENCES DWPerfil
    (
     PERFCOD
    )
    ON DELETE CASCADE
/

ALTER TABLE DWOfertesTreball
    ADD CONSTRAINT PeriodeOferta FOREIGN KEY
    (
     IDTEMPS
    )
    REFERENCES DWTemps
    (
     IDTEMPS
    )
    ON DELETE CASCADE
/

