/* **********************************************************
 *                                                          *
 *  DISSENY I IMPLEMENTACI DUNA BASE DE DADES RELACIONAL  *
 *  PER A UNA EMPRESA DE SELECCI DE PERSONAL               *
 *                                                          *
 *  UOC                                                     *
 *  PROJECTE FINAL DE CARRERA ENGINYERIA EN INFORMATICA     *
 *  ALUMNE:    RUBEN PEREZ DE LA FUENTE                     *
 *  CONSULTOR: JUAN MARTINEZ BOLAOS                        *
 *                                                          *
 ***********************************************************/

/* **********************************************************
 *           IMPLEMENTACI DEL PAQUET PROVES_PKG
 ***********************************************************/

CREATE OR REPLACE PACKAGE BODY
OUTPUT_PKG is

    /* Fitxes dels registres de les taules*/
    Procedure Fitxa_CATEGORIA(c in CATEGORIA.CATCOD%type) is
        r_null BASIC_PKG.CATEGORIA_typ;
        t      BASIC_PKG.CATEGORIA_tab;
    begin
        BASIC_PKG.Consultar_CATEGORIA(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_CATEGORIA(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_CATEGORIA;

    Procedure Fitxa_CATEGORIA(r in BASIC_PKG.CATEGORIA_typ, f_r in number default 0) is
    begin
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA CATEGORIA', 40));
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || to_char(r.CATCOD));
            Dbms_Output.PUT_LINE(rpad('DESCRIPCIO', 15, '.') || ': ' || r.CATDESC);
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        else
            Dbms_Output.PUT_LINE(rpad(r.CATCOD, 10) || rpad(r.CATDESC, 50));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_CATEGORIA;

    Procedure Fitxa_CONVOCATS(c in CONVOCATS.ENTCOD%type) is
        r_null BASIC_PKG.CONVOCATS_typ;
        t      BASIC_PKG.CONVOCATS_tab;
    begin
        BASIC_PKG.Consultar_CONVOCATS(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_CONVOCATS(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_CONVOCATS;

    Procedure Fitxa_CONVOCATS(r in BASIC_PKG.CONVOCATS_typ) is
        s BASIC_PKG.SOLICITANT_typ;
        t BASIC_PKG.SOLICITANT_tab;
    begin
        BASIC_PKG.Consultar_SOLICITANT(t, r.SOLCOD, s);
        Fitxa_SOLICITANT(t(0), 2);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_CONVOCATS;

    Procedure Fitxa_CURRICULUM(c in CURRICULUM.SOLCOD%type) is
        t      BASIC_PKG.CURRICULUM_tab;
    begin
        BASIC_PKG.Consultar_CURRICULUM(t, c);
        if t.count() <> 0 then
            Fitxa_CURRICULUM(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_CURRICULUM;

    Procedure Fitxa_CURRICULUM(r in BASIC_PKG.CURRICULUM_typ) is
        tabsol BASIC_PKG.SOLICITANT_tab;
        typsol BASIC_PKG.SOLICITANT_typ;
        tabidi BASIC_PKG.IDIOMESCV_tab;
        typidi BASIC_PKG.IDIOMESCV_typ;
        tabtit BASIC_PKG.TITULACIOCV_tab;
        typtit BASIC_PKG.TITULACIOCV_typ;
        tabexp BASIC_PKG.EXPERIENCIACV_tab;
        typexp BASIC_PKG.EXPERIENCIACV_typ;
    begin
        BASIC_PKG.Consultar_SOLICITANT(tabsol, r.SOLCOD, typsol);
        BASIC_PKG.Consultar_IDIOMESCV(tabidi, r.SOLCOD, typidi);
        BASIC_PKG.Consultar_TITULACIOCV(tabtit, r.SOLCOD, typtit);
        BASIC_PKG.Consultar_EXPERIENCIACV(tabexp, r.SOLCOD, typexp);

        Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
        Dbms_Output.PUT_LINE(lpad('CURRICULUM SOLLICITANT', 71));
        Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || to_char(r.SOLCOD));
        Dbms_Output.PUT_LINE(rpad('NOM', 15, '.') || ': ' || tabsol(0).SOLNOM);
        Dbms_Output.PUT_LINE(rpad('NIF', 15, '.') || ': ' || tabsol(0).SOLNIF);
        Dbms_Output.PUT_LINE(rpad('DOMICILI', 15, '.') || ': ' || tabsol(0).SOLDOM);
        Dbms_Output.PUT_LINE(rpad('TELEFON', 15, '.') || ': ' || tabsol(0).SOLTEL);
        Dbms_Output.PUT_LINE(rpad('E-CORREU', 15, '.') || ': ' || tabsol(0).SOLCOR);
        if tabtit.count() > 0 then
            Dbms_Output.PUT_LINE(rpad('TITULACIO', 15, '.') || ': ' || Descriptor_TITULACIO(tabtit(0).TITCOD));
        end if;
        for i in 1..(tabtit.count() - 1) loop
            Dbms_Output.PUT_LINE(rpad(' ', 17) || Descriptor_TITULACIO(tabtit(i).TITCOD));
        end loop;
        if tabidi.count() > 0 then
            Dbms_Output.PUT_LINE(rpad('IDIOMES', 15, '.') || ': ' || Descriptor_IDIOMES(tabidi(0).IDIOCOD));
        end if;
        for i in 1..(tabidi.count() - 1) loop
            Dbms_Output.PUT_LINE(rpad(' ', 17) || Descriptor_IDIOMES(tabidi(i).IDIOCOD));
        end loop;
        if tabexp.count() > 0 then
            Dbms_Output.PUT_LINE(rpad('EXPERIENCIA', 15, '.') || ': ' || to_char(tabexp(0).DATAINI, 'MM/YYYY') || ' - ' ||
                                 to_char(tabexp(0).DATAFI, 'MM/YYYY') || ' ' || Descriptor_SUBCATEGORIA(tabexp(0).SCATCOD, 1));
            Dbms_Output.PUT_LINE(rpad(' ', 17) || tabexp(0).EMPNOM);
        end if;
        for i in 1..(tabtit.count() - 1) loop
            Dbms_Output.PUT_LINE(rpad(' ', 17) || to_char(tabexp(i).DATAINI, 'MM/YYYY') || ' - ' ||
                                 to_char(tabexp(i).DATAFI, 'MM/YYYY') || ' ' || Descriptor_SUBCATEGORIA(tabexp(i).SCATCOD, 1));
            Dbms_Output.PUT_LINE(rpad(' ', 17) || tabexp(i).EMPNOM);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_CURRICULUM;

    Procedure Fitxa_DEMANDAFEINA(c in DEMANDAFEINA.DEFCOD%type) is
        r_null BASIC_PKG.DEMANDAFEINA_typ;
        t      BASIC_PKG.DEMANDAFEINA_tab;
    begin
        BASIC_PKG.Consultar_DEMANDAFEINA(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_DEMANDAFEINA(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_DEMANDAFEINA;

    Procedure Fitxa_DEMANDAFEINA(r in BASIC_PKG.DEMANDAFEINA_typ, f_r in number default 0) is
    begin
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 115, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA DEMANDAFEINA', 66));
            Dbms_Output.PUT_LINE(rpad('*', 115, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || r.DEFCOD);
            Dbms_Output.PUT_LINE(rpad('SOLLICITANT', 15, '.') || ': ' || Descriptor_SOLICITANT(r.SOLCOD));
            Dbms_Output.PUT_LINE(rpad('PERFIL', 15, '.') || ': ' || Descriptor_PERFIL(r.PERFCOD));
            Dbms_Output.PUT_LINE(rpad('SUBCATEGORIA', 15, '.') || ': ' || Descriptor_SUBCATEGORIA(r.SCATCOD, 1));
            Dbms_Output.PUT_LINE(rpad('*', 115, '*'));
        else
            Dbms_Output.PUT_LINE(rpad(r.DEFCOD, 10) ||
                                 rpad(Descriptor_SOLICITANT(r.SOLCOD), 76) ||
                                 rpad(Descriptor_PERFIL(r.PERFCOD), 50));
            Dbms_Output.PUT_LINE(rpad('  ' || Descriptor_SUBCATEGORIA(r.SCATCOD, 1), 101));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_DEMANDAFEINA;

    Procedure Fitxa_EMPRESA(c in EMPRESA.EMPCOD%type) is
        r_null BASIC_PKG.EMPRESA_typ;
        t      BASIC_PKG.EMPRESA_tab;
    begin
        BASIC_PKG.Consultar_EMPRESA(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_EMPRESA(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_EMPRESA;

    Procedure Fitxa_EMPRESA(r in BASIC_PKG.EMPRESA_typ, f_r in number default 0) is
    begin
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 117, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA EMPRESA', 65));
            Dbms_Output.PUT_LINE(rpad('*', 117, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || r.EMPCOD);
            Dbms_Output.PUT_LINE(rpad('NOM', 15, '.') || ': ' || r.EMPNOM);
            Dbms_Output.PUT_LINE(rpad('SECTOR', 15, '.') || ': ' || r.EMPSEC);
            Dbms_Output.PUT_LINE(rpad('TREBALLADORS', 15, '.') || ': ' || r.EMPTRE);
            Dbms_Output.PUT_LINE(rpad('TELEFON', 15, '.') || ': ' || r.EMPTEL);
            Dbms_Output.PUT_LINE(rpad('E-CORREU', 15, '.') || ': ' || r.EMPCOR);
            Dbms_Output.PUT_LINE(rpad('PAGINA WEB', 15, '.') || ': ' || r.EMPWEB);
            Dbms_Output.PUT_LINE(rpad('CONTACTE', 15, '.') || ': ' || r.EMPCON);
            Dbms_Output.PUT_LINE(rpad('*', 117, '*'));
        else
            Dbms_Output.PUT_LINE(rpad(r.EMPCOD, 10) || rpad(r.EMPNOM, 100));
            Dbms_Output.PUT_LINE('  ' || rpad(r.EMPSEC, 51) || rpad(r.EMPTRE, 10));
            Dbms_Output.PUT_LINE('  ' || rpad(r.EMPTEL, 10) || rpad(r.EMPCOR, 31) || rpad(r.EMPWEB, 30));
            Dbms_Output.PUT_LINE('  ' || rpad(r.EMPCON, 75));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_EMPRESA;

    Procedure Fitxa_ENTREVISTA(c in ENTREVISTA.ENTCOD%type) is
        r_null BASIC_PKG.ENTREVISTA_typ;
        t      BASIC_PKG.ENTREVISTA_tab;
    begin
        BASIC_PKG.Consultar_ENTREVISTA(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_ENTREVISTA(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_ENTREVISTA;

    Procedure Fitxa_ENTREVISTA(r in BASIC_PKG.ENTREVISTA_typ, f_r in number default 0) is
        d varchar(250);
        c BASIC_PKG.CONVOCATS_tab;
    begin
        d := Descriptor_OFERTATREBALL(r.OFECOD);
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 95, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA ENTREVISTA', 55));
            Dbms_Output.PUT_LINE(rpad('*', 95, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 10, '.') || ': ' || to_char(r.ENTCOD));
            if length(d) > 59 then
                Dbms_Output.PUT_LINE(rpad('OFERTA', 10, '.') || ': ' || rpad(r.OFECOD, 9) ||
                                     rpad(d, 56) || '...');
            else
                Dbms_Output.PUT_LINE(rpad('OFERTA', 10, '.') || ': ' || rpad(r.OFECOD, 9) || d);
            end if;
            Dbms_Output.PUT_LINE(rpad('DATA', 10, '.') || ': ' || to_char(r.ENTDATA,'DD/MM/YYYY'));
            Dbms_Output.PUT_LINE(rpad('CONVOCATS', 10, '.'));
            Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('NIF', 10) || rpad('NOM', 75));
            Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 9, '-') || ' ' || rpad('-', 75, '-'));
            BASIC_PKG.Consultar_CONVOCATS(c, r.ENTCOD, null);
            for i in 0..(c.count() - 1) loop
                Fitxa_CONVOCATS(c(i));
            end loop;

            Dbms_Output.PUT_LINE(rpad('*', 95, '*'));
        else
            if length(d) > 49 then
                Dbms_Output.PUT_LINE(rpad(r.ENTCOD, 10) || rpad(r.OFECOD, 10) || rpad(d, 46) || '...' || r.ENTDATA);
            else
                Dbms_Output.PUT_LINE(rpad(r.ENTCOD, 10) || rpad(r.OFECOD, 10) || rpad(d, 50) || r.ENTDATA);
            end if;
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_ENTREVISTA;

    Procedure Fitxa_ESPLOG(r in BASIC_PKG.ESPLOG_typ) is
    begin
        Dbms_Output.PUT_LINE(rpad(r.LOGCOD, 10) || rpad(r.USRCOD, 21) || rpad(to_char(r.LOGINICI,'DD/MM/YYYY HH24:MI:SS.FF3'), 25) ||
                             rpad(to_char(r.LOGFINAL,'DD/MM/YYYY HH24:MI:SS.FF3'), 25) || rpad(r.LOGACCIO, 101) || rpad(r.LOGRESULT, 100));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_ESPLOG;

    Procedure Fitxa_IDIOMES(c in IDIOMES.IDIOCOD%type) is
        r_null BASIC_PKG.IDIOMES_typ;
        t      BASIC_PKG.IDIOMES_tab;
    begin
        BASIC_PKG.Consultar_IDIOMES(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_IDIOMES(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_IDIOMES;

    Procedure Fitxa_IDIOMES(r in BASIC_PKG.IDIOMES_typ, f_r in number default 0) is
    begin
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 35, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA IDIOMES', 24));
            Dbms_Output.PUT_LINE(rpad('*', 35, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || to_char(r.IDIOCOD));
            Dbms_Output.PUT_LINE(rpad('DESCRIPCIO', 15, '.') || ': ' || r.IDIODESC);
            Dbms_Output.PUT_LINE(rpad('*', 35, '*'));
        else
            Dbms_Output.PUT_LINE(rpad(r.IDIOCOD, 10) || r.IDIODESC);
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_IDIOMES;

    Procedure Fitxa_INTERESSAT(r in BASIC_PKG.INTERESSAT_typ) is
    begin
        Dbms_Output.PUT_LINE(rpad(r.SOLCOD, 10) || Descriptor_SOLICITANT(r.SOLCOD));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_INTERESSAT;

    Procedure Fitxa_NIVELL(c in NIVELL.NIVCOD%type) is
        r_null BASIC_PKG.NIVELL_typ;
        t      BASIC_PKG.NIVELL_tab;
    begin
        BASIC_PKG.Consultar_NIVELL(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_NIVELL(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_NIVELL;

    Procedure Fitxa_NIVELL(r in BASIC_PKG.NIVELL_typ, f_r in number default 0) is
    begin
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA NIVELL', 38));
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || to_char(r.NIVCOD));
            Dbms_Output.PUT_LINE(rpad('DESCRIPCIO', 15, '.') || ': ' || r.NIVDESC);
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        else
            Dbms_Output.PUT_LINE(rpad(r.NIVCOD, 10) || r.NIVDESC);
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_NIVELL;

    Procedure Fitxa_OFERTATREBALL(c in OFERTATREBALL.OFECOD%type) is
        r_null BASIC_PKG.OFERTATREBALL_typ;
        t      BASIC_PKG.OFERTATREBALL_tab;
    begin
        BASIC_PKG.Consultar_OFERTATREBALL(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_OFERTATREBALL(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_OFERTATREBALL;

    Procedure Fitxa_OFERTATREBALL(r in BASIC_PKG.OFERTATREBALL_typ, f_r in number default 0) is
        tabtit BASIC_PKG.TITULACIOOT_tab;
        typtit BASIC_PKG.TITULACIOOT_typ;
        tabidi BASIC_PKG.IDIOMESOT_tab;
        typidi BASIC_PKG.IDIOMESOT_typ;
    begin
        BASIC_PKG.Consultar_TITULACIOOT(tabtit, r.OFECOD, typtit);
        BASIC_PKG.Consultar_IDIOMESOT(tabidi, r.OFECOD, typidi);
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA OFERTA DE TREBALL', 40));
            Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || to_char(r.OFECOD));
            Dbms_Output.PUT_LINE(rpad('EMPRESA', 15, '.') || ': ' || Descriptor_EMPRESA(r.EMPCOD));
            Dbms_Output.PUT_LINE(rpad('PERFIL', 15, '.') || ': ' || Descriptor_PERFIL(r.PERFCOD));
            if tabtit.count() > 0 then
                Dbms_Output.PUT_LINE(rpad('TITULACIO', 15, '.') || ': ' || Descriptor_TITULACIO(tabtit(0).TITCOD));
            end if;
            for i in 1..(tabtit.count() - 1) loop
                Dbms_Output.PUT_LINE(rpad(' ', 17) || Descriptor_TITULACIO(tabtit(i).TITCOD));
            end loop;
            Dbms_Output.PUT_LINE(rpad('CONTRACTE', 15, '.') || ': ' || Descriptor_TIPUSCONTRACTE(r.CTECOD));
            Dbms_Output.PUT_LINE(rpad('JORNADA', 15, '.') || ': ' || Descriptor_TIPUSJORNADA(r.TJOCOD));
            if tabidi.count() > 0 then
                Dbms_Output.PUT_LINE(rpad('IDIOMES', 15, '.') || ': ' || Descriptor_IDIOMES(tabidi(0).IDIOCOD));
            end if;
            for i in 1..(tabidi.count() - 1) loop
                Dbms_Output.PUT_LINE(rpad(' ', 17) || Descriptor_IDIOMES(tabidi(i).IDIOCOD));
            end loop;
            Dbms_Output.PUT_LINE(rpad('SUBCATEGORIA', 15, '.') || ': ' || Descriptor_SUBCATEGORIA(r.SCATCOD, 1));
            Dbms_Output.PUT_LINE(rpad('DESCRIPCIO', 15, '.') || ': ' || r.OTDESC);
            Dbms_Output.PUT_LINE(rpad('SOU MINIM', 15, '.') || ': ' || to_char(r.SOUMIN,'999G999G990D00U', 'NLS_NUMERIC_CHARACTERS = '',.'' '));
            Dbms_Output.PUT_LINE(rpad('SOU MAXIM', 15, '.') || ': ' || to_char(r.SOUMAX,'999G999G990D00U', 'NLS_NUMERIC_CHARACTERS = '',.'' '));
            Dbms_Output.PUT_LINE(rpad('DATA INICI', 15, '.') || ': ' || to_char(r.OFEINI, 'DD/MM/YYYY'));
            Dbms_Output.PUT_LINE(rpad('PRIORITAT', 15, '.') || ': ' || to_char(r.OFEDIES));
            Dbms_Output.PUT_LINE(rpad('COBERTA EN DATA', 15, '.') || ': ' || to_char(r.OFEFI, 'DD/MM/YYYY'));
            Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
        else
            Dbms_Output.PUT_LINE(rpad(r.OFECOD, 10) || rpad(Descriptor_EMPRESA(r.EMPCOD), 101) || rpad(Descriptor_PERFIL(r.PERFCOD), 51));
            Dbms_Output.PUT_LINE('   ' || rpad(Descriptor_TIPUSCONTRACTE(r.CTECOD), 51) || rpad(Descriptor_TIPUSJORNADA(r.TJOCOD), 51));
            Dbms_Output.PUT_LINE('   ' || rpad(Descriptor_SUBCATEGORIA(r.SCATCOD), 101));
            Dbms_Output.PUT_LINE('   ' || rpad(r.OTDESC, 250));
            Dbms_Output.PUT_LINE('   ' || rpad(to_char(r.SOUMIN,'999G999G990D00U', 'NLS_NUMERIC_CHARACTERS = '',.'''), 15) ||
                                 rpad(to_char(r.SOUMAX,'999G999G990D00U', 'NLS_NUMERIC_CHARACTERS = '',.'''), 15) ||
                                 rpad(to_char(r.OFEINI, 'DD/MM/YYYY'), 11) || rpad(to_char(r.OFEDIES), 4) ||
                                 rpad(to_char(r.OFEFI, 'DD/MM/YYYY'), 11));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_OFERTATREBALL;

    Procedure Fitxa_PERFIL(c in PERFIL.PERFCOD%type) is
        r_null BASIC_PKG.PERFIL_typ;
        t      BASIC_PKG.PERFIL_tab;
    begin
        BASIC_PKG.Consultar_PERFIL(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_PERFIL(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_PERFIL;

    Procedure Fitxa_PERFIL(r in BASIC_PKG.PERFIL_typ, f_r in number default 0) is
    begin
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA PERFIL', 38));
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || to_char(r.PERFCOD));
            Dbms_Output.PUT_LINE(rpad('DESCRIPCIO', 15, '.') || ': ' || r.PERFDESC);
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        else
            Dbms_Output.PUT_LINE(rpad(r.PERFCOD, 10) || r.PERFDESC);
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_PERFIL;

    Procedure Fitxa_REBUTJATS(r in BASIC_PKG.REBUTJATS_typ) is
    begin
        Dbms_Output.PUT_LINE(rpad(r.SOLCOD, 10) || Descriptor_SOLICITANT(r.SOLCOD));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_REBUTJATS;

    Procedure Fitxa_SOLICITANT(c in SOLICITANT.SOLCOD%type) is
        r_null BASIC_PKG.SOLICITANT_typ;
        t      BASIC_PKG.SOLICITANT_tab;
    begin
        BASIC_PKG.Consultar_SOLICITANT(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_SOLICITANT(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_SOLICITANT;

    Procedure Fitxa_SOLICITANT(r in BASIC_PKG.SOLICITANT_typ, f_r in number default 0) is
    begin
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA SOLICITANT', 68));
            Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || to_char(r.SOLCOD));
            Dbms_Output.PUT_LINE(rpad('NOM', 15, '.') || ': ' || r.SOLNOM);
            Dbms_Output.PUT_LINE(rpad('NIF', 15, '.') || ': ' || r.SOLNIF);
            Dbms_Output.PUT_LINE(rpad('DOMICILI', 15, '.') || ': ' || r.SOLDOM);
            Dbms_Output.PUT_LINE(rpad('TELEFON', 15, '.') || ': ' || r.SOLTEL);
            Dbms_Output.PUT_LINE(rpad('E-CORREU', 15, '.') || ': ' || r.SOLCOR);
            Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
        else
            if f_r = 1 then
                Dbms_Output.PUT_LINE(rpad(r.SOLCOD, 10) || rpad(r.SOLNOM, 76) || rpad(r.SOLNIF, 10) || rpad(r.SOLDOM, 101) ||
                                     rpad(r.SOLTEL, 10) || rpad(r.SOLCOR, 31));
            else
                Dbms_Output.PUT_LINE(rpad(r.SOLCOD, 10) || rpad(r.SOLNIF, 10) || rpad(r.SOLNOM, 75));
            end if;
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_SOLICITANT;

    Procedure Fitxa_SUBCATEGORIA(c in SUBCATEGORIA.SCATCOD%type) is
        r_null BASIC_PKG.SUBCATEGORIA_typ;
        t      BASIC_PKG.SUBCATEGORIA_tab;
    begin
        BASIC_PKG.Consultar_SUBCATEGORIA(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_SUBCATEGORIA(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_SUBCATEGORIA;

    Procedure Fitxa_SUBCATEGORIA(r in BASIC_PKG.SUBCATEGORIA_typ, f_r in number default 0) is
    begin
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA SUBCATEGORIA', 38));
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || to_char(r.SCATCOD));
            Dbms_Output.PUT_LINE(rpad('DESCRIPCIO', 15, '.') || ': ' || r.SCATDESC);
            Dbms_Output.PUT_LINE(rpad('CATEGORIA', 15, '.') || ': ' || Descriptor_CATEGORIA(r.CATCOD));
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        else
            Dbms_Output.PUT_LINE(rpad(r.SCATCOD, 10) || rpad(r.SCATDESC, 51) || Descriptor_CATEGORIA(r.CATCOD));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_SUBCATEGORIA;

    Procedure Fitxa_TIPUSCONTRACTE(c in TIPUSCONTRACTE.CTECOD%type) is
        r_null BASIC_PKG.TIPUSCONTRACTE_typ;
        t      BASIC_PKG.TIPUSCONTRACTE_tab;
    begin
        BASIC_PKG.Consultar_TIPUSCONTRACTE(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_TIPUSCONTRACTE(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_TIPUSCONTRACTE;

    Procedure Fitxa_TIPUSCONTRACTE(r in BASIC_PKG.TIPUSCONTRACTE_typ, f_r in number default 0) is
    begin
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA TIPUS DE CONTRACTE', 38));
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || to_char(r.CTECOD));
            Dbms_Output.PUT_LINE(rpad('DESCRIPCIO', 15, '.') || ': ' || r.CTEDESC);
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        else
            Dbms_Output.PUT_LINE(rpad(r.CTECOD, 10) || r.CTEDESC);
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_TIPUSCONTRACTE;

    Procedure Fitxa_TIPUSJORNADA(c in TIPUSJORNADA.TJOCOD%type) is
        r_null BASIC_PKG.TIPUSJORNADA_typ;
        t      BASIC_PKG.TIPUSJORNADA_tab;
    begin
        BASIC_PKG.Consultar_TIPUSJORNADA(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_TIPUSJORNADA(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_TIPUSJORNADA;

    Procedure Fitxa_TIPUSJORNADA(r in BASIC_PKG.TIPUSJORNADA_typ, f_r in number default 0) is
    begin
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA TIPUS DE CONTRACTE', 38));
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || to_char(r.TJOCOD));
            Dbms_Output.PUT_LINE(rpad('DESCRIPCIO', 15, '.') || ': ' || r.TJODESC);
            Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        else
            Dbms_Output.PUT_LINE(rpad(r.TJOCOD, 10) || r.TJODESC);
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_TIPUSJORNADA;

    Procedure Fitxa_TITULACIO(c in TITULACIO.TITCOD%type) is
        r_null BASIC_PKG.TITULACIO_typ;
        t      BASIC_PKG.TITULACIO_tab;
    begin
        BASIC_PKG.Consultar_TITULACIO(t, c, r_null);
        if t.count() <> 0 then
            Fitxa_TITULACIO(t(0));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_TITULACIO;

    Procedure Fitxa_TITULACIO(r in BASIC_PKG.TITULACIO_typ, f_r in number default 0) is
    begin
        if f_r = 0 then
            Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
            Dbms_Output.PUT_LINE(lpad('FITXA TITULACIO', 67));
            Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
            Dbms_Output.PUT_LINE(rpad('CODI', 15, '.') || ': ' || to_char(r.TITCOD));
            Dbms_Output.PUT_LINE(rpad('DESCRIPCIO', 15, '.') || ': ' || r.TITDESC);
            Dbms_Output.PUT_LINE(rpad('NIVELL', 15, '.') || ': ' || Descriptor_NIVELL(r.NIVCOD));
            Dbms_Output.PUT_LINE(rpad('*', 120, '*'));
        else
            Dbms_Output.PUT_LINE(rpad(r.TITCOD, 10) || rpad(r.TITDESC, 101) || Descriptor_NIVELL(r.NIVCOD));
        end if;
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Fitxa_TITULACIO;

    /* Llistes del contingut de les taules*/
    Procedure Llista_CATEGORIA is
        r_null BASIC_PKG.CATEGORIA_typ;
        t      BASIC_PKG.CATEGORIA_tab;
    begin
        BASIC_PKG.Consultar_CATEGORIA(t, null, r_null);
        Llista_CATEGORIA(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_CATEGORIA;

    Procedure Llista_CATEGORIA(t in BASIC_PKG.CATEGORIA_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA DE CATEGORIES', 40));
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || 'DESCRIPCIO');
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 50, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_CATEGORIA(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_CATEGORIA;

    Procedure Llista_CONVOCATS is
        r_null BASIC_PKG.CONVOCATS_typ;
        t      BASIC_PKG.CONVOCATS_tab;
    begin
        BASIC_PKG.Consultar_CONVOCATS(t, null, r_null);
        Llista_CONVOCATS(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_CONVOCATS;

    Procedure Llista_CONVOCATS(t in BASIC_PKG.CONVOCATS_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 95, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA DE CONVOCATS', 57));
        Dbms_Output.PUT_LINE(rpad('*', 95, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('NIF', 10) || rpad('NOM', 75));
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 9, '-') || ' ' || rpad('-', 75, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_CONVOCATS(t(i));
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 95, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_CONVOCATS;

    Procedure Llista_DEMANDAFEINA is
        r_null BASIC_PKG.DEMANDAFEINA_typ;
        t      BASIC_PKG.DEMANDAFEINA_tab;
    begin
        BASIC_PKG.Consultar_DEMANDAFEINA(t, null, r_null);
        Llista_DEMANDAFEINA(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_DEMANDAFEINA;

    Procedure Llista_DEMANDAFEINA(t in BASIC_PKG.DEMANDAFEINA_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 137, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA DE DEMANDES DE FEINA', 82));
        Dbms_Output.PUT_LINE(rpad('*', 137, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('SOLLICITANT', 76) || rpad('PERFIL', 50));
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 75, '-') || ' ' || rpad('-', 50, '-'));
        Dbms_Output.PUT_LINE(rpad('  ' || 'SUBCATEGORIA', 100));
        Dbms_Output.PUT_LINE(rpad('  ' || '-', 100, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_DEMANDAFEINA(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 137, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_DEMANDAFEINA;

    Procedure Llista_EMPRESA is
        r_null BASIC_PKG.EMPRESA_typ;
        t      BASIC_PKG.EMPRESA_tab;
    begin
        BASIC_PKG.Consultar_EMPRESA(t, null, r_null);
        Llista_EMPRESA(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_EMPRESA;

    Procedure Llista_EMPRESA(t in BASIC_PKG.EMPRESA_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 110, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA D''EMPRESES', 63));
        Dbms_Output.PUT_LINE(rpad('*', 110, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('NOM', 100));
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 100, '-'));
        Dbms_Output.PUT_LINE('  ' || rpad('SECTOR', 51) || rpad('TREBALLADORS', 10));
        Dbms_Output.PUT_LINE('  ' || rpad('-', 50, '-') || ' ' || rpad('-', 10, '-'));
        Dbms_Output.PUT_LINE('  ' || rpad('TELEFON', 10) || rpad('E-CORREU', 31) || rpad('PAGINA WEB', 31));
        Dbms_Output.PUT_LINE('  ' || rpad('-', 9, '-') || ' ' || rpad('-', 30, '-') || ' ' || rpad('-', 30, '-'));
        Dbms_Output.PUT_LINE('  ' || rpad('CONTACTE', 75));
        Dbms_Output.PUT_LINE('  ' || rpad('-', 75, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_EMPRESA(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 110, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_EMPRESA;

    Procedure Llista_ENTREVISTA is
        r_null BASIC_PKG.ENTREVISTA_typ;
        t      BASIC_PKG.ENTREVISTA_tab;
    begin
        BASIC_PKG.Consultar_ENTREVISTA(t, null, r_null);
        Llista_ENTREVISTA(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_ENTREVISTA;

    Procedure Llista_ENTREVISTA(t in BASIC_PKG.ENTREVISTA_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 80, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA D''ENTREVISTES', 50));
        Dbms_Output.PUT_LINE(rpad('*', 80, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('OFERTA', 60) || rpad('DATA', 10));
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 59, '-') || ' ' || rpad('-', 9, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_ENTREVISTA(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 80, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_ENTREVISTA;

    Procedure Llista_ESPLOG is
        r_null BASIC_PKG.ESPLOG_typ;
        t      BASIC_PKG.ESPLOG_tab;
    begin
        BASIC_PKG.Consultar_ESPLOG(t, null, r_null);
        Llista_ESPLOG(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_ESPLOG;

    Procedure Llista_ESPLOG(t in BASIC_PKG.ESPLOG_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 272, '*'));
        Dbms_Output.PUT_LINE(lpad('LOG DEL SISTEMA', 143));
        Dbms_Output.PUT_LINE(rpad('*', 272, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('USUARI', 21) || rpad('INICI', 25) ||
                             rpad('FINAL', 25) || rpad('ACCIO', 101) || rpad('RESULTAT', 100));
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 20, '-') || ' ' || rpad('-', 24, '-')
                             || ' ' || rpad('-', 24, '-') || ' ' || rpad('-', 100, '-') || ' ' || rpad('-', 100, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_ESPLOG(t(i));
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 272, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_ESPLOG;

    Procedure Llista_IDIOMES is
        r_null BASIC_PKG.IDIOMES_typ;
        t      BASIC_PKG.IDIOMES_tab;
    begin
        BASIC_PKG.Consultar_IDIOMES(t, null, r_null);
        Llista_IDIOMES(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_IDIOMES;

    Procedure Llista_IDIOMES(t in BASIC_PKG.IDIOMES_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 35, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA D''IDIOMES', 26));
        Dbms_Output.PUT_LINE(rpad('*', 35, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('DESCRIPCIO', 20));
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 20, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_IDIOMES(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 35, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_IDIOMES;

    Procedure Llista_INTERESSAT is
        r_null BASIC_PKG.INTERESSAT_typ;
        t      BASIC_PKG.INTERESSAT_tab;
    begin
        BASIC_PKG.Consultar_INTERESSAT(t, null, r_null);
        Llista_INTERESSAT(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_INTERESSAT;

    Procedure Llista_INTERESSAT(t in BASIC_PKG.INTERESSAT_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 85, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA D''INTERESSATS', 52));
        Dbms_Output.PUT_LINE(rpad('*', 85, '*'));
        Dbms_Output.PUT_LINE(rpad('EMPRESA', 10) || rpad(t(0).EMPCOD, 20));
        Dbms_Output.PUT_LINE(rpad(' ', 10) || Descriptor_EMPRESA(t(0).EMPCOD));
        Dbms_Output.PUT_LINE('SOLICITANTS');
        Dbms_Output.PUT_LINE(rpad('-', 85, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_INTERESSAT(t(i));
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 85, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_INTERESSAT;

    Procedure Llista_NIVELL is
        r_null BASIC_PKG.NIVELL_typ;
        t      BASIC_PKG.NIVELL_tab;
    begin
        BASIC_PKG.Consultar_NIVELL(t, null, r_null);
        Llista_NIVELL(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_NIVELL;

    Procedure Llista_NIVELL(t in BASIC_PKG.NIVELL_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA DE NIVELLS', 41));
        Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('DESCRIPCIO', 50));
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 50, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_NIVELL(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_NIVELL;

    Procedure Llista_OFERTATREBALL is
        r_null BASIC_PKG.OFERTATREBALL_typ;
        t      BASIC_PKG.OFERTATREBALL_tab;
    begin
        BASIC_PKG.Consultar_OFERTATREBALL_Activa(t, null, r_null);
        Llista_OFERTATREBALL(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_OFERTATREBALL;

    Procedure Llista_OFERTATREBALL(t in BASIC_PKG.OFERTATREBALL_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 250, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA D''OFERTES DE TREBALL', 139));
        Dbms_Output.PUT_LINE(rpad('*', 250, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('EMPRESA', 101) || rpad('PERFIL', 51));
        Dbms_Output.PUT_LINE('   ' || rpad('CONTRACTE', 51) || rpad('JORNADA', 51));
        Dbms_Output.PUT_LINE('   ' || rpad('SUBCATEGORIA', 101));
        Dbms_Output.PUT_LINE('   ' || rpad('DESCRIPCIO', 251));
        Dbms_Output.PUT_LINE('   ' || rpad('SOU MINIM', 15) || rpad('SOU MAXIM', 15) || rpad('DATA INICI', 11) ||
                                      rpad('PRI', 4) || rpad('COBERTURA', 11));
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 100, '-') || ' ' || rpad('-', 9, '-'));
        Dbms_Output.PUT_LINE('   ' || rpad('-', 50, '-') || ' ' || rpad('-', 50, '-'));
        Dbms_Output.PUT_LINE('   ' || rpad('-', 100, '-'));
        Dbms_Output.PUT_LINE('   ' || rpad('-', 250, '-'));
        Dbms_Output.PUT_LINE('   ' || rpad('-', 14, '-') || ' ' || rpad('-', 14, '-') || ' ' || rpad('-', 10, '-') ||
                                      ' ' || rpad('-', 3, '-') || ' ' || rpad('-', 10, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_OFERTATREBALL(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 250, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_OFERTATREBALL;

    Procedure Llista_PERFIL is
        r_null BASIC_PKG.PERFIL_typ;
        t      BASIC_PKG.PERFIL_tab;
    begin
        BASIC_PKG.Consultar_PERFIL(t, null, r_null);
        Llista_PERFIL(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_PERFIL;

    Procedure Llista_PERFIL(t in BASIC_PKG.PERFIL_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA DE PERFILS', 41));
        Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('DESCRIPCIO', 50));
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 50, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_PERFIL(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 65, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_PERFIL;

    Procedure Llista_REBUTJATS is
        r_null BASIC_PKG.REBUTJATS_typ;
        t      BASIC_PKG.REBUTJATS_tab;
    begin
        BASIC_PKG.Consultar_REBUTJATS(t, null, r_null);
        Llista_REBUTJATS(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_REBUTJATS;

    Procedure Llista_REBUTJATS(t in BASIC_PKG.REBUTJATS_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 85, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA DE REBUTJATS', 52));
        Dbms_Output.PUT_LINE(rpad('*', 85, '*'));
        Dbms_Output.PUT_LINE(rpad('EMPRESA', 10) || rpad(t(0).EMPCOD, 20));
        Dbms_Output.PUT_LINE(rpad(' ', 10) || Descriptor_EMPRESA(t(0).EMPCOD));
        Dbms_Output.PUT_LINE('SOLICITANTS');
        Dbms_Output.PUT_LINE(rpad('-', 85, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_REBUTJATS(t(i));
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 85, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_REBUTJATS;

    Procedure Llista_SOLICITANT is
        r_null BASIC_PKG.SOLICITANT_typ;
        t      BASIC_PKG.SOLICITANT_tab;
    begin
        BASIC_PKG.Consultar_SOLICITANT(t, null, r_null);
        Llista_SOLICITANT(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_SOLICITANT;

    Procedure Llista_SOLICITANT(t in BASIC_PKG.SOLICITANT_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 235, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA DE SOLICITANT', 127));
        Dbms_Output.PUT_LINE(rpad('*', 235, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('NOM', 76) || rpad('NIF', 10) || rpad('DOMICILI', 101)
                             || rpad('TELEFON', 10) || rpad('E-CORREU', 31));
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 75, '-') || ' ' || rpad('-', 9, '-') || ' ' ||
                             rpad('-', 100, '-') || ' ' || rpad('-', 9, '-') || ' ' || rpad('-', 30, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_SOLICITANT(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 235, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_SOLICITANT;

    Procedure Llista_SUBCATEGORIA is
        r_null BASIC_PKG.SUBCATEGORIA_typ;
        t      BASIC_PKG.SUBCATEGORIA_tab;
    begin
        BASIC_PKG.Consultar_SUBCATEGORIA(t, null, r_null);
        Llista_SUBCATEGORIA(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_SUBCATEGORIA;

    Procedure Llista_SUBCATEGORIA(t in BASIC_PKG.SUBCATEGORIA_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA DE SUBCATEGORIES', 38));
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('DESCRIPCIO', 51) || 'CATEGORIA');
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 50, '-') || ' ' || rpad('-', 50, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_SUBCATEGORIA(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_SUBCATEGORIA;

    Procedure Llista_TIPUSCONTRACTE is
        r_null BASIC_PKG.TIPUSCONTRACTE_typ;
        t      BASIC_PKG.TIPUSCONTRACTE_tab;
    begin
        BASIC_PKG.Consultar_TIPUSCONTRACTE(t, null, r_null);
        Llista_TIPUSCONTRACTE(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_TIPUSCONTRACTE;

    Procedure Llista_TIPUSCONTRACTE(t in BASIC_PKG.TIPUSCONTRACTE_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA DE TIPUS DE CONTRACTES', 15));
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || 'DESCRIPCIO');
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 50, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_TIPUSCONTRACTE(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_TIPUSCONTRACTE;

    Procedure Llista_TIPUSJORNADA is
        r_null BASIC_PKG.TIPUSJORNADA_typ;
        t      BASIC_PKG.TIPUSJORNADA_tab;
    begin
        BASIC_PKG.Consultar_TIPUSJORNADA(t, null, r_null);
        Llista_TIPUSJORNADA(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_TIPUSJORNADA;

    Procedure Llista_TIPUSJORNADA(t in BASIC_PKG.TIPUSJORNADA_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA DE TIPUS DE JORNADA', 17));
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || 'DESCRIPCIO');
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 50, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_TIPUSJORNADA(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 60, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_TIPUSJORNADA;

    Procedure Llista_TITULACIO is
        r_null BASIC_PKG.TITULACIO_typ;
        t      BASIC_PKG.TITULACIO_tab;
    begin
        BASIC_PKG.Consultar_TITULACIO(t, null, r_null);
        Llista_TITULACIO(t);
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_TITULACIO;

    Procedure Llista_TITULACIO(t in BASIC_PKG.TITULACIO_tab) is
    begin
        Dbms_Output.PUT_LINE(rpad('*', 160, '*'));
        Dbms_Output.PUT_LINE(lpad('LLISTA DE TITULACIONS', 90));
        Dbms_Output.PUT_LINE(rpad('*', 160, '*'));
        Dbms_Output.PUT_LINE(rpad('CODI', 10) || rpad('DESCRIPCIO', 101) || 'NIVELL');
        Dbms_Output.PUT_LINE(rpad('-', 9, '-') || ' ' || rpad('-', 100, '-') || ' ' || rpad('-', 50, '-'));
        for i in 0..(t.count() - 1) loop
            Fitxa_TITULACIO(t(i), 1);
        end loop;
        Dbms_Output.PUT_LINE(rpad('*', 160, '*'));
        exception
            when others then
                DBMS_Output.PUT_LINE(sqlerrm);
    end Llista_TITULACIO;

    /* Procediments per a la consulta del magatzem de dades*/
    Procedure ConsultaMagatzemDades is
        cursor c is
            select t.NANY ANY_, t.MES MES_, p.PERFDESC PERFIL, s.CATDESC ||  ' - ' || s.SCATDESC SUBCATEGORIA,
                   c.CTEDESC CONTRACTE, j.TJODESC JORNADA, o.DIESCOBERTURA, o.OFERTESENTEMPS, o.OFERTESCOBERTES,
                   o.SALARI / o.OFERTESCOBERTES MSALARI
            from DWOFERTESTREBALL o, DWTEMPS t, DWPERFIL p, DWSUBCATEGORIA s, DWTIPUSCONTRACTE c, DWTIPUSJORNADA j
            where o.IDTEMPS = t.IDTEMPS          and
                  o.PERFCOD = p.PERFCOD          and
                  o.SCATCOD = s.SCATCOD          and
                  o.CTECOD  = c.CTECOD           and
                  o.TJOCOD  = j.TJOCOD
            order by t.NANY, t.MES, p.PERFDESC, s.CATDESC, s.SCATDESC, c.CTEDESC, j.TJODESC;
    begin
        Dbms_Output.PUT_LINE(rpad('ANY', 5) || rpad('MES', 5) || rpad('PERFIL', 51) ||
                             rpad('SUBCATEGORIA', 51) || rpad('CONTRACTE', 51) || rpad('JORNADA', 21) ||
                             rpad('DIES COBERTURA', 15) || rpad('EN TEMPS', 9) || rpad('COBERTES', 9) ||
                             rpad('SALARI', 16));
        Dbms_Output.PUT_LINE(rpad('-', 4, '-') || ' ' || rpad('-', 4,'-') || ' ' || rpad('-', 50, '-') || ' ' ||
                             rpad('-', 50, '-') || ' ' || rpad('-', 50, '-') || ' ' || rpad('-', 20, '-') || ' ' ||
                             rpad('-', 14, '-') || ' ' || rpad('-', 8, '-') || ' ' || rpad('-', 8, '-') || ' ' ||
                             rpad('-', 15, '-'));
        for r in c loop
            Dbms_Output.PUT_LINE(lpad(r.ANY_, 4) || ' ' || lpad(r.MES_, 4) || ' ' || rpad(r.PERFIL, 51) ||
                                 rpad(r.SUBCATEGORIA, 51) || rpad(r.CONTRACTE, 51) || rpad(r.JORNADA, 21) ||
                                 lpad(r.DIESCOBERTURA, 14) || ' ' || lpad(r.OFERTESENTEMPS, 8) || ' ' ||
                                 lpad(r.OFERTESCOBERTES, 8) || ' ' ||
                                 lpad(to_char(r.MSALARI,'999G999G990D00U', 'NLS_NUMERIC_CHARACTERS = '',.'' '), 15));
        end loop;
    end ConsultaMagatzemDades;

    Procedure ConsultaMagatzemDades(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type) is
        cursor c is
            select t.NANY ANY_, t.MES MES_, p.PERFDESC PERFIL, s.CATDESC ||  ' - ' || s.SCATDESC SUBCATEGORIA,
                   c.CTEDESC CONTRACTE, j.TJODESC JORNADA, o.DIESCOBERTURA, o.OFERTESENTEMPS, o.OFERTESCOBERTES,
                   o.SALARI / o.OFERTESCOBERTES MSALARI
            from DWOFERTESTREBALL o, DWTEMPS t, DWPERFIL p, DWSUBCATEGORIA s, DWTIPUSCONTRACTE c, DWTIPUSJORNADA j
            where o.IDTEMPS = t.IDTEMPS          and
                  o.PERFCOD = p.PERFCOD          and
                  o.SCATCOD = s.SCATCOD          and
                  o.CTECOD  = c.CTECOD           and
                  o.TJOCOD  = j.TJOCOD           and
                  t.NANY    = nvl(p_any, t.NANY) and
                  t.MES     = nvl(p_mes, t.MES)
            order by t.NANY, t.MES, p.PERFDESC, s.CATDESC, s.SCATDESC, c.CTEDESC, j.TJODESC;
    begin
        Dbms_Output.PUT_LINE(rpad('ANY', 5) || rpad('MES', 5) || rpad('PERFIL', 51) ||
                             rpad('SUBCATEGORIA', 51) || rpad('CONTRACTE', 51) || rpad('JORNADA', 21) ||
                             rpad('DIES COBERTURA', 15) || rpad('EN TEMPS', 9) || rpad('COBERTES', 9) ||
                             rpad('SALARI', 16));
        Dbms_Output.PUT_LINE(rpad('-', 4, '-') || ' ' || rpad('-', 4,'-') || ' ' || rpad('-', 50, '-') || ' ' ||
                             rpad('-', 50, '-') || ' ' || rpad('-', 50, '-') || ' ' || rpad('-', 20, '-') || ' ' ||
                             rpad('-', 14, '-') || ' ' || rpad('-', 8, '-') || ' ' || rpad('-', 8, '-') || ' ' ||
                             rpad('-', 15, '-'));
        for r in c loop
            Dbms_Output.PUT_LINE(lpad(r.ANY_, 4) || ' ' || lpad(r.MES_, 4) || ' ' || rpad(r.PERFIL, 51) ||
                                 rpad(r.SUBCATEGORIA, 51) || rpad(r.CONTRACTE, 51) || rpad(r.JORNADA, 21) ||
                                 lpad(r.DIESCOBERTURA, 14) || ' ' || lpad(r.OFERTESENTEMPS, 8) || ' ' ||
                                 lpad(r.OFERTESCOBERTES, 8) || ' ' ||
                                 lpad(to_char(r.MSALARI,'999G999G990D00U', 'NLS_NUMERIC_CHARACTERS = '',.'' '), 15));
        end loop;
    end ConsultaMagatzemDades;

    Procedure ConsultaDWTempsCobertura is
        cursor c is
            select t.NANY ANY_, t.MES MES_, sum(o.DIESCOBERTURA) DIES, sum(o.OFERTESENTEMPS) OFERTES,
                   sum(o.OFERTESCOBERTES) COBERTES, (sum(o.DIESCOBERTURA) / sum(o.OFERTESCOBERTES)) MITJANA,
                   (sum(o.OFERTESENTEMPS) / sum(o.OFERTESCOBERTES)) * 100 PROPORCIO
            from DWOFERTESTREBALL o, DWTEMPS t
            where o.IDTEMPS = t.IDTEMPS
            group by t.NANY, t.MES
            order by t.NANY, t.MES;
    begin
        Dbms_Output.PUT_LINE(rpad('ANY', 5) || rpad('MES', 5) || rpad('DIES COBERTURA', 15) || rpad('COBERTES EN TEMPS', 18) ||
                             rpad('COBERTES TOTAL', 15) || rpad('MITJANA', 14) || rpad('EN TEMPS / TOTAL', 17));
        Dbms_Output.PUT_LINE(rpad('-', 4, '-') || ' ' || rpad('-', 4,'-') || ' ' || rpad('-', 14, '-') || ' ' || rpad('-', 17, '-') || ' ' ||
                             rpad('-', 14, '-') || ' ' || rpad('-', 13, '-') || ' ' || rpad('-', 17, '-'));
        for r in c loop
            Dbms_Output.PUT_LINE(lpad(r.ANY_, 4) || ' ' || lpad(r.MES_, 4) || ' ' || lpad(r.DIES, 14) || ' ' ||
                                 lpad(r.OFERTES, 17) || ' ' || lpad(r.COBERTES, 14) || ' ' ||
                                 lpad(to_char(r.MITJANA,'990D00', 'NLS_NUMERIC_CHARACTERS = '',.'' '), 8) || ' dies' || ' ' ||
                                 lpad(to_char(r.PROPORCIO,'990D00', 'NLS_NUMERIC_CHARACTERS = '',.'' '), 16) || '%' );
        end loop;
    end ConsultaDWTempsCobertura;

    Procedure ConsultaDWTempsCobertura(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type) is
        cursor c is
            select t.NANY ANY_, t.MES MES_, sum(o.DIESCOBERTURA) DIES, sum(o.OFERTESENTEMPS) OFERTES,
                   sum(o.OFERTESCOBERTES) COBERTES, sum(o.DIESCOBERTURA) / sum(o.OFERTESCOBERTES) MITJANA,
                   sum(o.OFERTESENTEMPS) / sum(o.OFERTESCOBERTES) PROPORCIO
            from DWOFERTESTREBALL o, DWTEMPS t
            where o.IDTEMPS = t.IDTEMPS          and
                  t.NANY    = nvl(p_any, t.NANY) and
                  t.MES     = nvl(p_mes, t.MES)
            group by t.NANY, t.MES
            order by t.NANY, t.MES;
    begin
        Dbms_Output.PUT_LINE(rpad('ANY', 5) || rpad('MES', 5) || rpad('DIES COBERTURA', 15) || rpad('COBERTES EN TEMPS', 18) ||
                             rpad('COBERTES TOTAL', 15) || rpad('MITJANA', 14) || rpad('EN TEMPS / TOTAL', 17));
        Dbms_Output.PUT_LINE(rpad('-', 4, '-') || ' ' || rpad('-', 4,'-') || ' ' || rpad('-', 14, '-') || ' ' || rpad('-', 17, '-') || ' ' ||
                             rpad('-', 14, '-') || ' ' || rpad('-', 13, '-') || ' ' || rpad('-', 17, '-'));
        for r in c loop
            Dbms_Output.PUT_LINE(lpad(r.ANY_, 4) || ' ' || lpad(r.MES_, 4) || ' ' || lpad(r.DIES, 14) || ' ' ||
                                 lpad(r.OFERTES, 17) || ' ' || lpad(r.COBERTES, 14) || ' ' ||
                                 lpad(to_char(r.MITJANA,'990D00', 'NLS_NUMERIC_CHARACTERS = '',.'' '), 8) || ' dies' || ' ' ||
                                 lpad(to_char(r.PROPORCIO,'990D00', 'NLS_NUMERIC_CHARACTERS = '',.'' '), 16) || '%' );
        end loop;
    end ConsultaDWTempsCobertura;

    Procedure ConsultaDWMitjanaDiesPerfil is
        cursor c is
            select t.NANY ANY_, t.MES MES_, p.PERFDESC PERFIL, sum(o.DIESCOBERTURA) DIES, sum(o.OFERTESCOBERTES) OFERTES,
                   (sum(o.DIESCOBERTURA) / sum(o.OFERTESCOBERTES)) MITJANA
            from DWOFERTESTREBALL o, DWTEMPS t, DWPERFIL p
            where o.IDTEMPS = t.IDTEMPS and
                  o.PERFCOD = p.PERFCOD
            group by t.NANY, t.MES, p.PERFDESC
            order by t.NANY, t.MES, p.PERFDESC;
    begin
        Dbms_Output.PUT_LINE(rpad('ANY', 5) || rpad('MES', 5) || rpad('PERFIL', 51) || rpad('DIES COBERTURA', 15) ||
                             rpad('OFERTES COBERTES', 17) || rpad('MITJANA', 15));
        Dbms_Output.PUT_LINE(rpad('-', 4, '-') || ' ' || rpad('-', 4,'-') || ' ' || rpad('-', 50,'-') || ' ' ||
                             rpad('-', 14, '-') || ' ' || rpad('-', 16, '-') || ' ' || rpad('-', 14, '-'));
        for r in c loop
            Dbms_Output.PUT_LINE(lpad(r.ANY_, 4) || ' ' || lpad(r.MES_, 4) || ' ' || rpad(r.PERFIL, 50) || ' ' ||
                                 lpad(r.DIES, 14) || ' ' || lpad(r.OFERTES, 17) || ' ' ||
                                 lpad(to_char(r.MITJANA,'990D00', 'NLS_NUMERIC_CHARACTERS = '',.'' '), 8) || ' dies');
        end loop;
    end ConsultaDWMitjanaDiesPerfil;

    Procedure ConsultaDWMitjanaDiesPerfil(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type) is
        cursor c is
            select t.NANY ANY_, t.MES MES_, p.PERFDESC PERFIL, sum(o.DIESCOBERTURA) DIES, sum(o.OFERTESCOBERTES) OFERTES,
                   sum(o.DIESCOBERTURA) / sum(o.OFERTESCOBERTES) MITJANA
            from DWOFERTESTREBALL o, DWTEMPS t, DWPERFIL p
            where o.IDTEMPS = t.IDTEMPS          and
                  o.PERFCOD = p.PERFCOD          and
                  t.NANY    = nvl(p_any, t.NANY) and
                  t.MES     = nvl(p_mes, t.MES)
            group by t.NANY, t.MES, p.PERFDESC
            order by t.NANY, t.MES, p.PERFDESC;
    begin
        Dbms_Output.PUT_LINE(rpad('ANY', 5) || rpad('MES', 5) || rpad('PERFIL', 51) || rpad('DIES COBERTURA', 15) ||
                             rpad('OFERTES COBERTES', 17) || rpad('MITJANA', 15));
        Dbms_Output.PUT_LINE(rpad('-', 4, '-') || ' ' || rpad('-', 4,'-') || ' ' || rpad('-', 50,'-') || ' ' ||
                             rpad('-', 14, '-') || ' ' || rpad('-', 16, '-') || ' ' || rpad('-', 14, '-'));
        for r in c loop
            Dbms_Output.PUT_LINE(lpad(r.ANY_, 4) || ' ' || lpad(r.MES_, 4) || ' ' || rpad(r.PERFIL, 50) || ' ' ||
                                 lpad(r.DIES, 14) || ' ' || lpad(r.OFERTES, 17) || ' ' ||
                                 lpad(to_char(r.MITJANA,'990D00', 'NLS_NUMERIC_CHARACTERS = '',.'' '), 8) || ' dies');
        end loop;
    end ConsultaDWMitjanaDiesPerfil;

    Procedure ConsultaDWMitjanaSalariPerfil is
        cursor c is
            select t.NANY ANY_, t.MES MES_, p.PERFDESC PERFIL, sum(o.OFERTESCOBERTES) OFERTES,
                   sum(o.SALARI) / sum(o.OFERTESCOBERTES) MITJANA
            from DWOFERTESTREBALL o, DWTEMPS t, DWPERFIL p
            where o.IDTEMPS = t.IDTEMPS and
                  o.PERFCOD = p.PERFCOD
            group by t.NANY, t.MES, p.PERFDESC
            order by t.NANY, t.MES, p.PERFDESC;
    begin
        Dbms_Output.PUT_LINE(rpad('ANY', 5) || rpad('MES', 5) || rpad('PERFIL', 51) || rpad('O. COBERTES', 12) ||
                             rpad('SOU MIG', 15));
        Dbms_Output.PUT_LINE(rpad('-', 4, '-') || ' ' || rpad('-', 4,'-') || ' ' || rpad('-', 50,'-') || ' ' ||
                             rpad('-', 11, '-') || ' ' || rpad('-', 15, '-'));
        for r in c loop
            Dbms_Output.PUT_LINE(lpad(r.ANY_, 4) || ' ' || lpad(r.MES_, 4) || ' ' || rpad(r.PERFIL, 50) || ' ' ||
                                 lpad(r.OFERTES, 11) || ' ' ||
                                 lpad(to_char(r.MITJANA,'999G999G990D00U', 'NLS_NUMERIC_CHARACTERS = '',.'' '), 15));
        end loop;
    end ConsultaDWMitjanaSalariPerfil;

    Procedure ConsultaDWMitjanaSalariPerfil(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type) is
        cursor c is
            select t.NANY ANY_, t.MES MES_, p.PERFDESC PERFIL, sum(o.OFERTESCOBERTES) OFERTES,
                   sum(o.SALARI) / sum(o.OFERTESCOBERTES) MITJANA
            from DWOFERTESTREBALL o, DWTEMPS t, DWPERFIL p
            where o.IDTEMPS = t.IDTEMPS          and
                  o.PERFCOD = p.PERFCOD          and
                  t.NANY    = nvl(p_any, t.NANY) and
                  t.MES     = nvl(p_mes, t.MES)
            group by t.NANY, t.MES, p.PERFDESC
            order by t.NANY, t.MES, p.PERFDESC;
    begin
        Dbms_Output.PUT_LINE(rpad('ANY', 5) || rpad('MES', 5) || rpad('PERFIL', 51) || rpad('O. COBERTES', 12) ||
                             rpad('SOU MIG', 15));
        Dbms_Output.PUT_LINE(rpad('-', 4, '-') || ' ' || rpad('-', 4,'-') || ' ' || rpad('-', 50,'-') || ' ' ||
                             rpad('-', 11, '-') || ' ' || rpad('-', 15, '-'));
        for r in c loop
            Dbms_Output.PUT_LINE(lpad(r.ANY_, 4) || ' ' || lpad(r.MES_, 4) || ' ' || rpad(r.PERFIL, 50) || ' ' ||
                                 lpad(r.OFERTES, 11) || ' ' ||
                                 lpad(to_char(r.MITJANA,'999G999G990D00U', 'NLS_NUMERIC_CHARACTERS = '',.'' '), 15));
        end loop;
    end ConsultaDWMitjanaSalariPerfil;

    /* Funcions per a l'obtenci del descriptor d'un tipus */
    Function Descriptor_CATEGORIA(c in CATEGORIA.CATCOD%type) return varchar is
      t BASIC_PKG.CATEGORIA_tab;
    begin
        BASIC_PKG.Consultar_CATEGORIA(t, c, null);
        return t(0).CATDESC;
    end Descriptor_CATEGORIA;

    Function Descriptor_EMPRESA(c in EMPRESA.EMPCOD%type) return varchar is
        t BASIC_PKG.EMPRESA_tab;
    begin
        BASIC_PKG.Consultar_EMPRESA(t, c, null);
        return t(0).EMPNOM;
    end Descriptor_EMPRESA;

    Function Descriptor_IDIOMES(c in IDIOMES.IDIOCOD%type) return varchar is
        t BASIC_PKG.IDIOMES_tab;
    begin
        BASIC_PKG.Consultar_IDIOMES(t, c, null);
        return t(0).IDIODESC;
    end Descriptor_IDIOMES;

    Function Descriptor_NIVELL(c in NIVELL.NIVCOD%type) return varchar is
        t BASIC_PKG.NIVELL_tab;
    begin
        BASIC_PKG.Consultar_NIVELL(t, c, null);
        return t(0).NIVDESC;
    end Descriptor_NIVELL;

    Function Descriptor_OFERTATREBALL(c in OFERTATREBALL.OFECOD%type) return varchar is
        t BASIC_PKG.OFERTATREBALL_tab;
    begin
        BASIC_PKG.Consultar_OFERTATREBALL(t, c, null);
        return t(0).OTDESC;
    end Descriptor_OFERTATREBALL;

    Function Descriptor_PERFIL(c in PERFIL.PERFCOD%type) return varchar is
        t BASIC_PKG.PERFIL_tab;
    begin
        BASIC_PKG.Consultar_PERFIL(t, c, null);
        return t(0).PERFDESC;
    end Descriptor_PERFIL;

    Function Descriptor_SOLICITANT(c in SOLICITANT.SOLCOD%type) return varchar is
        t BASIC_PKG.SOLICITANT_tab;
    begin
        BASIC_PKG.Consultar_SOLICITANT(t, c, null);
        return t(0).SOLNOM;
    end Descriptor_SOLICITANT;

    Function Descriptor_SUBCATEGORIA(c in SUBCATEGORIA.SCATCOD%type, f in number default 0) return varchar is
        t BASIC_PKG.SUBCATEGORIA_tab;
    begin
        BASIC_PKG.Consultar_SUBCATEGORIA(t, c, null);
        if f = 0 then
            return t(0).SCATDESC;
        else
            return trim(Descriptor_CATEGORIA(t(0).CATCOD)) || ' - ' || t(0).SCATDESC;
        end if;
    end Descriptor_SUBCATEGORIA;

    Function Descriptor_TIPUSCONTRACTE(c in TIPUSCONTRACTE.CTECOD%type) return varchar is
        t BASIC_PKG.TIPUSCONTRACTE_tab;
    begin
        BASIC_PKG.Consultar_TIPUSCONTRACTE(t, c, null);
        return t(0).CTEDESC;
    end Descriptor_TIPUSCONTRACTE;

    Function Descriptor_TIPUSJORNADA(c in TIPUSJORNADA.TJOCOD%type) return varchar is
        t BASIC_PKG.TIPUSJORNADA_tab;
    begin
        BASIC_PKG.Consultar_TIPUSJORNADA(t, c, null);
        return t(0).TJODESC;
    end Descriptor_TIPUSJORNADA;

    Function Descriptor_TITULACIO(c in TITULACIO.TITCOD%type) return varchar is
        t BASIC_PKG.TITULACIO_tab;
    begin
        BASIC_PKG.Consultar_TITULACIO(t, c, null);
        return t(0).TITDESC;
    end Descriptor_TITULACIO;

end OUTPUT_PKG;
/
