/* **********************************************************
 *                                                          *
 *  DISSENY I IMPLEMENTACI DUNA BASE DE DADES RELACIONAL  *
 *  PER A UNA EMPRESA DE SELECCI DE PERSONAL               *
 *                                                          *
 *  UOC                                                     *
 *  PROJECTE FINAL DE CARRERA ENGINYERIA EN INFORMATICA     *
 *  ALUMNE:    RUBEN PEREZ DE LA FUENTE                     *
 *  CONSULTOR: JUAN MARTINEZ BOLAOS                        *
 *                                                          *
 ***********************************************************/

/* **********************************************************
 *             DESCRIPCI DEL PAQUET OUTPUT_PKG
 ***********************************************************/

CREATE OR REPLACE PACKAGE
OUTPUT_PKG is

    /*
       Fitxes dels registres de les taules
       Existeixen dos tipus de procediment per a cadascuna de les
       taules de la BD operacional:
       - Procedure xxx(c in ...COD%type): solliciten la fitxa d'un
         objecte concret en format "fitxa de dades"
       - Procedure xxx(r in ..._typ, f_r...): mostren per consola
         les dades de l'objecte en qesti segons el format indicat
         a f_r (fitxa o llista)
       En el cas especial del currculum, mostra per consola les dades
       del currculum (titulacions, experincia i idiomes) en format
       fitxa, ja que fer-ho d'una altra manera no tindria sentit o no
       seria visiblement coherent.
    */
    Procedure Fitxa_CATEGORIA(c in CATEGORIA.CATCOD%type);
    Procedure Fitxa_CATEGORIA(r in BASIC_PKG.CATEGORIA_typ, f_r in number default 0);
    Procedure Fitxa_CONVOCATS(c in CONVOCATS.ENTCOD%type);
    Procedure Fitxa_CONVOCATS(r in BASIC_PKG.CONVOCATS_typ);
    Procedure Fitxa_CURRICULUM(c in CURRICULUM.SOLCOD%type);
    Procedure Fitxa_CURRICULUM(r in BASIC_PKG.CURRICULUM_typ);
    Procedure Fitxa_DEMANDAFEINA(c in DEMANDAFEINA.DEFCOD%type);
    Procedure Fitxa_DEMANDAFEINA(r in BASIC_PKG.DEMANDAFEINA_typ, f_r in number default 0);
    Procedure Fitxa_EMPRESA(c in EMPRESA.EMPCOD%type);
    Procedure Fitxa_EMPRESA(r in BASIC_PKG.EMPRESA_typ, f_r in number default 0);
    Procedure Fitxa_ENTREVISTA(c in ENTREVISTA.ENTCOD%type);
    Procedure Fitxa_ENTREVISTA(r in BASIC_PKG.ENTREVISTA_typ, f_r in number default 0);
    Procedure Fitxa_ESPLOG(r in BASIC_PKG.ESPLOG_typ);
    Procedure Fitxa_IDIOMES(c in IDIOMES.IDIOCOD%type);
    Procedure Fitxa_IDIOMES(r in BASIC_PKG.IDIOMES_typ, f_r in number default 0);
    Procedure Fitxa_INTERESSAT(r in BASIC_PKG.INTERESSAT_typ);
    Procedure Fitxa_NIVELL(c in NIVELL.NIVCOD%type);
    Procedure Fitxa_NIVELL(r in BASIC_PKG.NIVELL_typ, f_r in number default 0);
    Procedure Fitxa_OFERTATREBALL(c in OFERTATREBALL.OFECOD%type);
    Procedure Fitxa_OFERTATREBALL(r in BASIC_PKG.OFERTATREBALL_typ, f_r in number default 0);
    Procedure Fitxa_PERFIL(c in PERFIL.PERFCOD%type);
    Procedure Fitxa_PERFIL(r in BASIC_PKG.PERFIL_typ, f_r in number default 0);
    Procedure Fitxa_REBUTJATS(r in BASIC_PKG.REBUTJATS_typ);
    Procedure Fitxa_SOLICITANT(c in SOLICITANT.SOLCOD%type);
    Procedure Fitxa_SOLICITANT(r in BASIC_PKG.SOLICITANT_typ, f_r in number default 0);
    Procedure Fitxa_SUBCATEGORIA(c in SUBCATEGORIA.SCATCOD%type);
    Procedure Fitxa_SUBCATEGORIA(r in BASIC_PKG.SUBCATEGORIA_typ, f_r in number default 0);
    Procedure Fitxa_TIPUSCONTRACTE(c in TIPUSCONTRACTE.CTECOD%type);
    Procedure Fitxa_TIPUSCONTRACTE(r in BASIC_PKG.TIPUSCONTRACTE_typ, f_r in number default 0);
    Procedure Fitxa_TIPUSJORNADA(c in TIPUSJORNADA.TJOCOD%type);
    Procedure Fitxa_TIPUSJORNADA(r in BASIC_PKG.TIPUSJORNADA_typ, f_r in number default 0);
    Procedure Fitxa_TITULACIO(c in TITULACIO.TITCOD%type);
    Procedure Fitxa_TITULACIO(r in BASIC_PKG.TITULACIO_typ, f_r in number default 0);

    /*
       Llistes del contingut de les taules
       Mostren per consola llistes de les taules. Existeixen dos tipus
       de procediment:
       - Llista_xxx: mostra per consola el contingut de tota la taula
         corresponent
       - Llista_xxx(t ...): mostra per consola els registres continguts
         a la taula t passada per parmetre, obtinguda amb una consulta
         a la BD
    */
    Procedure Llista_CATEGORIA;
    Procedure Llista_CATEGORIA(t in BASIC_PKG.CATEGORIA_tab);
    Procedure Llista_CONVOCATS;
    Procedure Llista_CONVOCATS(t in BASIC_PKG.CONVOCATS_tab);
    Procedure Llista_DEMANDAFEINA;
    Procedure Llista_DEMANDAFEINA(t in BASIC_PKG.DEMANDAFEINA_tab);
    Procedure Llista_EMPRESA;
    Procedure Llista_EMPRESA(t in BASIC_PKG.EMPRESA_tab);
    Procedure Llista_ENTREVISTA;
    Procedure Llista_ENTREVISTA(t in BASIC_PKG.ENTREVISTA_tab);
    Procedure Llista_ESPLOG;
    Procedure Llista_ESPLOG(t in BASIC_PKG.ESPLOG_tab);
    Procedure Llista_IDIOMES;
    Procedure Llista_IDIOMES(t in BASIC_PKG.IDIOMES_tab);
    Procedure Llista_INTERESSAT;
    Procedure Llista_INTERESSAT(t in BASIC_PKG.INTERESSAT_tab);
    Procedure Llista_NIVELL;
    Procedure Llista_NIVELL(t in BASIC_PKG.NIVELL_tab);
    Procedure Llista_OFERTATREBALL;
    Procedure Llista_OFERTATREBALL(t in BASIC_PKG.OFERTATREBALL_tab);
    Procedure Llista_PERFIL;
    Procedure Llista_PERFIL(t in BASIC_PKG.PERFIL_tab);
    Procedure Llista_REBUTJATS;
    Procedure Llista_REBUTJATS(t in BASIC_PKG.REBUTJATS_tab);
    Procedure Llista_SOLICITANT;
    Procedure Llista_SOLICITANT(t in BASIC_PKG.SOLICITANT_tab);
    Procedure Llista_SUBCATEGORIA;
    Procedure Llista_SUBCATEGORIA(t in BASIC_PKG.SUBCATEGORIA_tab);
    Procedure Llista_TIPUSCONTRACTE;
    Procedure Llista_TIPUSCONTRACTE(t in BASIC_PKG.TIPUSCONTRACTE_tab);
    Procedure Llista_TIPUSJORNADA;
    Procedure Llista_TIPUSJORNADA(t in BASIC_PKG.TIPUSJORNADA_tab);
    Procedure Llista_TITULACIO;
    Procedure Llista_TITULACIO(t in BASIC_PKG.TITULACIO_tab);

    /*
       Procediments per a la consulta del magatzem de dades
       Existeixen dos tipus de procediment:
       - Sense parmetres: mostren els resultats corresponents agrupats
         per any-mes continguts al DW.
       - Amb parmetres: mostren els resultat corresponents, per noms
         els de l'any i mes indicats.
    */
    -- Mostra tot el contingut del DW
    Procedure ConsultaMagatzemDades;
    Procedure ConsultaMagatzemDades(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type);
    -- Temps que s'ha trigat en cobrir les ofertes i quantes s'han cobert en temps
    -- Tamb mostra la mitjana que es triga en cobrir una oferta i la proporci
    -- d'ofertes cobertes en temps sobre el total d'ofertes cobertes
    Procedure ConsultaDWTempsCobertura;
    Procedure ConsultaDWTempsCobertura(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type);
    -- Mitjana de dies que es triga en cobrir una oferta de treball segons el perfil
    Procedure ConsultaDWMitjanaDiesPerfil;
    Procedure ConsultaDWMitjanaDiesPerfil(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type);
    -- Salari mitj que s'ofereix segons el perfil
    Procedure ConsultaDWMitjanaSalariPerfil;
    Procedure ConsultaDWMitjanaSalariPerfil(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type);

    /* Funcions per a l'obtenci del descriptor d'un tipus */
    Function Descriptor_CATEGORIA(c in CATEGORIA.CATCOD%type) return varchar;
    Function Descriptor_EMPRESA(c in EMPRESA.EMPCOD%type) return varchar;
    Function Descriptor_IDIOMES(c in IDIOMES.IDIOCOD%type) return varchar;
    Function Descriptor_NIVELL(c in NIVELL.NIVCOD%type) return varchar;
    Function Descriptor_OFERTATREBALL(c in OFERTATREBALL.OFECOD%type) return varchar;
    Function Descriptor_PERFIL(c in PERFIL.PERFCOD%type) return varchar;
    Function Descriptor_SOLICITANT(c in SOLICITANT.SOLCOD%type) return varchar;
    Function Descriptor_SUBCATEGORIA(c in SUBCATEGORIA.SCATCOD%type, f in number default 0) return varchar;
    Function Descriptor_TIPUSCONTRACTE(c in TIPUSCONTRACTE.CTECOD%type) return varchar;
    Function Descriptor_TIPUSJORNADA(c in TIPUSJORNADA.TJOCOD%type) return varchar;
    Function Descriptor_TITULACIO(c in TITULACIO.TITCOD%type) return varchar;

end OUTPUT_PKG;
/
