/* **********************************************************
 *                                                          *
 *  DISSENY I IMPLEMENTACI DUNA BASE DE DADES RELACIONAL  *
 *  PER A UNA EMPRESA DE SELECCI DE PERSONAL               *
 *                                                          *
 *  UOC                                                     *
 *  PROJECTE FINAL DE CARRERA ENGINYERIA EN INFORMATICA     *
 *  ALUMNE:    RUBEN PEREZ DE LA FUENTE                     *
 *  CONSULTOR: JUAN MARTINEZ BOLAOS                        *
 *                                                          *
 ***********************************************************/

/* **********************************************************
 *           IMPLEMENTACI DEL PAQUET PROVES_PKG
 ***********************************************************/

CREATE OR REPLACE PACKAGE BODY
PROVES_PKG is

    Procedure GENERAESTADISTIQUES is
        e BASIC_PKG.xerror_typ;
    begin
        -- Selecci de totes les dades del Magatzem de Dades
        Dbms_Output.PUT_LINE('');
        Dbms_Output.PUT_LINE('Extracci de les dades...');
        BASIC_PKG.ExtraccioDades(false, e);
        -- Comprovaci de les dades obtingudes
        Dbms_Output.PUT_LINE('');
        Dbms_Output.PUT_LINE('Dades obtingudes al DW...');
        OUTPUT_PKG.ConsultaMagatzemDades;
        -- Temps que s'ha trigat en cobrir les ofertes i quantes s'han cobert en temps
        Dbms_Output.PUT_LINE('');
        Dbms_Output.PUT_LINE('Temps que es triga en cobrir les ofertes i quantes s''han cobert en temps...');
        OUTPUT_PKG.ConsultaDWTempsCobertura;
        -- Mitjana de dies que es triga en cobrir una oferta segons el perfil sollicitat
        Dbms_Output.PUT_LINE('');
        Dbms_Output.PUT_LINE('Mitjana de dies que es triga en cobrir una oferta segons el perfil sollicitat...');
        OUTPUT_PKG.ConsultaDWMitjanaDiesPerfil;
        -- Mitjana del salari ofert segons el perfil sollicitat
        Dbms_Output.PUT_LINE('');
        Dbms_Output.PUT_LINE('Mitjana del salari ofert segons el perfil sollicitat');
        OUTPUT_PKG.ConsultaDWMitjanaSalariPerfil;
    end GENERAESTADISTIQUES;

    Procedure ProvesIndividuals is
    begin
        Dbms_Output.PUT_LINE('');
        Dbms_Output.PUT_LINE('Execuci de les proves individuals:');
        for i in 0..6 loop
            ProvesIndividuals(i);
        end loop;
    end ProvesIndividuals;

    Procedure ProvesIndividuals(prova NUMBER) is
        -- Variable per capturar els possibles errors
        e      BASIC_PKG.xerror_typ;

        -- Variables per emmagatzemar els valors d'un registre de cada taula
        typcat BASIC_PKG.CATEGORIA_typ;
        typcon BASIC_PKG.CONVOCATS_typ;
        typcur BASIC_PKG.CURRICULUM_typ;
        typdef BASIC_PKG.DEMANDAFEINA_typ;
        typemp BASIC_PKG.EMPRESA_typ;
        typent BASIC_PKG.ENTREVISTA_typ;
        typexp BASIC_PKG.EXPERIENCIACV_typ;
        typidi BASIC_PKG.IDIOMES_typ;
        typicv BASIC_PKG.IDIOMESCV_typ;
        typiot BASIC_PKG.IDIOMESOT_typ;
        typint BASIC_PKG.INTERESSAT_typ;
        typniv BASIC_PKG.NIVELL_typ;
        typofe BASIC_PKG.OFERTATREBALL_typ;
        typper BASIC_PKG.PERFIL_typ;
        typreb BASIC_PKG.REBUTJATS_typ;
        typsol BASIC_PKG.SOLICITANT_typ;
        typsca BASIC_PKG.SUBCATEGORIA_typ;
        typcte BASIC_PKG.TIPUSCONTRACTE_typ;
        typjor BASIC_PKG.TIPUSJORNADA_typ;
        typtit BASIC_PKG.TITULACIO_typ;
        typtcv BASIC_PKG.TITULACIOCV_typ;
        typtot BASIC_PKG.TITULACIOOT_typ;

        -- Variables per blanquejar el contingut d'una variable typ%
        connul BASIC_PKG.CONVOCATS_typ;
        empnul BASIC_PKG.EMPRESA_typ;
        entnul BASIC_PKG.ENTREVISTA_typ;
        ofenul BASIC_PKG.OFERTATREBALL_typ;
        solnul BASIC_PKG.SOLICITANT_typ;

        -- Variables per emmagatzemar registres en taules
        tabcat BASIC_PKG.CATEGORIA_tab;
        tabcon BASIC_PKG.CONVOCATS_tab;
        tabcur BASIC_PKG.CURRICULUM_tab;
        tabdef BASIC_PKG.DEMANDAFEINA_tab;
        tabemp BASIC_PKG.EMPRESA_tab;
        tabent BASIC_PKG.ENTREVISTA_tab;
        tabexp BASIC_PKG.EXPERIENCIACV_tab;
        tabidi BASIC_PKG.IDIOMES_tab;
        tabicv BASIC_PKG.IDIOMESCV_tab;
        tabiot BASIC_PKG.IDIOMESOT_tab;
        tabint BASIC_PKG.INTERESSAT_tab;
        tabniv BASIC_PKG.NIVELL_tab;
        tabofe BASIC_PKG.OFERTATREBALL_tab;
        tabper BASIC_PKG.PERFIL_tab;
        tabreb BASIC_PKG.REBUTJATS_tab;
        tabsol BASIC_PKG.SOLICITANT_tab;
        tabsca BASIC_PKG.SUBCATEGORIA_tab;
        tabcte BASIC_PKG.TIPUSCONTRACTE_tab;
        tabjor BASIC_PKG.TIPUSJORNADA_tab;
        tabtit BASIC_PKG.TITULACIO_tab;
        tabtcv BASIC_PKG.TITULACIOCV_tab;
        tabtot BASIC_PKG.TITULACIOOT_tab;

        l_index number;
        datafi  date;
    begin
        if prova = 0 then
            -- Creaci d'un sollicitant i entrada del currculum
            Dbms_Output.PUT_LINE('');
            Dbms_Output.PUT_LINE('Creaci d''un sollicitant...');
            typsol.SOLNOM := 'Alex Duran Tarrag';
            typsol.SOLNIF := '44785214L';
            typsol.SOLDOM := 'C. Illes Balears, 14 - 17001 Girona';
            typsol.SOLTEL := '972211220';
            typsol.SOLCOR := 'aduran71@gmail.com';
            BASIC_PKG.Afegir_SOLICITANT (typsol, false, e);
            -- Comprovaci de les dades entrades
            OUTPUT_PKG.Fitxa_SOLICITANT(typsol);

            -- Entrada de les dades del currculum
            Dbms_Output.PUT_LINE('');
            Dbms_Output.PUT_LINE('...i entrada del seu currculum');
            typcur.SOLCOD := typsol.SOLCOD;
            BASIC_PKG.Afegir_CURRICULUM (typcur, false, e);

            -- Experincia professional
            typexp.SOLCOD  := typsol.SOLCOD;
            typexp.SCATCOD := 17;
            typexp.EMPNOM  := 'Supermercat DIA';
            typexp.EMPTEL  := '972225533';
            typexp.DATAINI := '01/03/2010';
            typexp.DATAFI  := '30/04/2012';
            BASIC_PKG.Afegir_EXPERIENCIACV(typexp, false, e);

            -- Idiomes que coneix
            typicv.SOLCOD  := typsol.SOLCOD;
            typicv.IDIOCOD := 11;
            typicv.NIVORA  := 'ALT';
            typicv.NIVESC  := 'MIG';
            BASIC_PKG.Afegir_IDIOMESCV(typicv, false, e);

            -- Titulaci oficial de qu disposa
            typtcv.SOLCOD := typsol.SOLCOD;
            typtcv.TITCOD := 10;
            typtcv.ANYTIT := 2011;
            typtcv.ESCOLA := 'IES Montilivi';
            BASIC_PKG.Afegir_TITULACIOCV(typtcv, false, e);
            -- Comprovaci de les dades entrades
            OUTPUT_PKG.Fitxa_CURRICULUM(typcur.SOLCOD);
        end if;

        if prova = 1 then
            -- Creaci d'una empresa
            Dbms_Output.PUT_LINE('');
            Dbms_Output.PUT_LINE('Creaci d''una empresa');
            typemp := empnul;
            typemp.EMPNOM := 'La colla del ranxo';
            typemp.EMPSEC := 'Dinars populars';
            typemp.EMPTRE := '10 - 20';
            typemp.EMPTEL := '972154223';
            typemp.EMPCOR := 'lacolladelranxo@gmail.com';
            typemp.EMPCON := 'Manel Tulsanes Puig';
            BASIC_PKG.Afegir_EMPRESA(typemp, false, e);
            -- Comprovaci de les dades entrades
            OUTPUT_PKG.Fitxa_EMPRESA(typemp.EMPCOD);
        end if;

        if prova = 2 then
            -- Adici d'una oferta de treball
            -- Comprovaci de les ofertes existents
            Dbms_Output.PUT_LINE('');
            Dbms_Output.PUT_LINE('Relaci de les ofertes de treball actives...');
            OUTPUT_PKG.Llista_OFERTATREBALL;
            -- Cerca de l'empresa que genera l'oferta de treball
            Dbms_Output.PUT_LINE('');
            Dbms_Output.PUT_LINE('Adici d''una oferta de treball (LA COLLA DEL RANXO)...');
            typemp := empnul;
            typemp.EMPNOM := 'La colla del ranxo';
            BASIC_PKG.Consultar_EMPRESA(tabemp, null, typemp);
            -- Dades de l'oferta de treball
            typofe.EMPCOD  := tabemp(0).EMPCOD;
            typofe.PERFCOD := 15;
            typofe.CTECOD  := 14;
            typofe.TJOCOD  := 6;
            typofe.SCATCOD := 84;
            typofe.OTDESC  := 'Pinxo de cuina. Ajudant dels cuiners de la Colla.';
            typofe.SOUMIN  := '16500';
            typofe.SOUMAX  := '19800';
            typofe.OFEINI  := sysdate;
            typofe.OFEDIES := '15';
            BASIC_PKG.Afegir_OFERTATREBALL(typofe, false, e);
            -- Comprovaci de les dades entrades
            Dbms_Output.PUT_LINE('');
            Dbms_Output.PUT_LINE('Relaci de les ofertes de treball actives (de nou)...');
            OUTPUT_PKG.Llista_OFERTATREBALL;
        end if;

        if prova = 3 then
            -- Creaci d'una entrevista de treball
            -- Cerca de les ofertes disponibles per a Comptable
            Dbms_Output.PUT_LINE('');
            Dbms_Output.PUT_LINE('Creaci d''una entrevista de treball...');
            typofe := ofenul;
            typofe.OTDESC := 'Comptable';
            BASIC_PKG.Consultar_OFERTATREBALL_Activa(tabofe, null, typofe);
            l_index := tabofe.first;
            loop
                -- Creaci d'una entrevista per a cada oferta trobada
                BASIC_PKG.ConcertarEntrevista(tabofe(l_index), sysdate + 10, false, e);
                typent := entnul;
                typent.OFECOD := tabofe(l_index).OFECOD;
                typent.ENTDATA := sysdate + 10;
                -- Comprovaci de l'entrevista creada
                BASIC_PKG.Consultar_ENTREVISTA(tabent, null, typent);
                OUTPUT_PKG.Fitxa_ENTREVISTA(tabent(0).ENTCOD);
                exit when l_index = tabofe.last;
                l_index := tabofe.next(l_index);
            end loop;
        end if;

        if prova = 4 then
            -- Empresa guarda currculum interessant
            -- Cerca de l'empresa interessada
            Dbms_Output.PUT_LINE('');
            Dbms_Output.PUT_LINE('Una empresa es guarda un currculum que li interessa...');
            typemp := empnul;
            typemp.EMPNOM := 'Excavacions el Talp';
            BASIC_PKG.Consultar_EMPRESA(tabemp, null, typemp);
            -- Cerca del sollicitant interessant
            typsol := solnul;
            typsol.SOLNOM := 'Albert Garcia Gonzlez';
            BASIC_PKG.Consultar_SOLICITANT(tabsol, null, typsol);
            -- Es guarda el currculum per a aquesta empresa
            typint.EMPCOD := tabemp(0).EMPCOD;
            typint.SOLCOD := tabsol(0).SOLCOD;
            BASIC_PKG.Afegir_INTERESSAT(typint, false, e);
            -- Comprovaci de les dades entrades
            OUTPUT_PKG.Llista_INTERESSAT;
        end if;

        if prova = 5 then
            -- Empresa descarta currculum per sempre
            -- Cerca de l'empresa interessada
            Dbms_Output.PUT_LINE('');
            Dbms_Output.PUT_LINE('Una empresa descarta un currculum que no li interessa...');
            typemp := empnul;
            typemp.EMPNOM := 'Assegurances Mart';
            BASIC_PKG.Consultar_EMPRESA(tabemp, null, typemp);
            -- Cerca del sollicitant rebutjat
            typsol := solnul;
            typsol.SOLNIF := '87654321D';
            BASIC_PKG.Consultar_SOLICITANT(tabsol, null, typsol);
            -- Es guarda el rebuig sollicitat
            typreb.EMPCOD := tabemp(0).EMPCOD;
            typreb.SOLCOD := tabsol(0).SOLCOD;
            BASIC_PKG.Afegir_REBUTJATS(typreb, false, e);
            -- Comprovaci de les dades entrades
            BASIC_PKG.Consultar_REBUTJATS(tabreb, null, typreb);
            OUTPUT_PKG.Llista_REBUTJATS(tabreb);
            /* Comprovaci de qu ara no se selecciona per a una entrevista un sollicitant
               rebutjat per l'empresa que ha presentat l'oferta objecte de l'entrevista */
            Dbms_Output.PUT_LINE('');
            Dbms_Output.PUT_LINE('Es torna a crear una entrevista, per comprovar que el ' || 
                                 'sollicitant rebutjat (Santi Salisachs) no s seleccionat pel sistema...');
            typofe := ofenul;
            typofe.OTDESC := 'Comptable';
            BASIC_PKG.Consultar_OFERTATREBALL_Activa(tabofe, null, typofe);
            l_index := tabofe.first;
            loop
                BASIC_PKG.ConcertarEntrevista(tabofe(l_index), sysdate + 12, false, e);
                typent := entnul;
                typent.OFECOD := tabofe(l_index).OFECOD;
                typent.ENTDATA := sysdate + 12;
                BASIC_PKG.Consultar_ENTREVISTA(tabent, null, typent);
                OUTPUT_PKG.Fitxa_ENTREVISTA(tabent(0).ENTCOD);
                exit when l_index = tabofe.last;
                l_index := tabofe.next(l_index);
            end loop;
        end if;

        if prova = 6 then
            -- Empresa selecciona candidat
            -- Cerca de l'oferta que es cobreix
            Dbms_Output.PUT_LINE('');
            Dbms_Output.PUT_LINE('Una empresa (27) selecciona un currculum (2) per cobrir l''oferta...');
            typofe := ofenul;
            typofe.OTDESC := 'Comptable';
            BASIC_PKG.Consultar_OFERTATREBALL_Activa(tabofe, null, typofe);
            -- Cerca del sollicitant que ocupar la plaa
            typsol := solnul;
            typsol.SOLNIF := '12345679B';
            BASIC_PKG.Consultar_SOLICITANT(tabsol, null, typsol);
            -- Selecci del candidat
            datafi := to_date(to_char(sysdate,'DD/MM/YYYY'));
            BASIC_PKG.SeleccionarCandidat(tabofe(0), tabsol(0).SOLCOD, datafi, false, e);
            -- Comprovaci de les dades entrades
            OUTPUT_PKG.Llista_OFERTATREBALL;
            OUTPUT_PKG.Llista_SOLICITANT;
        end if;

        exception
            when others then
                Dbms_Output.PUT_LINE('ERROR APLICACIO: ' || e.status || ' - ' || e.message);
                if sqlerrm is not null then
                    Dbms_Output.PUT_LINE('ERROR ORACLE: ' || sqlerrm );
                end if;
    end ProvesIndividuals;
    
    Procedure ConsultaLog is
        typlog BASIC_PKG.ESPLOG_typ;
        tablog BASIC_PKG.ESPLOG_tab;
    begin
        BASIC_PKG.Consultar_ESPLOG ( tablog, null, typlog);
        OUTPUT_PKG.Llista_ESPLOG(tablog);
    end ConsultaLog;

END PROVES_PKG;
/
