/* **********************************************************
 *                                                          *
 *  DISSENY I IMPLEMENTACI DUNA BASE DE DADES RELACIONAL  *
 *  PER A UNA EMPRESA DE SELECCI DE PERSONAL               *
 *                                                          *
 *  UOC                                                     *
 *  PROJECTE FINAL DE CARRERA ENGINYERIA EN INFORMATICA     *
 *  ALUMNE:    RUBEN PEREZ DE LA FUENTE                     *
 *  CONSULTOR: JUAN MARTINEZ BOLAOS                        *
 *                                                          *
 ***********************************************************/

/* **********************************************************
 *           IMPLEMENTACI DEL PAQUET  BASIC_PKG
 ***********************************************************/

CREATE OR REPLACE PACKAGE BODY
BASIC_PKG is

    /* Interfcie PL/SQL per a la Taula CATEGORIA*/
    Function GetPK_CATEGORIA return number is
        cursor c is
            select CATEGORIA_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_CATEGORIA;

    Procedure Consultar_CATEGORIA ( r in out CATEGORIA_ref, p_CATCOD in number default null, cons in CATEGORIA_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_CATCOD is not null then
            open r for
                select CATCOD, CATDESC, SWBAIXA
                from   CATEGORIA
                where  CATCOD = nvl(p_CATCOD, CATCOD) and
                       SWBAIXA <> 1;
        else
            open r for
                select CATCOD, CATDESC, SWBAIXA
                from   CATEGORIA
                where  (cons.CATDESC is null or CATDESC like trim(cons.CATDESC) || '%') and
                       SWBAIXA <> 1;
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_CATEGORIA(p_catcod: ' || nvl(p_CATCOD,0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_CATEGORIA ;

    Procedure Consultar_CATEGORIA ( t in out CATEGORIA_tab, p_CATCOD in number default null, cons in CATEGORIA_typ ) is
        cursor c is
            select CATCOD, CATDESC
            from   CATEGORIA
            where  CATCOD = nvl(p_CATCOD, CATCOD);
        cursor c2 is
            select CATCOD, CATDESC
            from   CATEGORIA
            where  (cons.CATDESC is null or CATDESC like trim(cons.CATDESC) || '%');
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin
        if p_CATCOD is not null then
            for i in c loop
                t(l_count).CATCOD  :=  i.CATCOD;
                t(l_count).CATDESC :=  i.CATDESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGINICI from dual;
                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_CATEGORIA(i.catcod: ' || i.CATCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                t(l_count).CATCOD  :=  i.CATCOD;
                t(l_count).CATDESC :=  i.CATDESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGINICI from dual;
                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_CATEGORIA(i.catdesc: ' || i.CATDESC || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_CATEGORIA;

    Procedure Afegir_CATEGORIA ( r in out CATEGORIA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;
        if r.CATCOD is null then r.CATCOD := GetPK_CATEGORIA; end if;
        insert into CATEGORIA(CATCOD, CATDESC)
                      values (r.CATCOD, r.CATDESC)
        returning CATCOD, CATDESC
             into r.CATCOD, r.CATDESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;
        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_CATEGORIA(r.catdesc: ' || r.CATDESC || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_CATEGORIA(r.catdesc: ' || r.CATDESC || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_CATEGORIA;

    Procedure Afegir_CATEGORIA ( t in out CATEGORIA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_CATEGORIA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_CATEGORIA - taula';
        l.LOGRESULT  := e.status;
        Afegir_ESPLOG(l, p_commit, e);

        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_CATEGORIA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_CATEGORIA;

    Procedure Esborrar_CATEGORIA ( p_CATCOD in CATEGORIA.CATCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update CATEGORIA
        set    SWBAIXA = 1
        where  CATCOD = p_CATCOD;
        update SUBCATEGORIA
        set    SWBAIXA = 1
        where  CATCOD = p_CATCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_CATEGORIA(p_catcod: ' || nvl(p_CATCOD,0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_CATEGORIA(p_catcod: ' || nvl(p_CATCOD,0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_CATEGORIA;

    Procedure Esborrar_CATEGORIA ( t in CATEGORIA_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_CATEGORIA(t(l_index).CATCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_CATEGORIA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);

        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_CATEGORIA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_CATEGORIA;

    Procedure Modificar_CATEGORIA ( r in out CATEGORIA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update CATEGORIA
        set    CATDESC = r.CATDESC,
               SWBAIXA = r.SWBAIXA
        where  CATCOD = r.CATCOD
        returning CATCOD, CATDESC, SWBAIXA
             into r.CATCOD, r.CATDESC, r.SWBAIXA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_CATEGORIA(r.catcod: ' || r.CATCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);

        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_CATEGORIA(r.catcod: ' || r.CATCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_CATEGORIA;

    Procedure Modificar_CATEGORIA ( t in out CATEGORIA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_CATEGORIA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_CATEGORIA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_CATEGORIA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_CATEGORIA;

    /* Interfcie PL/SQL per a la Taula CONVOCATS*/
    Function GetPK_CONVOCATS return number is
        cursor c is
            select CONVOCATS_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_CONVOCATS;

    Procedure Consultar_CONVOCATS ( r in out CONVOCATS_ref, p_ENTCOD in number default null, cons in CONVOCATS_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_ENTCOD is not null then
            open r for
                select ENTCOD, SOLCOD
                from   CONVOCATS
                where  ENTCOD = nvl(p_ENTCOD, ENTCOD);
        else
            open r for
                select ENTCOD, SOLCOD
                from   CONVOCATS
                where  (cons.SOLCOD is null or SOLCOD = cons.SOLCOD);
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_CONVOCATS(p_entcod: ' || nvl(p_ENTCOD,0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_CONVOCATS ;

    Procedure Consultar_CONVOCATS ( t in out CONVOCATS_tab, p_ENTCOD in number default null, cons in CONVOCATS_typ ) is
        cursor c is
            select ENTCOD, SOLCOD
            from   CONVOCATS
            where  ENTCOD = nvl(p_ENTCOD, ENTCOD);
        cursor c2 is
            select ENTCOD, SOLCOD
            from   CONVOCATS
            where  (cons.SOLCOD is null or SOLCOD = cons.SOLCOD);
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin
        if p_ENTCOD is not null then
            for i in c loop
                t(l_count).ENTCOD :=  i.ENTCOD;
                t(l_count).SOLCOD :=  i.SOLCOD;
                l_count := l_count + 1;

                select systimestamp into l.LOGINICI from dual;
                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_CONVOCATS(i.entcod: ' || i.ENTCOD || ', i.solcod: ' || i.SOLCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                t(l_count).ENTCOD :=  i.ENTCOD;
                t(l_count).SOLCOD :=  i.SOLCOD;
                l_count := l_count + 1;

                select systimestamp into l.LOGINICI from dual;
                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_CONVOCATS(i.entcod: ' || i.ENTCOD || ', i.solcod: ' || i.SOLCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_CONVOCATS;

    Procedure Afegir_CONVOCATS ( r in out CONVOCATS_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.ENTCOD is null then r.ENTCOD := GetPK_CONVOCATS; end if;
        insert into CONVOCATS(ENTCOD, SOLCOD)
                      values (r.ENTCOD, r.SOLCOD)
        returning ENTCOD, SOLCOD
             into r.ENTCOD, r.SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_CONVOCATS(r.entcod: ' || r.ENTCOD || ', r.solcod: ' || r.SOLCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_CONVOCATS(r.entcod: ' || r.ENTCOD || ', r.solcod: ' || r.SOLCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_CONVOCATS;

    Procedure Afegir_CONVOCATS ( t in out CONVOCATS_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_CONVOCATS(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_CONVOCATS - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_CONVOCATS - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_CONVOCATS;

    Procedure Esborrar_CONVOCATS ( p_ENTCOD in CONVOCATS.ENTCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   CONVOCATS
        where  ENTCOD = p_ENTCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_CONVOCATS(p_entcod: ' || nvl(p_ENTCOD,0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_CONVOCATS(p_entcod: ' || nvl(p_ENTCOD,0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_CONVOCATS;

    Procedure Esborrar_CONVOCATS ( t in CONVOCATS_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_CONVOCATS(t(l_index).ENTCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_CONVOCATS - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_CONVOCATS - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_CONVOCATS;

    Procedure Modificar_CONVOCATS ( r in out CONVOCATS_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update CONVOCATS
        set    SOLCOD = r.SOLCOD
        where  ENTCOD = r.ENTCOD
        returning ENTCOD, SOLCOD
             into r.ENTCOD, r.SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_CONVOCATS(r.entcod: ' || r.ENTCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_CONVOCATS(r.entcod: ' || r.ENTCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_CONVOCATS;

    Procedure Modificar_CONVOCATS ( t in out CONVOCATS_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_CONVOCATS(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_CONVOCATS - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_CONVOCATS - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_CONVOCATS;

    /* Interfcie PL/SQL per a la Taula CURRICULUM*/
    Function GetPK_CURRICULUM return number is
        cursor c is
            select CURRICULUM_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_CURRICULUM;

    Procedure Consultar_CURRICULUM ( r in out CURRICULUM_ref, p_SOLCOD in number default null ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        open r for
            select SOLCOD
            from   CURRICULUM
            where  SOLCOD = nvl(p_SOLCOD, SOLCOD);

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_Curriculum(p_solcod: ' || p_SOLCOD || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_CURRICULUM ;

    Procedure Consultar_CURRICULUM ( t in out CURRICULUM_tab, p_SOLCOD in number default null ) is
        cursor c is
            select SOLCOD
            from   CURRICULUM
            where  SOLCOD = nvl(p_SOLCOD, SOLCOD);
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        for i in c loop
            t(l_count).SOLCOD :=  i.SOLCOD;
            l_count := l_count + 1;

            select systimestamp into l.LOGFINAL from dual;
            l.USRCOD  := 'PFC';
            l.LOGACCIO := 'Consultar_CURRICULUM(i.solcod: ' || i.SOLCOD || ')';
            l.LOGRESULT  := ' ';
            Afegir_ESPLOG(l, true, e);
        end loop;
    end Consultar_CURRICULUM;

    Procedure Afegir_CURRICULUM ( r in out CURRICULUM_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.SOLCOD is null then r.SOLCOD := GetPK_CURRICULUM; end if;
        insert into CURRICULUM(SOLCOD)
                       values (r.SOLCOD)
        returning SOLCOD
             into r.SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

            select systimestamp into l.LOGFINAL from dual;
            l.USRCOD  := 'PFC';
            l.LOGACCIO := 'Afegir_CURRICULUM(r.solcod: ' || r.SOLCOD || ')';
            l.LOGRESULT  := trim(rpad(e.status, 255));
            Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_CURRICULUM(r.solcod: ' || r.SOLCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_CURRICULUM;

    Procedure Afegir_CURRICULUM ( t in out CURRICULUM_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_CURRICULUM(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_CURRICULUM - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_CURRICULUM - taula)';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_CURRICULUM;

    Procedure Esborrar_CURRICULUM ( p_SOLCOD in CURRICULUM.SOLCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   CURRICULUM
        where  SOLCOD = p_SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_CURRICULUM(p_solcod: ' || nvl(p_SOLCOD,0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_CURRICULUM(p_solcod: ' || nvl(p_SOLCOD,0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_CURRICULUM;

    Procedure Esborrar_CURRICULUM ( t in CURRICULUM_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_CURRICULUM(t(l_index).SOLCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_CURRICULUM - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_CURRICULUM - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_CURRICULUM;

    /* Interfcie PL/SQL per a la Taula DEMANDAFEINA*/
    Function GetPK_DEMANDAFEINA return number is
        cursor c is
            select DEMANDAFEINA_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_DEMANDAFEINA;

    Procedure Consultar_DEMANDAFEINA ( r in out DEMANDAFEINA_ref, p_DEFCOD in number default null, cons in DEMANDAFEINA_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_DEFCOD is not null then
            open r for
                select DEFCOD, SOLCOD, PERFCOD, SCATCOD, SWBAIXA
                from   DEMANDAFEINA
                where  DEFCOD = nvl(p_DEFCOD, DEFCOD) and
                       SWBAIXA <> 1;
        else
            open r for
                select DEFCOD, SOLCOD, PERFCOD, SCATCOD, SWBAIXA
                from   DEMANDAFEINA
                where  (cons.SOLCOD is null or  SOLCOD = cons.SOLCOD) and
                       (cons.PERFCOD is null or PERFCOD = cons.PERFCOD) and
                       (cons.SCATCOD is null or SCATCOD = cons.SCATCOD) and
                       SWBAIXA <> 1;
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_DEMANDAFEINA(p_defcod: ' || nvl(p_DEFCOD,0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_DEMANDAFEINA ;

    Procedure Consultar_DEMANDAFEINA ( t in out DEMANDAFEINA_tab, p_DEFCOD in number default null, cons in DEMANDAFEINA_typ ) is
        cursor c is
            select DEFCOD, SOLCOD, PERFCOD, SCATCOD, SWBAIXA
            from   DEMANDAFEINA
            where  DEFCOD = nvl(p_DEFCOD, DEFCOD);
        cursor c2 is
            select DEFCOD, SOLCOD, PERFCOD, SCATCOD, SWBAIXA
            from   DEMANDAFEINA
            where  (cons.SOLCOD is null or  SOLCOD = cons.SOLCOD) and
                   (cons.PERFCOD is null or PERFCOD = cons.PERFCOD) and
                   (cons.SCATCOD is null or SCATCOD = cons.SCATCOD) and
                   SWBAIXA <> 1;
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin
        if p_DEFCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).DEFCOD  :=  i.DEFCOD;
                t(l_count).SOLCOD  :=  i.SOLCOD;
                t(l_count).PERFCOD :=  i.PERFCOD;
                t(l_count).SCATCOD :=  i.SCATCOD;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_DEMANDAFEINA(i.defcod: ' || i.DEFCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).DEFCOD  :=  i.DEFCOD;
                t(l_count).SOLCOD  :=  i.SOLCOD;
                t(l_count).PERFCOD :=  i.PERFCOD;
                t(l_count).SCATCOD :=  i.SCATCOD;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_DEMANDAFEINA(i.defcod: ' || i.DEFCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_DEMANDAFEINA;

    Procedure Afegir_DEMANDAFEINA ( r in out DEMANDAFEINA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.DEFCOD is null then r.DEFCOD := GetPK_DEMANDAFEINA; end if;
        if r.SWBAIXA is null then r.SWBAIXA := 0; end if;
        insert into DEMANDAFEINA(DEFCOD, SOLCOD, PERFCOD, SCATCOD, SWBAIXA)
                         values (r.DEFCOD, r.SOLCOD, r.PERFCOD, r.SCATCOD, r.SWBAIXA)
        returning DEFCOD, SOLCOD, PERFCOD, SCATCOD, SWBAIXA
             into r.DEFCOD, r.SOLCOD, r.PERFCOD, r.SCATCOD, r.SWBAIXA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_DEMANDAFEINA(r.defcod: ' || r.DEFCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status,255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_DEMANDAFEINA(r.defcod: ' || r.DEFCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message,255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_DEMANDAFEINA;

    Procedure Afegir_DEMANDAFEINA ( t in out DEMANDAFEINA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_DEMANDAFEINA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_DEMANDAFEINA - taula';
        l.LOGRESULT  := trim(rpad(e.status,255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_DEMANDAFEINA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message,255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_DEMANDAFEINA;

    Procedure Esborrar_DEMANDAFEINA ( p_DEFCOD in DEMANDAFEINA.DEFCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update DEMANDAFEINA
        set    SWBAIXA = 1
        where  DEFCOD = p_DEFCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_DEMANDAFEINA(p_defcod: ' || nvl(p_DEFCOD,0) || ')';
        l.LOGRESULT  := trim(rpad(e.status,255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_DEMANDAFEINA(p_defcod: ' || nvl(p_DEFCOD,0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message,255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_DEMANDAFEINA;

    Procedure Esborrar_DEMANDAFEINA ( t in DEMANDAFEINA_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_DEMANDAFEINA(t(l_index).DEFCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_DEMANDAFEINA - taula';
        l.LOGRESULT  := trim(rpad(e.status,255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_DEMANDAFEINA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message,255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_DEMANDAFEINA;

    Procedure Modificar_DEMANDAFEINA ( r in out DEMANDAFEINA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update DEMANDAFEINA
        set    SOLCOD  = r.SOLCOD,
               PERFCOD = r.PERFCOD,
               SCATCOD = r.SCATCOD,
               SWBAIXA = r.SWBAIXA
        where  DEFCOD = r.DEFCOD
        returning DEFCOD, SOLCOD, PERFCOD, SCATCOD, SWBAIXA
             into r.DEFCOD, r.SOLCOD, r.PERFCOD, r.SCATCOD, r.SWBAIXA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_DEMANDAFEINA(r.defcod: ' || r.DEFCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status,255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_DEMANDAFEINA(r.defcod: ' || r.DEFCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message,255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_DEMANDAFEINA;

    Procedure Modificar_DEMANDAFEINA ( t in out DEMANDAFEINA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_DEMANDAFEINA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_DEMANDAFEINA - taula';
        l.LOGRESULT  := trim(rpad(e.status,255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_DEMANDAFEINA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message,255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_DEMANDAFEINA;

    /* Interfcie PL/SQL per a la Taula EMPRESA*/
    Function GetPK_EMPRESA return number is
        cursor c is
            select EMPRESA_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_EMPRESA;

    Procedure Consultar_EMPRESA ( r in out EMPRESA_ref, p_EMPCOD in number default null, cons in EMPRESA_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_EMPCOD is not null then
            open r for
                select EMPCOD, EMPNOM, EMPSEC, EMPTRE, EMPTEL, EMPCOR, EMPWEB, EMPCON, SWBAIXA
                from   EMPRESA
                where  EMPCOD = nvl(p_EMPCOD, EMPCOD) and
                       SWBAIXA <> 1;
        else
            open r for
                select EMPCOD, EMPNOM, EMPSEC, EMPTRE, EMPTEL, EMPCOR, EMPWEB, EMPCON, SWBAIXA
                from   EMPRESA
                where  (cons.EMPNOM is null or EMPNOM like trim(cons.EMPNOM) || '%') and
                       (cons.EMPSEC is null or EMPSEC like trim(cons.EMPSEC) || '%') and
                       (cons.EMPTRE is null or EMPTRE like trim(cons.EMPTRE) || '%') and
                       (cons.EMPTEL is null or EMPTEL like trim(cons.EMPTEL) || '%') and
                       (cons.EMPCOR is null or EMPCOR like trim(cons.EMPCOR) || '%') and
                       (cons.EMPWEB is null or EMPWEB like trim(cons.EMPWEB) || '%') and
                       (cons.EMPCON is null or EMPCON like trim(cons.EMPCON) || '%') and
                       SWBAIXA <> 1;
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_EMPRESA(p_empcod: ' || nvl(p_EMPCOD,0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_EMPRESA ;

    Procedure Consultar_EMPRESA ( t in out EMPRESA_tab, p_EMPCOD in number default null, cons in EMPRESA_typ ) is
        cursor c is
            select EMPCOD, EMPNOM, EMPSEC, EMPTRE, EMPTEL, EMPCOR, EMPWEB, EMPCON, SWBAIXA
            from   EMPRESA
            where  EMPCOD = nvl(p_EMPCOD, EMPCOD) and
                   SWBAIXA <> 1;
        cursor c2 is
            select EMPCOD, EMPNOM, EMPSEC, EMPTRE, EMPTEL, EMPCOR, EMPWEB, EMPCON, SWBAIXA
            from   EMPRESA
            where  (cons.EMPNOM is null or EMPNOM like trim(cons.EMPNOM) || '%') and
                   (cons.EMPSEC is null or EMPSEC like trim(cons.EMPSEC) || '%') and
                   (cons.EMPTRE is null or EMPTRE like trim(cons.EMPTRE) || '%') and
                   (cons.EMPTEL is null or EMPTEL like trim(cons.EMPTEL) || '%') and
                   (cons.EMPCOR is null or EMPCOR like trim(cons.EMPCOR) || '%') and
                   (cons.EMPWEB is null or EMPWEB like trim(cons.EMPWEB) || '%') and
                   (cons.EMPCON is null or EMPCON like trim(cons.EMPCON) || '%') and
                   SWBAIXA <> 1;
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_EMPCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).EMPCOD  :=  i.EMPCOD;
                t(l_count).EMPNOM  :=  i.EMPNOM;
                t(l_count).EMPSEC  :=  i.EMPSEC;
                t(l_count).EMPTRE  :=  i.EMPTRE;
                t(l_count).EMPTEL  :=  i.EMPTEL;
                t(l_count).EMPCOR  :=  i.EMPCOR;
                t(l_count).EMPWEB  :=  i.EMPWEB;
                t(l_count).EMPCON  :=  i.EMPCON;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_EMPRESA(i.empcod: ' || i.EMPCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).EMPCOD  :=  i.EMPCOD;
                t(l_count).EMPNOM  :=  i.EMPNOM;
                t(l_count).EMPSEC  :=  i.EMPSEC;
                t(l_count).EMPTRE  :=  i.EMPTRE;
                t(l_count).EMPTEL  :=  i.EMPTEL;
                t(l_count).EMPCOR  :=  i.EMPCOR;
                t(l_count).EMPWEB  :=  i.EMPWEB;
                t(l_count).EMPCON  :=  i.EMPCON;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_EMPRESA(i.empcod: ' || i.EMPCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_EMPRESA;

    Procedure Afegir_EMPRESA ( r in out EMPRESA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.EMPCOD is null then r.EMPCOD := GetPK_EMPRESA; end if;
        if r.SWBAIXA is null then r.SWBAIXA := 0; end if;
        insert into EMPRESA(EMPCOD, EMPNOM, EMPSEC, EMPTRE, EMPTEL, EMPCOR, EMPWEB, EMPCON, SWBAIXA)
                    values (r.EMPCOD, r.EMPNOM, r.EMPSEC, r.EMPTRE, r.EMPTEL, r.EMPCOR, r.EMPWEB, r.EMPCON, r.SWBAIXA)
        returning EMPCOD, EMPNOM, EMPSEC, EMPTRE, EMPTEL, EMPCOR, EMPWEB, EMPCON, SWBAIXA
             into r.EMPCOD, r.EMPNOM, r.EMPSEC, r.EMPTRE, r.EMPTEL, r.EMPCOR, r.EMPWEB, r.EMPCON, r.SWBAIXA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_EMPRESA(r.empcod: ' || r.EMPCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_EMPRESA(r.empcod: ' || r.EMPCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_EMPRESA;

    Procedure Afegir_EMPRESA ( t in out EMPRESA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_EMPRESA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_EMPRESA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_EMPRESA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_EMPRESA;

    Procedure Esborrar_EMPRESA ( p_EMPCOD in EMPRESA.EMPCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update EMPRESA
        set    SWBAIXA = 1
        where  EMPCOD = p_EMPCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_EMPRESA(p_empcod: ' || nvl(p_EMPCOD,0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_EMPRESA(p_empcod: ' || nvl(p_EMPCOD,0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_EMPRESA;

    Procedure Esborrar_EMPRESA ( t in EMPRESA_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_EMPRESA(t(l_index).EMPCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_EMPRESA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_EMPRESA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_EMPRESA;

    Procedure Modificar_EMPRESA ( r in out EMPRESA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update EMPRESA
        set    EMPNOM  = r.EMPNOM,
               EMPSEC  = r.EMPSEC,
               EMPTRE  = r.EMPTRE,
               EMPTEL  = r.EMPTEL,
               EMPCOR  = r.EMPCOR,
               EMPWEB  = r.EMPWEB,
               EMPCON  = r.EMPCON,
               SWBAIXA = r.SWBAIXA
        where  EMPCOD = r.EMPCOD
        returning EMPCOD, EMPNOM, EMPSEC, EMPTRE, EMPTEL, EMPCOR, EMPWEB, EMPCON, SWBAIXA
             into r.EMPCOD, r.EMPNOM, r.EMPSEC, r.EMPTRE, r.EMPTEL, r.EMPCOR, r.EMPWEB, r.EMPCON, r.SWBAIXA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_EMPRESA(p_empcod: ' || r.EMPCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_EMPRESA(p_empcod: ' || r.EMPCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_EMPRESA;

    Procedure Modificar_EMPRESA ( t in out EMPRESA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_EMPRESA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_EMPRESA - taula';
        l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_EMPRESA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_EMPRESA;

    /* Interfcie PL/SQL per a la Taula ENTREVISTA*/
    Function GetPK_ENTREVISTA return number is
        cursor c is
            select ENTREVISTA_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_ENTREVISTA;

    Procedure Consultar_ENTREVISTA ( r in out ENTREVISTA_ref, p_ENTCOD in number default null, cons in ENTREVISTA_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_ENTCOD is not null then
            open r for
                select ENTCOD, OFECOD, ENTDATA
                from   ENTREVISTA
                where  ENTCOD = nvl(p_ENTCOD, ENTCOD);
        else
            open r for
                select ENTCOD, OFECOD, ENTDATA
                from   ENTREVISTA
                where  (cons.OFECOD is null or  OFECOD = cons.OFECOD) and
                       (cons.ENTDATA is null or ENTDATA = cons.ENTDATA);
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_ENTREVISTA(p_entcod: ' || nvl(p_ENTCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_ENTREVISTA ;

    Procedure Consultar_ENTREVISTA ( t in out ENTREVISTA_tab, p_ENTCOD in number default null, cons in ENTREVISTA_typ ) is
        cursor c is
            select ENTCOD, OFECOD, ENTDATA
            from   ENTREVISTA
            where  ENTCOD = nvl(p_ENTCOD, ENTCOD);
        cursor c2 is
            select ENTCOD, OFECOD, ENTDATA
            from   ENTREVISTA
            where  (cons.OFECOD is null or  OFECOD = cons.OFECOD) and
                   (cons.ENTDATA is null or ENTDATA = cons.ENTDATA);
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_ENTCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).ENTCOD  :=  i.ENTCOD;
                t(l_count).OFECOD  :=  i.OFECOD;
                t(l_count).ENTDATA :=  i.ENTDATA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_ENTREVISTA(i.entcod: ' || i.ENTCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).ENTCOD  :=  i.ENTCOD;
                t(l_count).OFECOD  :=  i.OFECOD;
                t(l_count).ENTDATA :=  i.ENTDATA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_ENTREVISTA(i.entcod: ' || i.ENTCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_ENTREVISTA;

    Procedure Afegir_ENTREVISTA ( r in out ENTREVISTA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.ENTCOD is null then r.ENTCOD := GetPK_ENTREVISTA; end if;
        insert into ENTREVISTA(ENTCOD, OFECOD, ENTDATA)
                       values (r.ENTCOD, r.OFECOD, r.ENTDATA)
        returning ENTCOD, OFECOD, ENTDATA
             into r.ENTCOD, r.OFECOD, r.ENTDATA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_ENTREVISTA(r.entcod: ' || r.ENTCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_ENTREVISTA(r.entcod: ' || r.ENTCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_ENTREVISTA;

    Procedure Afegir_ENTREVISTA ( t in out ENTREVISTA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_ENTREVISTA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_ENTREVISTA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_ENTREVISTA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_ENTREVISTA;

    Procedure Esborrar_ENTREVISTA ( p_ENTCOD in ENTREVISTA.ENTCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   ENTREVISTA
        where  ENTCOD = p_ENTCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_ENTREVISTA(p_entcod: ' || nvl(p_ENTCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_ENTREVISTA(p_entcod: ' || nvl(p_ENTCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_ENTREVISTA;

    Procedure Esborrar_ENTREVISTA ( t in ENTREVISTA_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_ENTREVISTA(t(l_index).ENTCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_ENTREVISTA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_ENTREVISTA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_ENTREVISTA;

    Procedure Modificar_ENTREVISTA ( r in out ENTREVISTA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update ENTREVISTA
        set    OFECOD  = r.OFECOD,
               ENTDATA = r.ENTDATA
        where  ENTCOD = r.ENTCOD
        returning ENTCOD, OFECOD, ENTDATA
             into r.ENTCOD, r.OFECOD, r.ENTDATA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_ENTREVISTA(r.entcod: ' || r.ENTCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_ENTREVISTA(r.entcod: ' || r.ENTCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_ENTREVISTA;

    Procedure Modificar_ENTREVISTA ( t in out ENTREVISTA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_ENTREVISTA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_ENTREVISTA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modofocar_ENTREVISTA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_ENTREVISTA;

    /* Interficie PL/SQL per a la Taula ESP_LOG*/
    Function GetPK_ESPLOG return number is
        cursor c is
            select ESPLOG_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_ESPLOG;

    Procedure Consultar_ESPLOG ( r in out ESPLOG_ref, p_LOGCOD in number default null, cons in ESPLOG_typ ) is
    begin
        if p_LOGCOD is not null then
            open r for
                select LOGCOD, USRCOD, LOGINICI, LOGFINAL, LOGACCIO, LOGRESULT
                from   ESP_LOG
                where  LOGCOD = nvl(p_LOGCOD, LOGCOD);
        else
            open r for
                select LOGCOD, USRCOD, LOGINICI, LOGFINAL, LOGACCIO, LOGRESULT
                from   ESP_LOG
                where  (cons.USRCOD    is null or USRCOD    like trim(cons.USRCOD) || '%') and
                       (cons.LOGINICI  is null or to_char(LOGINICI, 'DD/MM/YYYY')  >= to_char(cons.LOGINICI,'DD/MM/YYYY')) and
                       (cons.LOGFINAL  is null or to_char(LOGFINAL, 'DD/MM/YYYY')  <= to_char(cons.LOGFINAL,'DD/MM/YYYY')) and
                       (cons.LOGACCIO  is null or LOGACCIO  like trim(cons.LOGACCIO) || '%') and
                       (cons.LOGRESULT is null or LOGRESULT like trim(cons.LOGRESULT) || '%')
                order by LOGCOD;
        end if;
    end Consultar_ESPLOG ;

    Procedure Consultar_ESPLOG ( t in out ESPLOG_tab, p_LOGCOD in number default null, cons in ESPLOG_typ ) is
        cursor c is
            select LOGCOD, USRCOD, LOGINICI, LOGFINAL, LOGACCIO, LOGRESULT
            from   ESP_LOG
            where  LOGCOD = nvl(p_LOGCOD, LOGCOD);
        cursor c2 is
            select LOGCOD, USRCOD, LOGINICI, LOGFINAL, LOGACCIO, LOGRESULT
            from   ESP_LOG
            where  (cons.USRCOD    is null or USRCOD    like trim(cons.USRCOD) || '%') and
                   (cons.LOGINICI  is null or to_char(LOGINICI, 'DD/MM/YYYY') >= to_char(cons.LOGINICI,'DD/MM/YYYY')) and
                   (cons.LOGFINAL  is null or to_char(LOGFINAL, 'DD/MM/YYYY') <= to_char(cons.LOGFINAL,'DD/MM/YYYY')) and
                   (cons.LOGACCIO  is null or LOGACCIO  like trim(cons.LOGACCIO) || '%') and
                   (cons.LOGRESULT is null or LOGRESULT like trim(cons.LOGRESULT) || '%')
            order by LOGCOD;
        l_count number := 0;
    begin
        if p_LOGCOD is not null then
            for i in c loop
                t(l_count).LOGCOD    :=  i.LOGCOD;
                t(l_count).USRCOD    :=  i.USRCOD;
                t(l_count).LOGINICI  :=  i.LOGINICI;
                t(l_count).LOGFINAL  :=  i.LOGFINAL;
                t(l_count).LOGACCIO  :=  i.LOGACCIO;
                t(l_count).LOGRESULT :=  i.LOGRESULT;
                l_count := l_count + 1;
            end loop;
        else
            for i in c2 loop
                t(l_count).LOGCOD    :=  i.LOGCOD;
                t(l_count).USRCOD    :=  i.USRCOD;
                t(l_count).LOGINICI  :=  i.LOGINICI;
                t(l_count).LOGFINAL  :=  i.LOGFINAL;
                t(l_count).LOGACCIO  :=  i.LOGACCIO;
                t(l_count).LOGRESULT :=  i.LOGRESULT;
                l_count := l_count + 1;
            end loop;
        end if;
    end Consultar_ESPLOG;

    Procedure Afegir_ESPLOG(l in out ESPLOG_typ, p_commit in boolean, e out xerror_typ) is
    begin
        insert into ESP_LOG(LOGCOD, USRCOD, LOGINICI, LOGFINAL, LOGACCIO, LOGRESULT)
                    values (GetPK_ESPLOG, l.USRCOD, l.LOGINICI, l.LOGFINAL, l.LOGACCIO, l.LOGRESULT)
        returning USRCOD, LOGINICI, LOGFINAL, LOGACCIO, LOGRESULT
             into l.USRCOD, l.LOGINICI, l.LOGFINAL, l.LOGACCIO, l.LOGRESULT;
        if p_commit then commit; end if;
        e.status := SUCCESS;
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;
                RAISE;
    end Afegir_ESPLOG;

    /* Interfcie PL/SQL per a la Taula EXPERIENCIACV*/
    Function GetPK_EXPERIENCIACV return number is
        cursor c is
            select EXPERIENCIACV_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_EXPERIENCIACV;

    Procedure Consultar_EXPERIENCIACV ( r in out EXPERIENCIACV_ref, p_SOLCOD in number default null, cons in EXPERIENCIACV_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_SOLCOD is not null then
            open r for
                select SOLCOD, SCATCOD, EMPNOM, EMPTEL, DATAINI, DATAFI
                from   EXPERIENCIACV
                where  SOLCOD = nvl(p_SOLCOD, SOLCOD);
        else
            open r for
                select SOLCOD, SCATCOD, EMPNOM, EMPTEL, DATAINI, DATAFI
                from   EXPERIENCIACV
                where  (cons.SCATCOD is null or SCATCOD = cons.SCATCOD) and
                       (cons.EMPNOM is null or  EMPNOM like trim(cons.EMPNOM) || '%') and
                       (cons.EMPTEL is null or  EMPTEL like trim(cons.EMPTEL) || '%') and
                       (cons.DATAINI is null or DATAINI = cons.DATAINI) and
                       (cons.DATAFI is null or  DATAFI = cons.DATAFI);
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_EXPERIENCIACV(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_EXPERIENCIACV ;

    Procedure Consultar_EXPERIENCIACV ( t in out EXPERIENCIACV_tab, p_SOLCOD in number default null, cons in EXPERIENCIACV_typ ) is
        cursor c is
            select SOLCOD, SCATCOD, EMPNOM, EMPTEL, DATAINI, DATAFI
            from   EXPERIENCIACV
            where  SOLCOD = nvl(p_SOLCOD, SOLCOD);
        cursor c2 is
            select SOLCOD, SCATCOD, EMPNOM, EMPTEL, DATAINI, DATAFI
            from   EXPERIENCIACV
            where  (cons.SCATCOD is null or SCATCOD = cons.SCATCOD) and
                   (cons.EMPNOM is null or  EMPNOM like trim(cons.EMPNOM) || '%') and
                   (cons.EMPTEL is null or  EMPTEL like trim(cons.EMPTEL) || '%') and
                   (cons.DATAINI is null or DATAINI = cons.DATAINI) and
                   (cons.DATAFI is null or  DATAFI = cons.DATAFI);
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin
        if p_SOLCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).SOLCOD  :=  i.SOLCOD;
                t(l_count).SCATCOD :=  i.SCATCOD;
                t(l_count).EMPNOM  :=  i.EMPNOM;
                t(l_count).EMPTEL  :=  i.EMPTEL;
                t(l_count).DATAINI :=  i.DATAINI;
                t(l_count).DATAFI  :=  i.DATAFI;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_EXPERIENCIACV(i.solcod: ' || i.SOLCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).SOLCOD  :=  i.SOLCOD;
                t(l_count).SCATCOD :=  i.SCATCOD;
                t(l_count).EMPNOM  :=  i.EMPNOM;
                t(l_count).EMPTEL  :=  i.EMPTEL;
                t(l_count).DATAINI :=  i.DATAINI;
                t(l_count).DATAFI  :=  i.DATAFI;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_EXPERIENCIACV(i.solcod: ' || i.SOLCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_EXPERIENCIACV;

    Procedure Afegir_EXPERIENCIACV ( r in out EXPERIENCIACV_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.SOLCOD is null then r.SOLCOD := GetPK_EXPERIENCIACV; end if;
        insert into EXPERIENCIACV(SOLCOD, SCATCOD, EMPNOM, EMPTEL, DATAINI, DATAFI)
                          values (r.SOLCOD, r.SCATCOD, r.EMPNOM, r.EMPTEL, r.DATAINI, r.DATAFI)
        returning SOLCOD, SCATCOD, EMPNOM, EMPTEL, DATAINI, DATAFI
             into r.SOLCOD, r.SCATCOD, r.EMPNOM, r.EMPTEL, r.DATAINI, r.DATAFI;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_EXPERIENCIACV(r.solcod: ' || r.SOLCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_EXPERIENCIACV(r.solcod: ' || r.SOLCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_EXPERIENCIACV;

    Procedure Afegir_EXPERIENCIACV ( t in out EXPERIENCIACV_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_EXPERIENCIACV(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_EXPERIENCIACV - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_EXPERIENCIACV - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_EXPERIENCIACV;

    Procedure Esborrar_EXPERIENCIACV ( p_SOLCOD in EXPERIENCIACV.SOLCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   EXPERIENCIACV
        where  SOLCOD = p_SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_EXPERIENCIACV(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_EXPERIENCIACV(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_EXPERIENCIACV;

    Procedure Esborrar_EXPERIENCIACV ( t in EXPERIENCIACV_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_EXPERIENCIACV(t(l_index).SOLCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_EXPERIENCIACV - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_EXPERIENCIACV - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_EXPERIENCIACV;

    Procedure Modificar_EXPERIENCIACV ( r in out EXPERIENCIACV_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update EXPERIENCIACV
        set    EMPNOM  = r.EMPNOM,
               EMPTEL  = r.EMPTEL,
               DATAINI = r.DATAINI,
               DATAFI  = r.DATAFI
        where  SOLCOD  = r.SOLCOD and SCATCOD = r.SCATCOD
        returning SOLCOD, SCATCOD, EMPNOM, EMPTEL, DATAINI, DATAFI
             into r.SOLCOD, r.SCATCOD, r.EMPNOM, r.EMPTEL, r.DATAINI, r.DATAFI;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_EXPERIENCIACV(r.solcod: ' || r.SOLCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_EXPERIENCIACV(r.solcod: ' || r.SOLCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_EXPERIENCIACV;

    Procedure Modificar_EXPERIENCIACV ( t in out EXPERIENCIACV_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_EXPERIENCIACV(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modofocar_EXPERIENCIACV - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_EXPERIENCIACV - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_EXPERIENCIACV;

    /* Interfcie PL/SQL per a la Taula IDIOMES*/
    Function GetPK_IDIOMES return number is
        cursor c is
            select IDIOMES_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_IDIOMES;

    Procedure Consultar_IDIOMES ( r in out IDIOMES_ref, p_IDIOCOD in number default null, cons in IDIOMES_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_IDIOCOD is not null then
            open r for
                select IDIOCOD, IDIODESC
                from   IDIOMES
                where  IDIOCOD = nvl(p_IDIOCOD, IDIOCOD);
        else
            open r for
                select IDIOCOD, IDIODESC
                from   IDIOMES
                where  (cons.IDIODESC is null or IDIODESC like trim(cons.IDIODESC) || '%');
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_IDIOMES(p_idiocod: ' || nvl(p_IDIOCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_IDIOMES ;

    Procedure Consultar_IDIOMES ( t in out IDIOMES_tab, p_IDIOCOD in number default null, cons in IDIOMES_typ ) is
        cursor c is
            select IDIOCOD, IDIODESC
            from   IDIOMES
            where  IDIOCOD = nvl(p_IDIOCOD, IDIOCOD);
        cursor c2 is
            select IDIOCOD, IDIODESC
            from   IDIOMES
            where  (cons.IDIODESC is null or IDIODESC like trim(cons.IDIODESC) || '%');
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_IDIOCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).IDIOCOD  :=  i.IDIOCOD;
                t(l_count).IDIODESC :=  i.IDIODESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_IDIOMES(i.idiocod: ' || i.IDIOCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).IDIOCOD  :=  i.IDIOCOD;
                t(l_count).IDIODESC :=  i.IDIODESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_IDIOMES(i.idiocod: ' || i.IDIOCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_IDIOMES;

    Procedure Afegir_IDIOMES ( r in out IDIOMES_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.IDIOCOD is null then r.IDIOCOD := GetPK_IDIOMES; end if;
        insert into IDIOMES(IDIOCOD, IDIODESC)
                    values (r.IDIOCOD, r.IDIODESC)
        returning IDIOCOD, IDIODESC
             into r.IDIOCOD, r.IDIODESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_IDIOMES(r.idiocod: ' || r.IDIOCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_IDIOMES(r.idiocod: ' || r.IDIOCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_IDIOMES;

    Procedure Afegir_IDIOMES ( t in out IDIOMES_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_IDIOMES(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_IDIOMES - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_IDIOMES - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_IDIOMES;

    Procedure Esborrar_IDIOMES ( p_IDIOCOD in IDIOMES.IDIOCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   IDIOMES
        where  IDIOCOD = p_IDIOCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_IDIOMES(p_idiocod: ' || nvl(p_IDIOCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_IDIOMES(p_idiocod: ' || nvl(p_IDIOCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_IDIOMES;

    Procedure Esborrar_IDIOMES ( t in IDIOMES_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_IDIOMES(t(l_index).IDIOCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_IDIOMES - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_IDIOMES - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_IDIOMES;

    Procedure Modificar_IDIOMES ( r in out IDIOMES_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update IDIOMES
        set    IDIODESC = r.IDIODESC
        where  IDIOCOD = r.IDIOCOD
        returning IDIOCOD, IDIODESC
             into r.IDIOCOD, r.IDIODESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_IDIOMES(r.idiocod: ' || r.IDIOCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_IDIOMES(r.idiocod: ' || r.IDIOCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_IDIOMES;

    Procedure Modificar_IDIOMES ( t in out IDIOMES_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_IDIOMES(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modoficar_IDIOMES - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_IDIOMES - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_IDIOMES;

    /* Interfcie PL/SQL per a la Taula IDIOMESCV*/
    Function GetPK_IDIOMESCV return number is
        cursor c is
            select IDIOMESCV_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_IDIOMESCV;

    Procedure Consultar_IDIOMESCV ( r in out IDIOMESCV_ref, p_SOLCOD in number default null, cons in IDIOMESCV_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_SOLCOD is not null then
            open r for
                select SOLCOD, IDIOCOD, NIVORA, NIVESC
                from   IDIOMESCV
                where  SOLCOD = nvl(p_SOLCOD, SOLCOD);
        else
            open r for
                select SOLCOD, IDIOCOD, NIVORA, NIVESC
                from   IDIOMESCV
                where  (cons.IDIOCOD is null or IDIOCOD = cons.IDIOCOD) and
                       (cons.NIVORA is null or  NIVORA like trim(cons.NIVORA) || '%') and
                       (cons.NIVESC is null or  NIVESC like trim(cons.NIVESC) || '%');
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_IDIOMESCV(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_IDIOMESCV ;

    Procedure Consultar_IDIOMESCV ( t in out IDIOMESCV_tab, p_SOLCOD in number default null, cons in IDIOMESCV_typ ) is
        cursor c is
            select SOLCOD, IDIOCOD, NIVORA, NIVESC
            from   IDIOMESCV
            where  SOLCOD = nvl(p_SOLCOD, SOLCOD);
        cursor c2 is
            select SOLCOD, IDIOCOD, NIVORA, NIVESC
            from   IDIOMESCV
            where  (cons.IDIOCOD is null or IDIOCOD = cons.IDIOCOD) and
                   (cons.NIVORA is null or  NIVORA like trim(cons.NIVORA) || '%') and
                   (cons.NIVESC is null or  NIVESC like trim(cons.NIVESC) || '%');
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_SOLCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).SOLCOD  :=  i.SOLCOD;
                t(l_count).IDIOCOD :=  i.IDIOCOD;
                t(l_count).NIVORA  :=  i.NIVORA;
                t(l_count).NIVESC  :=  i.NIVESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_IDIOMESCV(i.solcod: ' || i.SOLCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).SOLCOD  :=  i.SOLCOD;
                t(l_count).IDIOCOD :=  i.IDIOCOD;
                t(l_count).NIVORA  :=  i.NIVORA;
                t(l_count).NIVESC  :=  i.NIVESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_IDIOMESCV(i.solcod: ' || i.SOLCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_IDIOMESCV;

    Procedure Afegir_IDIOMESCV ( r in out IDIOMESCV_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.SOLCOD is null then r.SOLCOD := GetPK_IDIOMESCV; end if;
        insert into IDIOMESCV(SOLCOD, IDIOCOD, NIVORA, NIVESC)
                      values (r.SOLCOD, r.IDIOCOD, r.NIVORA, r.NIVESC)
        returning SOLCOD, IDIOCOD, NIVORA, NIVESC
             into r.SOLCOD, r.IDIOCOD, r.NIVORA, r.NIVESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_IDIOMESCV(r.solcol: ' || r.SOLCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_IDIOMESCV(r.solcod: ' || r.SOLCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_IDIOMESCV;

    Procedure Afegir_IDIOMESCV ( t in out IDIOMESCV_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_IDIOMESCV(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_IDIOMESCV - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_IDIOMESCV - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_IDIOMESCV;

    Procedure Esborrar_IDIOMESCV ( p_SOLCOD in IDIOMESCV.SOLCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   IDIOMESCV
        where  SOLCOD = p_SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_IDIOMESCV(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_IDIOMESCV(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_IDIOMESCV;

    Procedure Esborrar_IDIOMESCV ( t in IDIOMESCV_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_IDIOMESCV(t(l_index).SOLCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_IDIOMESCV - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_IDIOMESCV - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_IDIOMESCV;

    Procedure Modificar_IDIOMESCV ( r in out IDIOMESCV_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update IDIOMESCV
        set    NIVORA  = r.NIVORA,
               NIVESC  = r.NIVESC
        where  SOLCOD = r.SOLCOD and IDIOCOD = r.IDIOCOD
        returning SOLCOD, IDIOCOD, NIVORA, NIVESC
             into r.SOLCOD, r.IDIOCOD, r.NIVORA, r.NIVESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_IDIOMESCV(r.solcod: ' || r.SOLCOD || ', r.idiocod: ' || r.IDIOCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_IDIOMESCV(r.solcod: ' || r.SOLCOD || ', r.idiocod: ' || r.IDIOCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_IDIOMESCV;

    Procedure Modificar_IDIOMESCV ( t in out IDIOMESCV_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_IDIOMESCV(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_IDIOMESCV - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;
                RAISE;
    end Modificar_IDIOMESCV;

    /* Interfcie PL/SQL per a la Taula IDIOMESOT*/
    Function GetPK_IDIOMESOT return number is
        cursor c is
            select IDIOMESOT_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_IDIOMESOT;

    Procedure Consultar_IDIOMESOT ( r in out IDIOMESOT_ref, p_OFECOD in number default null, cons in IDIOMESOT_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_OFECOD is not null then
            open r for
                select OFECOD, IDIOCOD
                from   IDIOMESOT
                where  OFECOD = nvl(p_OFECOD, OFECOD);
        else
            open r for
                select OFECOD, IDIOCOD
                from   IDIOMESOT
                where  (cons.IDIOCOD is null or IDIOCOD = cons.IDIOCOD);
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_IDIOMESOT(p_ofecod: ' || nvl(p_OFECOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_IDIOMESOT ;

    Procedure Consultar_IDIOMESOT ( t in out IDIOMESOT_tab, p_OFECOD in number default null, cons in IDIOMESOT_typ ) is
        cursor c is
            select OFECOD, IDIOCOD
            from   IDIOMESOT
            where  OFECOD = nvl(p_OFECOD, OFECOD);
        cursor c2 is
            select OFECOD, IDIOCOD
            from   IDIOMESOT
            where  (cons.IDIOCOD is null or IDIOCOD = cons.IDIOCOD);
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin
        if p_OFECOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).OFECOD  :=  i.OFECOD;
                t(l_count).IDIOCOD :=  i.IDIOCOD;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_IDIOMESOT(i.ofecod: ' || i.OFECOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).OFECOD  :=  i.OFECOD;
                t(l_count).IDIOCOD :=  i.IDIOCOD;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_IDIOMESOT(i.ofecod: ' || i.OFECOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_IDIOMESOT;

    Procedure Afegir_IDIOMESOT ( r in out IDIOMESOT_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.OFECOD is null then r.OFECOD := GetPK_IDIOMESOT; end if;
        insert into IDIOMESOT(OFECOD, IDIOCOD)
                      values (r.OFECOD, r.IDIOCOD)
        returning OFECOD, IDIOCOD
             into r.OFECOD, r.IDIOCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_IDIOMESOT(r.ofecod: ' || r.OFECOD || ', r.idiocod: ' || r.IDIOCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_IDIOMESOT(r.ofecod: ' || r.OFECOD || ', r.idiocod: ' || r.IDIOCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_IDIOMESOT;

    Procedure Afegir_IDIOMESOT ( t in out IDIOMESOT_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_IDIOMESOT(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_IDIOMESOT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_IDIOMESOT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_IDIOMESOT;

    Procedure Esborrar_IDIOMESOT ( p_OFECOD in IDIOMESOT.OFECOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   IDIOMESOT
        where  OFECOD = p_OFECOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_IDIOMESOT(p_ofecod: ' || nvl(p_OFECOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_IDIOMESOT(p_ofecod: ' || nvl(p_OFECOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_IDIOMESOT;

    Procedure Esborrar_IDIOMESOT ( t in IDIOMESOT_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_IDIOMESOT(t(l_index).OFECOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_IDIOMESOT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_IDIOMESOT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_IDIOMESOT;

    Procedure Modificar_IDIOMESOT ( r in out IDIOMESOT_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update IDIOMESOT
        set    IDIOCOD = r.IDIOCOD
        where  OFECOD = r.OFECOD
        returning OFECOD, IDIOCOD
             into r.OFECOD, r.IDIOCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_IDIOMESOT(r.ofecod: ' || r.OFECOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_IDIOMESOT(r.ofecod: ' || r.OFECOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_IDIOMESOT;

    Procedure Modificar_IDIOMESOT ( t in out IDIOMESOT_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_IDIOMESOT(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_IDIOMESOT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_IDIOMESOT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_IDIOMESOT;

    /* Interfcie PL/SQL per a la Taula INTERESSAT*/
    Function GetPK_INTERESSAT return number is
        cursor c is
            select INTERESSAT_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_INTERESSAT;

    Procedure Consultar_INTERESSAT ( r in out INTERESSAT_ref, p_EMPCOD in number default null, cons in INTERESSAT_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_EMPCOD is not null then
            open r for
                select EMPCOD, SOLCOD
                from   INTERESSAT
                where  EMPCOD = nvl(p_EMPCOD, EMPCOD);
        else
            open r for
                select EMPCOD, SOLCOD
                from   INTERESSAT
                where  (cons.SOLCOD is null or SOLCOD = cons.SOLCOD);
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_INTERESSAT(p_empcod: ' || nvl(p_EMPCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_INTERESSAT ;

    Procedure Consultar_INTERESSAT ( t in out INTERESSAT_tab, p_EMPCOD in number default null, cons in INTERESSAT_typ ) is
        cursor c is
            select EMPCOD, SOLCOD
            from   INTERESSAT
            where  EMPCOD = nvl(p_EMPCOD, EMPCOD);
        cursor c2 is
            select EMPCOD, SOLCOD
            from   INTERESSAT
            where  EMPCOD = nvl(p_EMPCOD, EMPCOD);
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin
        if p_EMPCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).EMPCOD :=  i.EMPCOD;
                t(l_count).SOLCOD :=  i.SOLCOD;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_INTERESSAT(i.empcod: ' || i.EMPCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).EMPCOD :=  i.EMPCOD;
                t(l_count).SOLCOD :=  i.SOLCOD;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_INTERESSAT(i.empcod: ' || i.EMPCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_INTERESSAT;

    Procedure Afegir_INTERESSAT ( r in out INTERESSAT_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;


        if r.EMPCOD is null then r.EMPCOD := GetPK_INTERESSAT; end if;
        insert into INTERESSAT(EMPCOD, SOLCOD)
                       values (r.EMPCOD, r.SOLCOD)
        returning EMPCOD, SOLCOD
             into r.EMPCOD, r.SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_INTERESSAT(r.empcod: ' || r.EMPCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_INTERESSAT(r.empcod: ' || r.EMPCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_INTERESSAT;

    Procedure Afegir_INTERESSAT ( t in out INTERESSAT_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;


        loop
            Afegir_INTERESSAT(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_INTERESSAT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_INTERESSAT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_INTERESSAT;

    Procedure Esborrar_INTERESSAT ( p_EMPCOD in INTERESSAT.EMPCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   INTERESSAT
        where  EMPCOD = p_EMPCOD;

        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_INTERESSAT(p_empcod: ' || nvl(p_EMPCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_INTERESSAT(p_empcod: ' || nvl(p_EMPCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_INTERESSAT;

    Procedure Esborrar_INTERESSAT ( t in INTERESSAT_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;


        loop
            Esborrar_INTERESSAT(t(l_index).EMPCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_INTERESSAT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_INTERESSAT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_INTERESSAT;

    Procedure Modificar_INTERESSAT ( r in out INTERESSAT_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update INTERESSAT
        set    SOLCOD = r.SOLCOD
        where  EMPCOD = r.EMPCOD
        returning EMPCOD, SOLCOD
             into r.EMPCOD, r.SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_INTERESSAT(r.empcod: ' || r.EMPCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_INTERESSAT(r.empcod: ' || r.EMPCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_INTERESSAT;

    Procedure Modificar_INTERESSAT ( t in out INTERESSAT_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_INTERESSAT(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_INTERESSAT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_INTERESSAT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_INTERESSAT;

    /* Interfcie PL/SQL per a la Taula NIVELL*/
    Function GetPK_NIVELL return number is
        cursor c is
            select NIVELL_seq.nextval
            from   sys.dual;
        pk number;
    begin
    open c;
    fetch c into pk;
    close c;
    return pk;
    exception
        when others then
            return null;
    end GetPK_NIVELL;

    Procedure Consultar_NIVELL ( r in out NIVELL_ref, p_NIVCOD in number default null, cons in NIVELL_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_NIVCOD is not null then
            open r for
                select NIVCOD, NIVDESC
                from   NIVELL
                where  NIVCOD = nvl(p_NIVCOD, NIVCOD);
        else
            open r for
                select NIVCOD, NIVDESC
                from   NIVELL
                where  (cons.NIVDESC is null or NIVDESC like trim(cons.NIVDESC) || '%');
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_NIVELL(p_nivcod: ' || nvl(p_NIVCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_NIVELL ;

    Procedure Consultar_NIVELL ( t in out NIVELL_tab, p_NIVCOD in number default null, cons in NIVELL_typ ) is
        cursor c is
            select NIVCOD, NIVDESC
            from   NIVELL
            where  NIVCOD = nvl(p_NIVCOD, NIVCOD);
        cursor c2 is
            select NIVCOD, NIVDESC
            from   NIVELL
            where  (cons.NIVDESC is null or NIVDESC like trim(cons.NIVDESC) || '%');
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_NIVCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).NIVCOD  :=  i.NIVCOD;
                t(l_count).NIVDESC :=  i.NIVDESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_NIVELL(i.nivcod: ' || i.NIVCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).NIVCOD  :=  i.NIVCOD;
                t(l_count).NIVDESC :=  i.NIVDESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_NIVELL(i.nivcod: ' || i.NIVCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_NIVELL;

    Procedure Afegir_NIVELL ( r in out NIVELL_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.NIVCOD is null then r.NIVCOD := GetPK_NIVELL; end if;
        insert into NIVELL(NIVCOD, NIVDESC)
                   values (r.NIVCOD, r.NIVDESC)
        returning NIVCOD, NIVDESC
             into r.NIVCOD, r.NIVDESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_NIVELL(r.nivcod: ' || r.NIVCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_NIVELL(r.nivcod: ' || r.NIVCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_NIVELL;

    Procedure Afegir_NIVELL ( t in out NIVELL_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_NIVELL(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_NIVELL - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_NIVELL - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_NIVELL;

    Procedure Esborrar_NIVELL ( p_NIVCOD in NIVELL.NIVCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   NIVELL
        where  NIVCOD = p_NIVCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_NIVELL(p_nivcod: ' || nvl(p_NIVCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_NIVELL(p_nivcod: ' || nvl(p_NIVCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_NIVELL;

    Procedure Esborrar_NIVELL ( t in NIVELL_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_NIVELL(t(l_index).NIVCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_NIVELL - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_NIVELL - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_NIVELL;

    Procedure Modificar_NIVELL ( r in out NIVELL_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update NIVELL
        set    NIVDESC = r.NIVDESC
        where  NIVCOD = r.NIVCOD
        returning NIVCOD, NIVDESC
             into r.NIVCOD, r.NIVDESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_NIVELL(r.nivcod: ' || r.NIVCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_NIVELL(r.nivcod: ' || r.NIVCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_NIVELL;

    Procedure Modificar_NIVELL ( t in out NIVELL_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_NIVELL(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_NIVELL - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_NIVELL - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_NIVELL;

    /* Interfcie PL/SQL per a la Taula OFERTATREBALL*/
    Function GetPK_OFERTATREBALL return number is
        cursor c is
            select OFERTATREBALL_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_OFERTATREBALL;

    Procedure Consultar_OFERTATREBALL ( r in out OFERTATREBALL_ref, p_OFECOD in number default null, cons in OFERTATREBALL_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_OFECOD is not null then
            open r for
                select OFECOD, EMPCOD, PERFCOD, CTECOD, TJOCOD, SCATCOD, OTDESC, SOUMIN,
                       SOUMAX, SWBAIXA, OFEINI, OFEDIES, OFEFI
                from   OFERTATREBALL
                where  OFECOD = nvl(p_OFECOD, OFECOD) and
                       SWBAIXA <> 1;
        else
            open r for
                select OFECOD, EMPCOD, PERFCOD, CTECOD, TJOCOD, SCATCOD, OTDESC, SOUMIN,
                       SOUMAX, SWBAIXA, OFEINI, OFEDIES, OFEFI
                from   OFERTATREBALL
                where  (cons.EMPCOD is null or  EMPCOD = cons.EMPCOD) and
                       (cons.PERFCOD is null or PERFCOD = cons.PERFCOD) and
                       (cons.CTECOD is null or  CTECOD = cons.CTECOD) and
                       (cons.TJOCOD is null or  TJOCOD = cons.TJOCOD) and
                       (cons.SCATCOD is null or SCATCOD = cons.SCATCOD) and
                       (cons.OTDESC is null or  OTDESC like trim(cons.OTDESC) || '%') and
                       (cons.SOUMIN is null or  SOUMIN >= cons.SOUMIN) and
                       (cons.SOUMAX is null or  SOUMAX <= cons.SOUMAX) and
                       (cons.OFEINI is null or  OFEINI = cons.OFEINI) and
                       (cons.OFEDIES is null or OFEDIES = cons.OFEDIES) and
                       (cons.OFEFI is null or   OFEFI = cons.OFEFI) and
                       SWBAIXA <> 1;
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_OFERTATREBALL(p_ofecod: ' || nvl(p_OFECOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_OFERTATREBALL ;

    Procedure Consultar_OFERTATREBALL ( t in out OFERTATREBALL_tab, p_OFECOD in number default null, cons in OFERTATREBALL_typ ) is
        cursor c is
            select OFECOD, EMPCOD, PERFCOD, CTECOD, TJOCOD, SCATCOD, OTDESC, SOUMIN,
                   SOUMAX, SWBAIXA, OFEINI, OFEDIES, OFEFI
            from   OFERTATREBALL
            where  OFECOD = nvl(p_OFECOD, OFECOD) and
                   SWBAIXA <> 1;
        cursor c2 is
            select OFECOD, EMPCOD, PERFCOD, CTECOD, TJOCOD, SCATCOD, OTDESC, SOUMIN,
                   SOUMAX, SWBAIXA, OFEINI, OFEDIES, OFEFI
            from   OFERTATREBALL
            where  (cons.EMPCOD is null or  EMPCOD = cons.EMPCOD) and
                   (cons.PERFCOD is null or PERFCOD = cons.PERFCOD) and
                   (cons.CTECOD is null or  CTECOD = cons.CTECOD) and
                   (cons.TJOCOD is null or  TJOCOD = cons.TJOCOD) and
                   (cons.SCATCOD is null or SCATCOD = cons.SCATCOD) and
                   (cons.OTDESC is null or  OTDESC like trim(cons.OTDESC) || '%') and
                   (cons.SOUMIN is null or  SOUMIN >= cons.SOUMIN) and
                   (cons.SOUMAX is null or  SOUMAX <= cons.SOUMAX) and
                   (cons.OFEINI is null or  OFEINI = cons.OFEINI) and
                   (cons.OFEDIES is null or OFEDIES = cons.OFEDIES) and
                   (cons.OFEFI is null or   OFEFI = cons.OFEFI) and
                   SWBAIXA <> 1;
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_OFECOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).OFECOD  :=  i.OFECOD;
                t(l_count).EMPCOD  :=  i.EMPCOD;
                t(l_count).PERFCOD :=  i.PERFCOD;
                t(l_count).CTECOD  :=  i.CTECOD;
                t(l_count).TJOCOD  :=  i.TJOCOD;
                t(l_count).SCATCOD :=  i.SCATCOD;
                t(l_count).OTDESC  :=  i.OTDESC;
                t(l_count).SOUMIN  :=  i.SOUMIN;
                t(l_count).SOUMAX  :=  i.SOUMAX;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                t(l_count).OFEINI  :=  i.OFEINI;
                t(l_count).OFEDIES :=  i.OFEDIES;
                t(l_count).OFEFI   :=  i.OFEFI;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_OFERTATREBALL(i.ofecod: ' || i.OFECOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).OFECOD  :=  i.OFECOD;
                t(l_count).EMPCOD  :=  i.EMPCOD;
                t(l_count).PERFCOD :=  i.PERFCOD;
                t(l_count).CTECOD  :=  i.CTECOD;
                t(l_count).TJOCOD  :=  i.TJOCOD;
                t(l_count).SCATCOD :=  i.SCATCOD;
                t(l_count).OTDESC  :=  i.OTDESC;
                t(l_count).SOUMIN  :=  i.SOUMIN;
                t(l_count).SOUMAX  :=  i.SOUMAX;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                t(l_count).OFEINI  :=  i.OFEINI;
                t(l_count).OFEDIES :=  i.OFEDIES;
                t(l_count).OFEFI   :=  i.OFEFI;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_OFERTATREBALL(i.ofecod: ' || i.OFECOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_OFERTATREBALL;

    Procedure Consultar_OFERTATREBALL_Activa ( t in out OFERTATREBALL_tab, p_OFECOD in number default null, cons in OFERTATREBALL_typ ) is
        cursor c is
            select OFECOD, EMPCOD, PERFCOD, CTECOD, TJOCOD, SCATCOD, OTDESC, SOUMIN,
                   SOUMAX, SWBAIXA, OFEINI, OFEDIES, OFEFI
            from   OFERTATREBALL
            where  OFECOD = nvl(p_OFECOD, OFECOD) and
                   OFEFI is null and
                   SWBAIXA <> 1;
        cursor c2 is
            select OFECOD, EMPCOD, PERFCOD, CTECOD, TJOCOD, SCATCOD, OTDESC, SOUMIN,
                   SOUMAX, SWBAIXA, OFEINI, OFEDIES, OFEFI
            from   OFERTATREBALL
            where  (cons.EMPCOD is null or  EMPCOD = cons.EMPCOD) and
                   (cons.PERFCOD is null or PERFCOD = cons.PERFCOD) and
                   (cons.CTECOD is null or  CTECOD = cons.CTECOD) and
                   (cons.TJOCOD is null or  TJOCOD = cons.TJOCOD) and
                   (cons.SCATCOD is null or SCATCOD = cons.SCATCOD) and
                   (cons.OTDESC is null or  OTDESC like trim(cons.OTDESC) || '%') and
                   (cons.SOUMIN is null or  SOUMIN >= cons.SOUMIN) and
                   (cons.SOUMAX is null or  SOUMAX <= cons.SOUMAX) and
                   (cons.OFEINI is null or  OFEINI = cons.OFEINI) and
                   (cons.OFEDIES is null or OFEDIES = cons.OFEDIES) and
                   OFEFI is null and
                   SWBAIXA <> 1;
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_OFECOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).OFECOD  :=  i.OFECOD;
                t(l_count).EMPCOD  :=  i.EMPCOD;
                t(l_count).PERFCOD :=  i.PERFCOD;
                t(l_count).CTECOD  :=  i.CTECOD;
                t(l_count).TJOCOD  :=  i.TJOCOD;
                t(l_count).SCATCOD :=  i.SCATCOD;
                t(l_count).OTDESC  :=  i.OTDESC;
                t(l_count).SOUMIN  :=  i.SOUMIN;
                t(l_count).SOUMAX  :=  i.SOUMAX;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                t(l_count).OFEINI  :=  i.OFEINI;
                t(l_count).OFEDIES :=  i.OFEDIES;
                t(l_count).OFEFI   :=  i.OFEFI;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_OFERTATREBALL(i.ofecod: ' || i.OFECOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).OFECOD  :=  i.OFECOD;
                t(l_count).EMPCOD  :=  i.EMPCOD;
                t(l_count).PERFCOD :=  i.PERFCOD;
                t(l_count).CTECOD  :=  i.CTECOD;
                t(l_count).TJOCOD  :=  i.TJOCOD;
                t(l_count).SCATCOD :=  i.SCATCOD;
                t(l_count).OTDESC  :=  i.OTDESC;
                t(l_count).SOUMIN  :=  i.SOUMIN;
                t(l_count).SOUMAX  :=  i.SOUMAX;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                t(l_count).OFEINI  :=  i.OFEINI;
                t(l_count).OFEDIES :=  i.OFEDIES;
                t(l_count).OFEFI   :=  i.OFEFI;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_OFERTATREBALL_Activa(i.ofecod: ' || i.OFECOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_OFERTATREBALL_Activa;

    Procedure Afegir_OFERTATREBALL ( r in out OFERTATREBALL_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.OFECOD is null then r.OFECOD := GetPK_OFERTATREBALL; end if;
        if r.SWBAIXA is null then r.SWBAIXA := 0; end if;
        insert into OFERTATREBALL(OFECOD, EMPCOD, PERFCOD, CTECOD, TJOCOD, SCATCOD, OTDESC, SOUMIN,
                                  SOUMAX, SWBAIXA, OFEINI, OFEDIES, OFEFI)
                          values (r.OFECOD, r.EMPCOD, r.PERFCOD, r.CTECOD, r.TJOCOD, r.SCATCOD, r.OTDESC, r.SOUMIN,
                                  r.SOUMAX, r.SWBAIXA, r.OFEINI, r.OFEDIES, r.OFEFI)
        returning OFECOD, EMPCOD, PERFCOD, CTECOD, TJOCOD, SCATCOD, OTDESC, SOUMIN,
                  SOUMAX, SWBAIXA, OFEINI, OFEDIES, OFEFI
             into r.OFECOD, r.EMPCOD, r.PERFCOD, r.CTECOD, r.TJOCOD, r.SCATCOD, r.OTDESC, r.SOUMIN,
                  r.SOUMAX, r.SWBAIXA, r.OFEINI, r.OFEDIES, r.OFEFI;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_OFERTATREBALL(r.ofecod: ' || r.OFECOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_OFERTATREBALL(r.ofecod: ' || r.OFECOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_OFERTATREBALL;

    Procedure Afegir_OFERTATREBALL ( t in out OFERTATREBALL_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_OFERTATREBALL(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_OFERTATREBALL - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_OFERTATREBALL - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_OFERTATREBALL;

    Procedure Esborrar_OFERTATREBALL ( p_OFECOD in OFERTATREBALL.OFECOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update OFERTATREBALL
        set    SWBAIXA = 1
        where  OFECOD = p_OFECOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_OFERTATREBALL(p_ofecod: ' || nvl(p_OFECOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_OFERTATREBALL(p_ofecod: ' || nvl(p_OFECOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_OFERTATREBALL;

    Procedure Esborrar_OFERTATREBALL ( t in OFERTATREBALL_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_OFERTATREBALL(t(l_index).OFECOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_OFERTATREBALL - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_OFERTATREBALL - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_OFERTATREBALL;

    Procedure Modificar_OFERTATREBALL ( r in out OFERTATREBALL_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update OFERTATREBALL
        set    EMPCOD  = r.EMPCOD,
               PERFCOD = r.PERFCOD,
               CTECOD  = r.CTECOD,
               TJOCOD  = r.TJOCOD,
               SCATCOD = r.SCATCOD,
               OTDESC  = r.OTDESC,
               SOUMIN  = r.SOUMIN,
               SOUMAX  = r.SOUMAX,
               SWBAIXA = r.SWBAIXA,
               OFEINI  = r.OFEINI,
               OFEDIES = r.OFEDIES,
               OFEFI   = r.OFEFI
        where  OFECOD = r.OFECOD
        returning OFECOD, EMPCOD, PERFCOD, CTECOD, TJOCOD, SCATCOD, OTDESC, SOUMIN,
                  SOUMAX, SWBAIXA, OFEINI, OFEDIES, OFEFI
             into r.OFECOD, r.EMPCOD, r.PERFCOD, r.CTECOD, r.TJOCOD, r.SCATCOD, r.OTDESC, r.SOUMIN,
                  r.SOUMAX, r.SWBAIXA, r.OFEINI, r.OFEDIES, r.OFEFI;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_OFERTATREBALL(r.ofecod: ' || r.OFECOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_OFERTATREBALL(r.ofecod: ' || r.OFECOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_OFERTATREBALL;

    Procedure Modificar_OFERTATREBALL ( t in out OFERTATREBALL_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_OFERTATREBALL(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_OFERTATREBALL - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_OFERTATREBALL - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_OFERTATREBALL;

    /* Interfcie PL/SQL per a la Taula PERFIL*/
    Function GetPK_PERFIL return number is
        cursor c is
            select PERFIL_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_PERFIL;

    Procedure Consultar_PERFIL ( r in out PERFIL_ref, p_PERFCOD in number default null, cons in PERFIL_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_PERFCOD is not null then
            open r for
                select PERFCOD, PERFDESC
                from   PERFIL
                where  PERFCOD = nvl(p_PERFCOD, PERFCOD);
        else
            open r for
                select PERFCOD, PERFDESC
                from   PERFIL
                where  (cons.PERFDESC is null or PERFDESC like trim(cons.PERFDESC) || '%');
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_PERFIL(p_perfcod: ' || nvl(p_PERFCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_PERFIL ;

    Procedure Consultar_PERFIL ( t in out PERFIL_tab, p_PERFCOD in number default null, cons in PERFIL_typ ) is
        cursor c is
            select PERFCOD, PERFDESC
            from   PERFIL
            where  PERFCOD = nvl(p_PERFCOD, PERFCOD);
        cursor c2 is
            select PERFCOD, PERFDESC
            from   PERFIL
            where  (cons.PERFDESC is null or PERFDESC like trim(cons.PERFDESC) || '%');
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_PERFCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).PERFCOD  :=  i.PERFCOD;
                t(l_count).PERFDESC :=  i.PERFDESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_PERFIL(i.perfcod: ' || i.PERFCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).PERFCOD  :=  i.PERFCOD;
                t(l_count).PERFDESC :=  i.PERFDESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_PERFIL(i.perfcod: ' || i.PERFCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_PERFIL;

    Procedure Afegir_PERFIL ( r in out PERFIL_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.PERFCOD is null then r.PERFCOD := GetPK_PERFIL; end if;
        insert into PERFIL(PERFCOD, PERFDESC)
                   values (r.PERFCOD, r.PERFDESC)
        returning PERFCOD, PERFDESC
             into r.PERFCOD, r.PERFDESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_PERFIL(r.perfcod: ' || r.PERFCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_PERFIL(r.perfcod: ' || r.PERFCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_PERFIL;

    Procedure Afegir_PERFIL ( t in out PERFIL_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_PERFIL(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_PERFIL - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_PERFIL - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_PERFIL;

    Procedure Esborrar_PERFIL ( p_PERFCOD in PERFIL.PERFCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   PERFIL
        where  PERFCOD = p_PERFCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_PERFIL(p_perfcod: ' || nvl(p_PERFCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_PERFIL(p_perfcod: ' || nvl(p_PERFCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_PERFIL;

    Procedure Esborrar_PERFIL ( t in PERFIL_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_PERFIL(t(l_index).PERFCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_PERFIL - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_PERFIL - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_PERFIL;

    Procedure Modificar_PERFIL ( r in out PERFIL_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update PERFIL
        set    PERFDESC = r.PERFDESC
        where  PERFCOD = r.PERFCOD
        returning PERFCOD, PERFDESC
             into r.PERFCOD, r.PERFDESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_PERFIL(r.perfcod: ' || r.PERFCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_PERFIL(r.perfcod: ' || r.PERFCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_PERFIL;

    Procedure Modificar_PERFIL ( t in out PERFIL_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_PERFIL(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_PERFIL - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_PERFIL - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_PERFIL;

    /* Interfcie PL/SQL per a la Taula REBUTJATS*/
    Function GetPK_REBUTJATS return number is
        cursor c is
            select REBUTJATS_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_REBUTJATS;

    Procedure Consultar_REBUTJATS ( r in out REBUTJATS_ref, p_EMPCOD in number default null, cons in REBUTJATS_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_EMPCOD is not null then
            open r for
                select EMPCOD, SOLCOD
                from   REBUTJATS
                where  EMPCOD = nvl(p_EMPCOD, EMPCOD);
        else
            open r for
                select EMPCOD, SOLCOD
                from   REBUTJATS
                where  (cons.SOLCOD is null or SOLCOD = cons.SOLCOD);
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_REBUTJATS(p_empcod: ' || nvl(p_EMPCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_REBUTJATS ;

    Procedure Consultar_REBUTJATS ( t in out REBUTJATS_tab, p_EMPCOD in number default null, cons in REBUTJATS_typ ) is
        cursor c is
            select EMPCOD, SOLCOD
            from   REBUTJATS
            where  EMPCOD = nvl(p_EMPCOD, EMPCOD);
        cursor c2 is
            select EMPCOD, SOLCOD
            from   REBUTJATS
            where  (cons.SOLCOD is null or SOLCOD = cons.SOLCOD);
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_EMPCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).EMPCOD :=  i.EMPCOD;
                t(l_count).SOLCOD :=  i.SOLCOD;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_REBUTJATS(i.empcod: ' || i.EMPCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).EMPCOD :=  i.EMPCOD;
                t(l_count).SOLCOD :=  i.SOLCOD;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_REBUTJATS(i.empcod: ' || i.EMPCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_REBUTJATS;


    Procedure Afegir_REBUTJATS ( r in out REBUTJATS_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;


        if r.EMPCOD is null then r.EMPCOD := GetPK_REBUTJATS; end if;
        insert into REBUTJATS(EMPCOD, SOLCOD)
                      values (r.EMPCOD, r.SOLCOD)
        returning EMPCOD, SOLCOD
             into r.EMPCOD, r.SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_REBUTJATS(r.empcod: ' || r.EMPCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_REBUTJATS(r.empcod: ' || r.EMPCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_REBUTJATS;


    Procedure Afegir_REBUTJATS ( t in out REBUTJATS_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;


        loop
            Afegir_REBUTJATS(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_REBUTJATS - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_REBUTJATS - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_REBUTJATS;


    Procedure Esborrar_REBUTJATS ( p_EMPCOD in REBUTJATS.EMPCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;


        delete
        from   REBUTJATS
        where  EMPCOD = p_EMPCOD;

        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_REBUTJATS(p_empcod: ' || nvl(p_EMPCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_REBUTJATS(p_empcod: ' || nvl(p_EMPCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_REBUTJATS;


    Procedure Esborrar_REBUTJATS ( t in REBUTJATS_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;


        loop
            Esborrar_REBUTJATS(t(l_index).EMPCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_REBUTJATS - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_REBUTJATS - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_REBUTJATS;

    Procedure Modificar_REBUTJATS ( r in out REBUTJATS_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update REBUTJATS
        set    SOLCOD = r.SOLCOD
        where  EMPCOD = r.EMPCOD
        returning EMPCOD, SOLCOD
             into r.EMPCOD, r.SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_REBUTJATS(r.empcod: ' || r.EMPCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_REBUTJATS(r.empcod: ' || r.EMPCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_REBUTJATS;

    Procedure Modificar_REBUTJATS ( t in out REBUTJATS_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_REBUTJATS(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_REBUTJATS - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_REBUTJATS - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_REBUTJATS;

    /* Interfcie PL/SQL per a la Taula SOLICITANT*/
    Function GetPK_SOLICITANT return number is
        cursor c is
            select SOLICITANT_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_SOLICITANT;

    Procedure Consultar_SOLICITANT ( r in out SOLICITANT_ref, p_SOLCOD in number default null, cons in SOLICITANT_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_SOLCOD is not null then
            open r for
                select SOLCOD, SOLNOM, SOLNIF, SOLDOM, SOLTEL, SOLCOR, SWBAIXA
                from   SOLICITANT
                where  SOLCOD = nvl(p_SOLCOD, SOLCOD) and
                       SWBAIXA <> 1;
        else
            open r for
                select SOLCOD, SOLNOM, SOLNIF, SOLDOM, SOLTEL, SOLCOR, SWBAIXA
                from   SOLICITANT
                where  (cons.SOLNOM is null or SOLNOM like trim(cons.SOLNOM) || '%') and
                       (cons.SOLNIF is null or SOLNIF like trim(cons.SOLNIF) || '%') and
                       (cons.SOLDOM is null or SOLDOM like trim(cons.SOLDOM) || '%') and
                       (cons.SOLTEL is null or SOLTEL like trim(cons.SOLTEL) || '%') and
                       (cons.SOLCOR is null or SOLCOR like trim(cons.SOLCOR) || '%') and
                       SWBAIXA <> 1;
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_SOLICITANT(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_SOLICITANT ;

    Procedure Consultar_SOLICITANT ( t in out SOLICITANT_tab, p_SOLCOD in number default null, cons in SOLICITANT_typ ) is
        cursor c is
            select SOLCOD, SOLNOM, SOLNIF, SOLDOM, SOLTEL, SOLCOR, SWBAIXA
            from   SOLICITANT
            where  SOLCOD = nvl(p_SOLCOD, SOLCOD) and
                   SWBAIXA <> 1;
        cursor c2 is
            select SOLCOD, SOLNOM, SOLNIF, SOLDOM, SOLTEL, SOLCOR, SWBAIXA
            from   SOLICITANT
            where  (cons.SOLNOM is null or SOLNOM like trim(cons.SOLNOM) || '%') and
                   (cons.SOLNIF is null or SOLNIF like trim(cons.SOLNIF) || '%') and
                   (cons.SOLDOM is null or SOLDOM like trim(cons.SOLDOM) || '%') and
                   (cons.SOLTEL is null or SOLTEL like trim(cons.SOLTEL) || '%') and
                   (cons.SOLCOR is null or SOLCOR like trim(cons.SOLCOR) || '%') and
                   SWBAIXA <> 1;
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_SOLCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).SOLCOD  :=  i.SOLCOD;
                t(l_count).SOLNOM  :=  i.SOLNOM;
                t(l_count).SOLNIF  :=  i.SOLNIF;
                t(l_count).SOLDOM  :=  i.SOLDOM;
                t(l_count).SOLTEL  :=  i.SOLTEL;
                t(l_count).SOLCOR  :=  i.SOLCOR;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_SOLICITANT(i.solcod: ' || i.SOLCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).SOLCOD  :=  i.SOLCOD;
                t(l_count).SOLNOM  :=  i.SOLNOM;
                t(l_count).SOLNIF  :=  i.SOLNIF;
                t(l_count).SOLDOM  :=  i.SOLDOM;
                t(l_count).SOLTEL  :=  i.SOLTEL;
                t(l_count).SOLCOR  :=  i.SOLCOR;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_SOLICITANT(i.solcod: ' || i.SOLCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_SOLICITANT;

    Procedure Afegir_SOLICITANT ( r in out SOLICITANT_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.SOLCOD is null then r.SOLCOD := GetPK_SOLICITANT; end if;
        if r.SWBAIXA is null then r.SWBAIXA := 0; end if;
        insert into SOLICITANT(SOLCOD, SOLNOM, SOLNIF, SOLDOM, SOLTEL, SOLCOR, SWBAIXA)
                       values (r.SOLCOD, r.SOLNOM, r.SOLNIF, r.SOLDOM, r.SOLTEL, r.SOLCOR, r.SWBAIXA)
        returning SOLCOD, SOLNOM, SOLNIF, SOLDOM, SOLTEL, SOLCOR, SWBAIXA
             into r.SOLCOD, r.SOLNOM, r.SOLNIF, r.SOLDOM, r.SOLTEL, r.SOLCOR, r.SWBAIXA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_SOLICITANT(r.solcod: ' || r.SOLCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_SOLICITANT(r.solcod: ' || r.SOLCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_SOLICITANT;

    Procedure Afegir_SOLICITANT ( t in out SOLICITANT_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_SOLICITANT(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_SOLICITANT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_SOLICITANT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_SOLICITANT;

    Procedure Esborrar_SOLICITANT ( p_SOLCOD in SOLICITANT.SOLCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update SOLICITANT
        set    SWBAIXA = 1
        where  SOLCOD = p_SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_SOLICITANT(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_SOLICITANT(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_SOLICITANT;

    Procedure Esborrar_SOLICITANT ( t in SOLICITANT_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_SOLICITANT(t(l_index).SOLCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_SOLICITANT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_SOLICITANT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_SOLICITANT;

    Procedure Modificar_SOLICITANT ( r in out SOLICITANT_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update SOLICITANT
        set    SOLNOM  = r.SOLNOM,
               SOLNIF  = r.SOLNIF,
               SOLDOM  = r.SOLDOM,
               SOLTEL  = r.SOLTEL,
               SOLCOR  = r.SOLCOR,
               SWBAIXA = r.SWBAIXA
        where  SOLCOD = r.SOLCOD
        returning SOLCOD, SOLNOM, SOLNIF, SOLDOM, SOLTEL, SOLCOR, SWBAIXA
             into r.SOLCOD, r.SOLNOM, r.SOLNIF, r.SOLDOM, r.SOLTEL, r.SOLCOR, r.SWBAIXA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_SOLICITANT(r.solcod: ' || r.SOLCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_SOLICITANT(r.solcod: ' || r.SOLCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_SOLICITANT;

    Procedure Modificar_SOLICITANT ( t in out SOLICITANT_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_SOLICITANT(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_SOLICITANT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_SOLICITANT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_SOLICITANT;

    /* Interfcie PL/SQL per a la Taula SUBCATEGORIA*/
    Function GetPK_SUBCATEGORIA return number is
        cursor c is
            select SUBCATEGORIA_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_SUBCATEGORIA;

    Procedure Consultar_SUBCATEGORIA ( r in out SUBCATEGORIA_ref, p_SCATCOD in number default null, cons in SUBCATEGORIA_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_SCATCOD is not null then
            open r for
                select SCATCOD, CATCOD, SCATDESC, SWBAIXA
                from   SUBCATEGORIA
                where  SCATCOD = nvl(p_SCATCOD, SCATCOD) and
                       SWBAIXA <> 1;
        else
            open r for
                select SCATCOD, CATCOD, SCATDESC, SWBAIXA
                from   SUBCATEGORIA
                where  (cons.CATCOD is null or   CATCOD = cons.CATCOD) and
                       (cons.SCATDESC is null or SCATDESC like trim(cons.SCATDESC) || '%') and
                       SWBAIXA <> 1;
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_SUBCATEGORIA(p_scatcod: ' || nvl(p_SCATCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_SUBCATEGORIA ;

    Procedure Consultar_SUBCATEGORIA ( t in out SUBCATEGORIA_tab, p_SCATCOD in number default null, cons in SUBCATEGORIA_typ ) is
        cursor c is
            select SCATCOD, CATCOD, SCATDESC
            from   SUBCATEGORIA
            where  SCATCOD = nvl(p_SCATCOD, SCATCOD);
        cursor c2 is
            select SCATCOD, CATCOD, SCATDESC
            from   SUBCATEGORIA
            where  (cons.CATCOD is null or   CATCOD = cons.CATCOD) and
                   (cons.SCATDESC is null or SCATDESC like trim(cons.SCATDESC) || '%');
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_SCATCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).SCATCOD  :=  i.SCATCOD;
                t(l_count).CATCOD   :=  i.CATCOD;
                t(l_count).SCATDESC :=  i.SCATDESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_SUBCATEGORIA(i.scatcod: ' || i.SCATCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).SCATCOD  :=  i.SCATCOD;
                t(l_count).CATCOD   :=  i.CATCOD;
                t(l_count).SCATDESC :=  i.SCATDESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_SUBCATEGORIA(i.scatcod: ' || i.SCATCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_SUBCATEGORIA;

    Procedure Afegir_SUBCATEGORIA ( r in out SUBCATEGORIA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.SCATCOD is null then r.SCATCOD := GetPK_SUBCATEGORIA; end if;
        insert into SUBCATEGORIA(SCATCOD, CATCOD, SCATDESC)
                         values (r.SCATCOD, r.CATCOD, r.SCATDESC)
        returning SCATCOD, CATCOD, SCATDESC
             into r.SCATCOD, r.CATCOD, r.SCATDESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_SUBCATEGORIA(r.scatcod: ' || r.SCATCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_SUBCATEGORIA(r.scatcod: ' || r.SCATCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_SUBCATEGORIA;

    Procedure Afegir_SUBCATEGORIA ( t in out SUBCATEGORIA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_SUBCATEGORIA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_SUBCATEGORIA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_SUBCATEGORIA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_SUBCATEGORIA;

    Procedure Esborrar_SUBCATEGORIA ( p_SCATCOD in SUBCATEGORIA.SCATCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update SUBCATEGORIA
        set    SWBAIXA = 1
        where  SCATCOD = p_SCATCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_SUBCATEGORIA(p_scatcod: ' || nvl(p_SCATCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_SUBCATEGORIA(p_scatcod: ' || nvl(p_SCATCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_SUBCATEGORIA;

    Procedure Esborrar_SUBCATEGORIA ( t in SUBCATEGORIA_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_SUBCATEGORIA(t(l_index).SCATCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_SUBCATEGORIA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_SUBCATEGORIA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_SUBCATEGORIA;

    Procedure Modificar_SUBCATEGORIA ( r in out SUBCATEGORIA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update SUBCATEGORIA
        set    CATCOD   = r.CATCOD,
               SCATDESC = r.SCATDESC,
               SWBAIXA  = r.SWBAIXA
        where  SCATCOD = r.SCATCOD
        returning SCATCOD, CATCOD, SCATDESC, SWBAIXA
             into r.SCATCOD, r.CATCOD, r.SCATDESC, r.SWBAIXA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_SUBCATEGORIA(r.scatcod: ' || r.SCATCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_SUBCATEGORIA(r.scatcod: ' || r.SCATCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_SUBCATEGORIA;

    Procedure Modificar_SUBCATEGORIA ( t in out SUBCATEGORIA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_SUBCATEGORIA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_SUBCATEGORIA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_SUBCATEGORIA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_SUBCATEGORIA;

    /* Interfcie PL/SQL per a la Taula TIPUSCONTRACTE*/
    Function GetPK_TIPUSCONTRACTE return number is
        cursor c is
            select TIPUSCONTRACTE_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_TIPUSCONTRACTE;

    Procedure Consultar_TIPUSCONTRACTE ( r in out TIPUSCONTRACTE_ref, p_CTECOD in number default null, cons in TIPUSCONTRACTE_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_CTECOD is not null then
            open r for
                select CTECOD, CTEDESC, SWBAIXA
                from   TIPUSCONTRACTE
                where  CTECOD = nvl(p_CTECOD, CTECOD) and
                       SWBAIXA <> 1;
        else
            open r for
                select CTECOD, CTEDESC, SWBAIXA
                from   TIPUSCONTRACTE
                where  (cons.CTEDESC is null or CTEDESC like trim(cons.CTEDESC) || '%') and
                       SWBAIXA <> 1;
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_TIPUSCONTRACTE(p_ctecod: ' || nvl(p_CTECOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_TIPUSCONTRACTE ;

    Procedure Consultar_TIPUSCONTRACTE ( t in out TIPUSCONTRACTE_tab, p_CTECOD in number default null, cons in TIPUSCONTRACTE_typ ) is
        cursor c is
            select CTECOD, CTEDESC, SWBAIXA
            from   TIPUSCONTRACTE
            where  CTECOD = nvl(p_CTECOD, CTECOD) and
                   SWBAIXA <> 1;
        cursor c2 is
            select CTECOD, CTEDESC, SWBAIXA
            from   TIPUSCONTRACTE
            where  (cons.CTEDESC is null or CTEDESC like trim(cons.CTEDESC) || '%') and
                   SWBAIXA <> 1;
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_CTECOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).CTECOD  :=  i.CTECOD;
                t(l_count).CTEDESC :=  i.CTEDESC;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_TIPUSCONTRACTE(i.ctecod: ' || i.CTECOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).CTECOD  :=  i.CTECOD;
                t(l_count).CTEDESC :=  i.CTEDESC;
                t(l_count).SWBAIXA :=  i.SWBAIXA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_TIPUSCONTRACTE(i.ctecod: ' || i.CTECOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_TIPUSCONTRACTE;

    Procedure Afegir_TIPUSCONTRACTE ( r in out TIPUSCONTRACTE_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.CTECOD is null then r.CTECOD := GetPK_TIPUSCONTRACTE; end if;
        if r.SWBAIXA is null then r.SWBAIXA := 0; end if;
        insert into TIPUSCONTRACTE(CTECOD, CTEDESC, SWBAIXA)
                           values (r.CTECOD, r.CTEDESC, r.SWBAIXA)
        returning CTECOD, CTEDESC, SWBAIXA
             into r.CTECOD, r.CTEDESC, r.SWBAIXA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_TIPUSCONTRACTE(r.ctecod: ' || r.CTECOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_TIPUSCONTRACTE(r.ctecod: ' || r.CTECOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_TIPUSCONTRACTE;

    Procedure Afegir_TIPUSCONTRACTE ( t in out TIPUSCONTRACTE_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_TIPUSCONTRACTE(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_TIPUSCONTRACTE - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_TIPUSCONTRACTE - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_TIPUSCONTRACTE;

    Procedure Esborrar_TIPUSCONTRACTE ( p_CTECOD in TIPUSCONTRACTE.CTECOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update TIPUSCONTRACTE
        set    SWBAIXA = 1
        where  CTECOD = p_CTECOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_TIPUSCONTRACTE(p_ctecod: ' || nvl(p_CTECOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_TIPUSCONTRACTE(p_ctecod: ' || nvl(p_CTECOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_TIPUSCONTRACTE;

    Procedure Esborrar_TIPUSCONTRACTE ( t in TIPUSCONTRACTE_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_TIPUSCONTRACTE(t(l_index).CTECOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_TIPUSCONTRACTE - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_TIPUSCONTRACTE - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_TIPUSCONTRACTE;

    Procedure Modificar_TIPUSCONTRACTE ( r in out TIPUSCONTRACTE_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update TIPUSCONTRACTE
        set    CTEDESC = r.CTEDESC,
               SWBAIXA = r.SWBAIXA
        where  CTECOD = r.CTECOD
        returning CTECOD, CTEDESC, SWBAIXA
             into r.CTECOD, r.CTEDESC, r.SWBAIXA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_TIPUSCONTRACTE(r.ctecod: ' || r.CTECOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_TIPUSCONTRACTE(r.ctecod: ' || r.CTECOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_TIPUSCONTRACTE;

    Procedure Modificar_TIPUSCONTRACTE ( t in out TIPUSCONTRACTE_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_TIPUSCONTRACTE(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_TIPUSCONTRACTE - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_TIPUSCONTRACTE - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_TIPUSCONTRACTE;

    /* Interfcie PL/SQL per a la Taula TIPUSJORNADA*/
    Function GetPK_TIPUSJORNADA return number is
        cursor c is
            select TIPUSJORNADA_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_TIPUSJORNADA;

    Procedure Consultar_TIPUSJORNADA ( r in out TIPUSJORNADA_ref, p_TJOCOD in number default null, cons in TIPUSJORNADA_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_TJOCOD is not null then
            open r for
                select TJOCOD, TJODESC
                from   TIPUSJORNADA
                where  TJOCOD = nvl(p_TJOCOD, TJOCOD);
        else
            open r for
                select TJOCOD, TJODESC
                from   TIPUSJORNADA
                where  (cons.TJODESC is null or TJODESC like trim(cons.TJODESC) || '%');
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_TIPUSJORNADA(p_tjocod: ' || nvl(p_TJOCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_TIPUSJORNADA ;

    Procedure Consultar_TIPUSJORNADA ( t in out TIPUSJORNADA_tab, p_TJOCOD in number default null, cons in TIPUSJORNADA_typ ) is
        cursor c is
            select TJOCOD, TJODESC
            from   TIPUSJORNADA
            where  TJOCOD = nvl(p_TJOCOD, TJOCOD);
        cursor c2 is
            select TJOCOD, TJODESC
            from   TIPUSJORNADA
            where  (cons.TJODESC is null or TJODESC like trim(cons.TJODESC) || '%');
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_TJOCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).TJOCOD  :=  i.TJOCOD;
                t(l_count).TJODESC :=  i.TJODESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_TIPUSJORNADA(i.tjocod: ' || i.TJOCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).TJOCOD  :=  i.TJOCOD;
                t(l_count).TJODESC :=  i.TJODESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_TIPUSJORNADA(i.tjocod: ' || i.TJOCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_TIPUSJORNADA;

    Procedure Afegir_TIPUSJORNADA ( r in out TIPUSJORNADA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.TJOCOD is null then r.TJOCOD := GetPK_TIPUSJORNADA; end if;
        insert into TIPUSJORNADA(TJOCOD, TJODESC)
                         values (r.TJOCOD, r.TJODESC)
        returning TJOCOD, TJODESC
             into r.TJOCOD, r.TJODESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_TIPUSJORNADA(r.tjocod: ' || r.TJOCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_TIPUSJORNADA(r.tjocod: ' || r.TJOCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_TIPUSJORNADA;

    Procedure Afegir_TIPUSJORNADA ( t in out TIPUSJORNADA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_TIPUSJORNADA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_TIPUSJORNADA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_TIPUSJORNADA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_TIPUSJORNADA;

    Procedure Esborrar_TIPUSJORNADA ( p_TJOCOD in TIPUSJORNADA.TJOCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   TIPUSJORNADA
        where  TJOCOD = p_TJOCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_TIPUSJORNADA(p_tjocod: ' || p_TJOCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_TIPUSJORNADA(p_tjocod: ' || p_TJOCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_TIPUSJORNADA;

    Procedure Esborrar_TIPUSJORNADA ( t in TIPUSJORNADA_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_TIPUSJORNADA(t(l_index).TJOCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_TIPUSJORNADA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_TIPUSJORNADA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_TIPUSJORNADA;

    Procedure Modificar_TIPUSJORNADA ( r in out TIPUSJORNADA_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update TIPUSJORNADA
        set    TJODESC = r.TJODESC
        where  TJOCOD = r.TJOCOD
        returning TJOCOD, TJODESC
             into r.TJOCOD, r.TJODESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_TIPUSJORNADA(r.tjocod: ' || r.TJOCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_TIPUSJORNADA(r.tjocod: ' || r.TJOCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_TIPUSJORNADA;

    Procedure Modificar_TIPUSJORNADA ( t in out TIPUSJORNADA_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_TIPUSJORNADA(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_TIPUSJORNADA - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_TIPUSJORNADA - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_TIPUSJORNADA;

    /* Interfcie PL/SQL per a la Taula TITULACIO*/
    Function GetPK_TITULACIO return number is
        cursor c is
            select TITULACIO_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_TITULACIO;

    Procedure Consultar_TITULACIO ( r in out TITULACIO_ref, p_TITCOD in number default null, cons in TITULACIO_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_TITCOD is not null then
            open r for
                select TITCOD, NIVCOD, TITDESC
                from   TITULACIO
                where  TITCOD = nvl(p_TITCOD, TITCOD);
        else
            open r for
                select TITCOD, NIVCOD, TITDESC
                from   TITULACIO
                where  (cons.NIVCOD is null or  NIVCOD = cons.NIVCOD) and
                       (cons.TITDESC is null or TITDESC like trim(cons.TITDESC) || '%');
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_TITULACIO(p_titcod: ' || nvl(p_TITCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_TITULACIO ;

    Procedure Consultar_TITULACIO ( t in out TITULACIO_tab, p_TITCOD in number default null, cons in TITULACIO_typ ) is
        cursor c is
            select TITCOD, NIVCOD, TITDESC
            from   TITULACIO
            where  TITCOD = nvl(p_TITCOD, TITCOD);
        cursor c2 is
            select TITCOD, NIVCOD, TITDESC
            from   TITULACIO
            where  (cons.NIVCOD is null or  NIVCOD = cons.NIVCOD) and
                   (cons.TITDESC is null or TITDESC like trim(cons.TITDESC) || '%');
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_TITCOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).TITCOD  :=  i.TITCOD;
                t(l_count).NIVCOD  :=  i.NIVCOD;
                t(l_count).TITDESC :=  i.TITDESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_TITULACIO(i.titcod: ' || i.TITCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).TITCOD  :=  i.TITCOD;
                t(l_count).NIVCOD  :=  i.NIVCOD;
                t(l_count).TITDESC :=  i.TITDESC;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_TITULACIO(i.titcod: ' || i.TITCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_TITULACIO;

    Procedure Afegir_TITULACIO ( r in out TITULACIO_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.TITCOD is null then r.TITCOD := GetPK_TITULACIO; end if;
        insert into TITULACIO(TITCOD, NIVCOD, TITDESC)
                      values (r.TITCOD, r.NIVCOD, r.TITDESC)
        returning TITCOD, NIVCOD, TITDESC
             into r.TITCOD, r.NIVCOD, r.TITDESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_TITULACIO(r.titcod: ' || r.TITCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_TITULACIO(r.titcod: ' || r.TITCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_TITULACIO;

    Procedure Afegir_TITULACIO ( t in out TITULACIO_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_TITULACIO(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_TITULACIO - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_TITULACIO - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_TITULACIO;

    Procedure Esborrar_TITULACIO ( p_TITCOD in TITULACIO.TITCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   TITULACIO
        where  TITCOD = p_TITCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_TITULACIO(p_titcod: ' || nvl(p_TITCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_TITULACIO(p_titcod: ' || nvl(p_TITCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_TITULACIO;

    Procedure Esborrar_TITULACIO ( t in TITULACIO_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_TITULACIO(t(l_index).TITCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_TITULACIO - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_TITULACIO - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_TITULACIO;

    Procedure Modificar_TITULACIO ( r in out TITULACIO_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update TITULACIO
        set    NIVCOD  = r.NIVCOD,
               TITDESC = r.TITDESC
        where  TITCOD = r.TITCOD
        returning TITCOD, NIVCOD, TITDESC
             into r.TITCOD, r.NIVCOD, r.TITDESC;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_TITULACIO(r.titcod: ' || r.TITCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_TITULACIO(r.titcod: ' || r.TITCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_TITULACIO;

    Procedure Modificar_TITULACIO ( t in out TITULACIO_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_TITULACIO(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_TITULACIO - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_TITULACIO - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_TITULACIO;

    /* Interfcie PL/SQL per a la Taula TITULACIOCV*/
    Function GetPK_TITULACIOCV return number is
        cursor c is
            select TITULACIOCV_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_TITULACIOCV;

    Procedure Consultar_TITULACIOCV ( r in out TITULACIOCV_ref, p_SOLCOD in number default null, cons in TITULACIOCV_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_SOLCOD is not null then
            open r for
                select SOLCOD, TITCOD, ANYTIT, ESCOLA
                from   TITULACIOCV
                where  SOLCOD = nvl(p_SOLCOD, SOLCOD);
        else
            open r for
                select SOLCOD, TITCOD, ANYTIT, ESCOLA
                from   TITULACIOCV
                where  (cons.TITCOD is null or TITCOD = cons.TITCOD) and
                       (cons.ANYTIT is null or ANYTIT = cons.ANYTIT) and
                       (cons.ESCOLA is null or ESCOLA like trim(cons.ESCOLA) || '%');
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_TITULACIOCV(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_TITULACIOCV ;

    Procedure Consultar_TITULACIOCV ( t in out TITULACIOCV_tab, p_SOLCOD in number default null, cons in TITULACIOCV_typ ) is
        cursor c is
            select SOLCOD, TITCOD, ANYTIT, ESCOLA
            from   TITULACIOCV
            where  SOLCOD = nvl(p_SOLCOD, SOLCOD);
        cursor c2 is
            select SOLCOD, TITCOD, ANYTIT, ESCOLA
            from   TITULACIOCV
            where  (cons.TITCOD is null or TITCOD = cons.TITCOD) and
                   (cons.ANYTIT is null or ANYTIT = cons.ANYTIT) and
                   (cons.ESCOLA is null or ESCOLA like trim(cons.ESCOLA) || '%');
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin
        if p_SOLCOD is not null then
            for i in c loop
                 select systimestamp into l.LOGINICI from dual;
                t(l_count).SOLCOD :=  i.SOLCOD;
                t(l_count).TITCOD :=  i.TITCOD;
                t(l_count).ANYTIT :=  i.ANYTIT;
                t(l_count).ESCOLA :=  i.ESCOLA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_TITULACIOCV(i.solcod: ' || i.SOLCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                 select systimestamp into l.LOGINICI from dual;
                t(l_count).SOLCOD :=  i.SOLCOD;
                t(l_count).TITCOD :=  i.TITCOD;
                t(l_count).ANYTIT :=  i.ANYTIT;
                t(l_count).ESCOLA :=  i.ESCOLA;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_TITULACIOCV(i.solcod: ' || i.SOLCOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_TITULACIOCV;

    Procedure Afegir_TITULACIOCV ( r in out TITULACIOCV_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.SOLCOD is null then r.SOLCOD := GetPK_TITULACIOCV; end if;
        insert into TITULACIOCV(SOLCOD, TITCOD, ANYTIT, ESCOLA)
                        values (r.SOLCOD, r.TITCOD, r.ANYTIT, r.ESCOLA)
        returning SOLCOD, TITCOD, ANYTIT, ESCOLA
             into r.SOLCOD, r.TITCOD, r.ANYTIT, r.ESCOLA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_TITULACIOCV(r.solcod: ' || r.SOLCOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_TITULACIOCV(r.solcod: ' || r.SOLCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_TITULACIOCV;

    Procedure Afegir_TITULACIOCV ( t in out TITULACIOCV_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_TITULACIOCV(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_TITULACIOCV - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_TITULACIOCV - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_TITULACIOCV;

    Procedure Esborrar_TITULACIOCV ( p_SOLCOD in TITULACIOCV.SOLCOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   TITULACIOCV
        where  SOLCOD = p_SOLCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_TITULACIOCV(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_TITULACIOCV(p_solcod: ' || nvl(p_SOLCOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_TITULACIOCV;

    Procedure Esborrar_TITULACIOCV ( t in TITULACIOCV_tab, p_commit in boolean, e out xerror_typ ) is
         l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_TITULACIOCV(t(l_index).SOLCOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_TITULACIOCV - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_TITULACIOCV - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_TITULACIOCV;

    Procedure Modificar_TITULACIOCV ( r in out TITULACIOCV_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update TITULACIOCV
        set    ANYTIT = r.ANYTIT,
               ESCOLA = r.ESCOLA
        where  SOLCOD = r.SOLCOD and TITCOD = r.TITCOD
        returning SOLCOD, TITCOD, ANYTIT, ESCOLA
             into r.SOLCOD, r.TITCOD, r.ANYTIT, r.ESCOLA;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_TITULACIOCV(r.solcod: ' || r.SOLCOD  || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_TITULACIOCV(r.solcod: ' || r.SOLCOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_TITULACIOCV;

    Procedure Modificar_TITULACIOCV ( t in out TITULACIOCV_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_TITULACIOCV(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'MOdificar_TITULACIOCV - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_TITULACIOCV - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_TITULACIOCV;

    /* Interfcie PL/SQL per a la Taula TITULACIOOT*/
    Function GetPK_TITULACIOOT return number is
        cursor c is
            select TITULACIOOT_seq.nextval
            from   sys.dual;
        pk number;
    begin
        open c;
        fetch c into pk;
        close c;
        return pk;
        exception
            when others then
                return null;
    end GetPK_TITULACIOOT;

    Procedure Consultar_TITULACIOOT ( r in out TITULACIOOT_ref, p_OFECOD in number default null, cons in TITULACIOOT_typ ) is
        l ESPLOG_typ;
        e xerror_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if p_OFECOD is not null then
            open r for
                select OFECOD, TITCOD
                from   TITULACIOOT
                where  OFECOD = nvl(p_OFECOD, OFECOD);
        else
            open r for
                select OFECOD, TITCOD
                from   TITULACIOOT
                where  (cons.TITCOD is null or TITCOD = cons.TITCOD);
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Consultar_TITULACIOOT(p_ofecod: ' || nvl(p_OFECOD, 0) || ')';
        l.LOGRESULT  := ' ';
        Afegir_ESPLOG(l, true, e);
    end Consultar_TITULACIOOT ;

    Procedure Consultar_TITULACIOOT ( t in out TITULACIOOT_tab, p_OFECOD in number default null, cons in TITULACIOOT_typ ) is
        cursor c is
            select OFECOD, TITCOD
            from   TITULACIOOT
            where  OFECOD = nvl(p_OFECOD, OFECOD);
        cursor c2 is
            select OFECOD, TITCOD
            from   TITULACIOOT
            where  (cons.TITCOD is null or TITCOD = cons.TITCOD);
        l_count number := 0;
        l ESPLOG_typ;
        e xerror_typ;
    begin

        if p_OFECOD is not null then
            for i in c loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).OFECOD :=  i.OFECOD;
                t(l_count).TITCOD :=  i.TITCOD;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_TITULACIOOT(i.ofecod: ' || i.OFECOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        else
            for i in c2 loop
                select systimestamp into l.LOGINICI from dual;
                t(l_count).OFECOD :=  i.OFECOD;
                t(l_count).TITCOD :=  i.TITCOD;
                l_count := l_count + 1;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Consultar_TITULACIOOT(i.ofecod: ' || i.OFECOD || ')';
                l.LOGRESULT  := ' ';
                Afegir_ESPLOG(l, true, e);
            end loop;
        end if;
    end Consultar_TITULACIOOT;

    Procedure Afegir_TITULACIOOT ( r in out TITULACIOOT_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        if r.OFECOD is null then r.OFECOD := GetPK_TITULACIOOT; end if;
        insert into TITULACIOOT(OFECOD, TITCOD)
                        values (r.OFECOD, r.TITCOD)
        returning OFECOD, TITCOD
             into r.OFECOD, r.TITCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_TITULACIOOT(r.ofecod: ' || r.OFECOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_TITULACIOOT(r.ofecod: ' || r.OFECOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_TITULACIOOT;

    Procedure Afegir_TITULACIOOT ( t in out TITULACIOOT_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Afegir_TITULACIOOT(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Afegir_TITULACIOOT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Afegir_TITULACIOOT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Afegir_TITULACIOOT;

    Procedure Esborrar_TITULACIOOT ( p_OFECOD in TITULACIOOT.OFECOD%type, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        delete
        from   TITULACIOOT
        where  OFECOD = p_OFECOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_TITULACIOOT(p_ofecod: ' || nvl(p_OFECOD, 0) || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_TITULACIOOT(p_ofecod: ' || nvl(p_OFECOD, 0) || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_TITULACIOOT;

    Procedure Esborrar_TITULACIOOT ( t in TITULACIOOT_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Esborrar_TITULACIOOT(t(l_index).OFECOD, p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Esborrar_TITULACIOOT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Esborrar_TITULACIOOT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Esborrar_TITULACIOOT;

    Procedure Modificar_TITULACIOOT ( r in out TITULACIOOT_typ, p_commit in boolean, e out xerror_typ ) is
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        update TITULACIOOT
        set    TITCOD = r.TITCOD
        where  OFECOD = r.OFECOD
        returning OFECOD, TITCOD
             into r.OFECOD, r.TITCOD;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'MOdificar_TITULACIOOT(r.ofecod: ' || r.OFECOD || ')';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'MOdificar_TITULACIOOT(r.ofecod: ' || r.OFECOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_TITULACIOOT;

    Procedure Modificar_TITULACIOOT ( t in out TITULACIOOT_tab, p_commit in boolean, e out xerror_typ ) is
        l_index number := t.first;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        loop
            Modificar_TITULACIOOT(t(l_index), p_commit, e);
            exit when l_index = t.last;
            l_index := t.next(l_index);
        end loop;
        if p_commit then commit; end if;
        e.status := SUCCESS;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'Modificar_TITULACIOOT - taula';
        l.LOGRESULT  := trim(rpad(e.status, 255));
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'Modificar_TITULACIOOT - taula';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end Modificar_TITULACIOOT;

    /* Altres procediments*/
    Procedure ConcertarEntrevista(ofe in OFERTATREBALL_typ, dat in ENTREVISTA.ENTDATA%type,
                                  p_commit in boolean, e out xerror_typ) is
        convocats CURRICULUM_tab;
        etp ENTREVISTA_typ;
        ctp CONVOCATS_typ;
        ctp_null CONVOCATS_typ;
        l_count NUMBER;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        SeleccionarCandidats(ofe, convocats);
        if convocats.Count() > 0 then
            etp.OFECOD  := ofe.OFECOD;
            etp.ENTDATA := dat;
            Afegir_ENTREVISTA (etp, p_commit, e);
            for i in 0..(convocats.count()-1) loop
                ctp := ctp_null;
                ctp.ENTCOD := etp.ENTCOD;
                ctp.SOLCOD := convocats(i).SOLCOD;
                Afegir_CONVOCATS (ctp, p_commit, e);
            end loop;
            if p_commit then commit; end if;
            e.status := SUCCESS;
            l.LOGRESULT    := trim(rpad(e.status, 255));
        else
            e.status  := WARNING;
            e.message := 'NO S''HAN TROBAT CANDIDATS PER A L''OFERTA ' || ofe.OFECOD;
            l.LOGRESULT     := trim(rpad(e.status || ' - ' || e.message, 255));
        end if;

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'ConcertarEntrevista(ofe.ofecod: ' || ofe.OFECOD || ')';
        Afegir_ESPLOG(l, p_commit, e);
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;

                select systimestamp into l.LOGFINAL from dual;
                l.USRCOD  := 'PFC';
                l.LOGACCIO := 'ConcertarEntrevista(ofe.ofecod: ' || ofe.OFECOD || ')';
                l.LOGRESULT  := trim(rpad(e.status || ' - ' || e.message, 255));
                Afegir_ESPLOG(l, p_commit, e);
                RAISE;
    end ConcertarEntrevista;

    Procedure SeleccionarCandidats(ofe in OFERTATREBALL_typ, con in out CURRICULUM_tab) is
        cursor c is
            select SOL.SOLCOD
            from   SOLICITANT SOL, EXPERIENCIACV ECV
            where  SOL.SOLCOD = ECV.SOLCOD and
                   ECV.SCATCOD = ofe.SCATCOD and
                   (0 = (select count(*) from IDIOMESOT where OFECOD = ofe.OFECOD) or
                    SOL.SOLCOD in(select SOLCOD
                                  from IDIOMESCV
                                  where IDIOCOD in(select IDIOCOD
                                                   from IDIOMESOT
                                                   where OFECOD = ofe.OFECOD)
                                )
                   ) and
                   (0 = (select count(*) from TITULACIOOT where OFECOD = ofe.OFECOD) or
                    SOL.SOLCOD in(select SOLCOD
                                  from TITULACIOCV
                                  where TITCOD in(select TITCOD
                                                  from TITULACIOOT
                                                  where OFECOD = ofe.OFECOD)
                                )
                   ) and
                   SOL.SOLCOD not in(select SOLCOD from REBUTJATS where EMPCOD = ofe.EMPCOD) and
                   SOL.SWBAIXA <> 1;
        l_count number;
    begin
        l_count := 0;
        for i in c loop
            con(l_count).SOLCOD := i.SOLCOD;
            l_count := l_count + 1;
        end loop;
    end SeleccionarCandidats;

    Procedure SeleccionarCandidat(ofe in out OFERTATREBALL_typ, p_SOLCOD in SOLICITANT.SOLCOD%type, d date, p_commit in boolean, e out xerror_typ) is
        oref OFERTATREBALL_ref;
        otyp OFERTATREBALL_typ;
        l ESPLOG_typ;
    begin
        select systimestamp into l.LOGINICI from dual;

        Esborrar_SOLICITANT(p_SOLCOD, p_commit, e);
        Consultar_OFERTATREBALL(oref, ofe.OFECOD, null);
        fetch oref into otyp;
        otyp.OFEFI := d; --to_date(to_char(d),'dd/mm/yyyy');
        Modificar_OFERTATREBALL(otyp, p_commit, e);

        select systimestamp into l.LOGFINAL from dual;
        l.USRCOD  := 'PFC';
        l.LOGACCIO := 'SeleccionarCandidat(ofe.ofecod: ' || ofe.OFECOD || ', p_solcod: ' || p_SOLCOD || ')';
        l.LOGRESULT  := e.status;
        if trim(e.message) <> '' then
            l.LOGRESULT := l.LOGRESULT || ' - ' || trim(e.message);
        end if;
        Afegir_ESPLOG(l, p_commit, e);
    end SeleccionarCandidat;

    Procedure ExtraccioDades(p_commit in boolean, e out xerror_typ) is
        cursor c is
            select distinct to_char(OFEFI, 'YYYYMM') anymes
            from OFERTATREBALL
            where OFEFI is not null;
    begin
        for i in c loop
            ExtraccioDades(substr(i.anymes,1,4), substr(i.anymes,5,2), p_commit, e);
        end loop;
    end ExtraccioDades;

    Procedure ExtraccioDades(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type, p_commit in boolean, e out xerror_typ) is
    begin
        FusionaPerfil(p_commit, e);
        FusionaSubcategoria(p_commit, e);
        FusionaTemps(p_any, p_mes, p_commit, e);
        FusionaTipusContracte(p_commit, e);
        FusionaTipusJornada(p_commit, e);

        merge into DWOFERTESTREBALL d using
                (select to_char(p_any) || trim(to_char(p_mes, '09')) IDTEMPS,
                        PERFCOD, SCATCOD, CTECOD, TJOCOD,
                        sum(OFEFI - OFEINI) DIESCOBERTURA,
                        sum(case when (OFEFI - OFEINI) >= OFEDIES then 0
                            else 1
                            end) OFERTESENTEMPS,
                        count(*) OFERTESCOBERTES,
                        sum(case when (SOUMIN = 0) then SOUMAX
                            else SOUMIN + ((SOUMAX - SOUMIN) / 2)
                            end) SALARI
                 from OFERTATREBALL
                 where to_char(OFEFI, 'YYYYMM') = to_char(p_any) || trim(to_char(p_mes, '09')) and
                       SWBAIXA <> 1
                 group by to_char(OFEFI, 'YYYYMM'), PERFCOD, SCATCOD, CTECOD, TJOCOD) p
              on (d.IDTEMPS = p.IDTEMPS)
              when matched then
                  update set d.PERFCOD         = p.PERFCOD,
                             d.SCATCOD         = p.SCATCOD,
                             d.CTECOD          = p.CTECOD,
                             d.TJOCOD          = p.TJOCOD,
                             d.DIESCOBERTURA   = p.DIESCOBERTURA,
                             d.OFERTESENTEMPS  = p.OFERTESENTEMPS,
                             d.OFERTESCOBERTES = p.OFERTESCOBERTES,
                             d.SALARI = p.SALARI
              when not matched then
                  insert (d.IDTEMPS, d.PERFCOD, d.SCATCOD, d.CTECOD, d.TJOCOD, d.DIESCOBERTURA,
                          d.OFERTESENTEMPS, d.OFERTESCOBERTES, d.SALARI)
                  values (p.IDTEMPS, p.PERFCOD, p.SCATCOD, p.CTECOD, p.TJOCOD, p.DIESCOBERTURA,
                          p.OFERTESENTEMPS, p.OFERTESCOBERTES, p.SALARI);
        if p_commit then commit; end if;
        e.status := SUCCESS;
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;
                RAISE;
    end ExtraccioDades;

    Procedure FusionaPerfil(p_commit in boolean, e out xerror_typ) is
    begin
        merge into DWPERFIL d using (select distinct f.PERFCOD, f.PERFDESC
                                     from PERFIL f, OFERTATREBALL o
                                     where f.PERFCOD = o.PERFCOD and
                                           o.SWBAIXA <> 1
                                     order by 1) p
              on (d.PERFCOD = p.PERFCOD)
              when matched then
                  update set d.PERFDESC = p.PERFDESC
              when not matched then
                  insert (d.PERFCOD, d.PERFDESC)
                  values (p.PERFCOD, p.PERFDESC);
        if p_commit then commit; end if;
        e.status := SUCCESS;
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;
                RAISE;
    end FusionaPerfil;

    Procedure FusionaSubcategoria(p_commit in boolean, e out xerror_typ) is
    begin
        merge into DWSUBCATEGORIA d using (select distinct s.SCATCOD, c.CATDESC, s.SCATDESC
                                           from SUBCATEGORIA s, CATEGORIA c, OFERTATREBALL o
                                           where s.CATCOD  = c.CATCOD and
                                                 s.SCATCOD = o.SCATCOD and
                                                 o.SWBAIXA <> 1
                                           order by 1) p
              on (d.SCATCOD = p.SCATCOD)
              when matched then
                  update set d.CATDESC  = p.CATDESC,
                             d.SCATDESC = p.SCATDESC
              when not matched then
                  insert (d.SCATCOD, d.CATDESC, d.SCATDESC)
                  values (p.SCATCOD, p.CATDESC, p.SCATDESC);
        if p_commit then commit; end if;
        e.status := SUCCESS;
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;
                RAISE;
    end FusionaSubcategoria;

    Procedure FusionaTemps(p_any in DWTEMPS.NANY%type, p_mes in DWTEMPS.MES%type, p_commit in boolean, e out xerror_typ) is
    begin
        merge into DWTEMPS d using (select to_number(to_char(p_any) || trim(to_char(p_mes, '09'))) IDTEMPS,
                                           p_any NANY, p_mes MES
                                    from dual) p
              on (d.IDTEMPS = p.IDTEMPS)
              when matched then
                  update set d.NANY = p.NANY,
                             d.MES  = p.MES
              when not matched then
                  insert (d.IDTEMPS, d.NANY, d.MES)
                  values (p.IDTEMPS, p.NANY, p.MES);
        if p_commit then commit; end if;
        e.status := SUCCESS;
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;
                RAISE;
    end FusionaTemps;

    Procedure FusionaTipusContracte(p_commit in boolean, e out xerror_typ) is
    begin
        merge into DWTIPUSCONTRACTE d using (select distinct c.CTECOD, c.CTEDESC
                                             from TIPUSCONTRACTE c, OFERTATREBALL o
                                             where c.CTECOD = o.CTECOD and
                                                   o.SWBAIXA <> 1
                                             order by 1) p
              on (d.CTECOD = p.CTECOD)
              when matched then
                  update set d.CTEDESC = p.CTEDESC
              when not matched then
                  insert (d.CTECOD, d.CTEDESC)
                  values (p.CTECOD, p.CTEDESC);
        if p_commit then commit; end if;
        e.status := SUCCESS;
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;
                RAISE;
    end FusionaTipusContracte;

    Procedure FusionaTipusJornada(p_commit in boolean, e out xerror_typ) is
    begin
        merge into DWTIPUSJORNADA d using (select distinct j.TJOCOD, j.TJODESC
                                           from TIPUSJORNADA j, OFERTATREBALL o
                                           where j.TJOCOD = o.TJOCOD and
                                                 o.SWBAIXA <> 1
                                           order by 1) p
              on (d.TJOCOD = p.TJOCOD)
              when matched then
                  update set d.TJODESC = p.TJODESC
              when not matched then
                  insert (d.TJOCOD, d.TJODESC)
                  values (p.TJOCOD, p.TJODESC);
        if p_commit then commit; end if;
        e.status := SUCCESS;
        exception
            when others then
                e.status  := ERROR;
                e.message := sqlerrm;
                RAISE;
    end FusionaTipusJornada;

end BASIC_PKG;
/
